/**
 * MOTECH PLATFORM OPENSOURCE LICENSE AGREEMENT
 *
 * Copyright (c) 2010-11 The Trustees of Columbia University in the City of
 * New York and Grameen Foundation USA.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. Neither the name of Grameen Foundation USA, Columbia University, or
 * their respective contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY GRAMEEN FOUNDATION USA, COLUMBIA UNIVERSITY
 * AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GRAMEEN FOUNDATION
 * USA, COLUMBIA UNIVERSITY OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.motechproject.mobile.core.model;

import org.motechproject.mobile.core.util.MotechIDGenerator;

import java.util.Date;

/**
 * Date: Dec 03, 2009
 * @author Joseph Djomeda (joseph@dreamoval.com)
 */
public class IncomingMessageFormParameterDefinitionImpl implements IncomingMessageFormParameterDefinition {

    private Long id;
    private IncomingMessageFormDefinition IncomingMsgFormDefinition;
    private String name;
    private boolean required;
    private String paramType;
    private int length;
    private Date dateCreated;
    private Date lastModified;

    public IncomingMessageFormParameterDefinitionImpl() {
        this.id = MotechIDGenerator.generateID();
    }
    private int version = -1;
    /*
     * @return the version
     */

    public int getVersion() {
        return version;
    }

    /*
     * @param version the version to set
     */
    public void setVersion(int version) {
        this.version = version;
    }
    /*
     * @return the IncomingMsgFormDefinition
     */

    public IncomingMessageFormDefinition getIncomingMsgFormDefinition() {
        return IncomingMsgFormDefinition;
    }

    /*
     * @param IncomingMsgFormDefinition the IncomingMsgFormDefinition to set
     */
    public void setIncomingMsgFormDefinition(IncomingMessageFormDefinition IncomingMsgFormDefinition) {
        this.IncomingMsgFormDefinition = IncomingMsgFormDefinition;
    }

    /*
     * @return the name
     */
    public String getName() {
        return name;
    }

    /*
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /*
     * @return the required
     */
    public boolean isRequired() {
        return required;
    }

    /*
     * @param required the required to set
     */
    public void setRequired(boolean required) {
        this.required = required;
    }

    /*
     * @return the paramType
     */
    public String getParamType() {
        return paramType;
    }

    /*
     * @param paramType the paramType to set
     */
    public void setParamType(String paramType) {
        this.paramType = paramType;
    }

    /*
     * @return the length
     */
    public int getLength() {
        return length;
    }

    /*
     * @param length the length to set
     */
    public void setLength(int length) {
        this.length = length;
    }

    /*
     * @return the dateCreated
     */
    public Date getDateCreated() {
        return dateCreated;
    }

    /*
     * @param dateCreated the dateCreated to set
     */
    public void setDateCreated(Date dateCreated) {
        this.dateCreated = dateCreated;
    }

    /*
     * @return the lastModified
     */
    public Date getLastModified() {
        return lastModified;
    }

    /*
     * @param lastModified the lastModified to set
     */
    public void setLastModified(Date lastModified) {
        this.lastModified = lastModified;
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        String newLine = System.getProperty("line.separator");

        if (this != null) {
            sb.append((this.getId() != null) ? "key=Id value=" + this.getId().toString() : "Id is null ");
            sb.append(newLine);
            sb.append((this.name != null) ? "key=name value=" + this.name : "name is null  ");
            sb.append(newLine);
            sb.append("key=required value=" + this.required);
            sb.append(newLine);
            sb.append((this.paramType != null) ? "key=paramType value=" + this.paramType : "paramType is null ");
            sb.append(newLine);
            sb.append((this.IncomingMsgFormDefinition != null) ? "key=IncomingMessageFormDefinition.Id value=" + this.IncomingMsgFormDefinition.getId() : "gatewayRequestDetails.Id is null ");
            sb.append(newLine);
            sb.append((this.length != -1) ? "key=length value=" + this.length : "length is null ");
            sb.append(newLine);

            sb.append((this.dateCreated != null) ? "key=dateCreate value=" + this.dateCreated.toString() : "dateCreated is null ");
            sb.append(newLine);
            sb.append((this.lastModified != null) ? "key=lastModified value=" + this.lastModified.toString() : "lastModified is null ");
            sb.append(newLine);

            return sb.toString();

        } else {
            return "Object is null";
        }


    }

    /*
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /*
     * @param id the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }
}
