--
-- MOTECH PLATFORM OPENSOURCE LICENSE AGREEMENT
--
-- Copyright (c) 2010-11 The Trustees of Columbia University in the City of
-- New York and Grameen Foundation USA.  All rights reserved.
--
-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions are met:
--
-- 1. Redistributions of source code must retain the above copyright notice,
-- this list of conditions and the following disclaimer.
--
-- 2. Redistributions in binary form must reproduce the above copyright notice,
-- this list of conditions and the following disclaimer in the documentation
-- and/or other materials provided with the distribution.
--
-- 3. Neither the name of Grameen Foundation USA, Columbia University, or
-- their respective contributors may be used to endorse or promote products
-- derived from this software without specific prior written permission.
--
-- THIS SOFTWARE IS PROVIDED BY GRAMEEN FOUNDATION USA, COLUMBIA UNIVERSITY
-- AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
-- BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
-- FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GRAMEEN FOUNDATION
-- USA, COLUMBIA UNIVERSITY OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
-- INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-- LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
-- OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
-- EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--

-- MySQL dump 10.13  Distrib 5.1.39, for Win32 (ia32)
--
-- Host: localhost    Database: motechmobiledb
-- ------------------------------------------------------
-- Server version	5.1.39-community

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

CREATE DATABASE IF NOT EXISTS `motechmobiledb`;

GRANT ALL ON motechmobiledb.* TO 'motechmobile'@'localhost' IDENTIFIED BY 'mmobilepass';

USE `motechmobiledb`;

/*Table structure for table `gateway_request` */

DROP TABLE IF EXISTS `gateway_request`;

CREATE TABLE `gateway_request` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `request_details_id` bigint(20) DEFAULT NULL,
  `message_request_id` bigint(20) DEFAULT NULL,
  `recipients_number` varchar(255) DEFAULT NULL,
  `date_sent` datetime DEFAULT NULL,
  `date_from` datetime DEFAULT NULL,
  `date_to` datetime DEFAULT NULL,
  `try_number` int(11) DEFAULT NULL,
  `message` text,
  `request_id` varchar(255) DEFAULT NULL,
  `message_status` varchar(255) DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `FK81205B94A5644C7B` (`request_details_id`),
  KEY `FK81205B94A5644C7A` (`message_request_id`),
  CONSTRAINT `FK81205B94A5644C7B` FOREIGN KEY (`request_details_id`) REFERENCES `gateway_request_details` (`id`),
  CONSTRAINT `FK81205B94A5644C7A` FOREIGN KEY (`message_request_id`) REFERENCES `message_request` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Table structure for table `gateway_request_details` */

DROP TABLE IF EXISTS `gateway_request_details`;

CREATE TABLE `gateway_request_details` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `message_type` varchar(255) DEFAULT NULL,
  `message` text,
  `number_of_pages` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Table structure for table `gateway_response` */

DROP TABLE IF EXISTS `gateway_response`;

CREATE TABLE `gateway_response` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `gateway_message_id` varchar(255) DEFAULT NULL,
  `request_id` varchar(255) DEFAULT NULL,
  `recipient_number` varchar(255) DEFAULT NULL,
  `message_status` varchar(255) DEFAULT NULL,
  `response_text` text,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `message_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FKA612CBDCDD47F282` (`message_id`),
  CONSTRAINT `FKA612CBDCDD47F282` FOREIGN KEY (`message_id`) REFERENCES `gateway_request` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Table structure for table `incoming_message` */

DROP TABLE IF EXISTS `incoming_message`;

CREATE TABLE `incoming_message` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `incoming_message_session_id` bigint(20) DEFAULT NULL,
  `incoming_message_form_id` bigint(20) DEFAULT NULL,
  `incoming_message_response_id` bigint(20) DEFAULT NULL,
  `message_content` text,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `message_status` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `incoming_message_response_id` (`incoming_message_response_id`),
  KEY `FKA1B318EE97D3332E` (`incoming_message_session_id`),
  KEY `FKA1B318EE51E8D466` (`incoming_message_response_id`),
  KEY `FKA1B318EEA9AD8E06` (`incoming_message_form_id`),
  CONSTRAINT `FKA1B318EEA9AD8E06` FOREIGN KEY (`incoming_message_form_id`) REFERENCES `incoming_message_form` (`id`),
  CONSTRAINT `FKA1B318EE51E8D466` FOREIGN KEY (`incoming_message_response_id`) REFERENCES `incoming_message_response` (`id`),
  CONSTRAINT `FKA1B318EE97D3332E` FOREIGN KEY (`incoming_message_session_id`) REFERENCES `incoming_message_session` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `incoming_message` */

/*Table structure for table `incoming_message_form` */

DROP TABLE IF EXISTS `incoming_message_form`;

CREATE TABLE `incoming_message_form` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `incoming_message_form_definition_id` bigint(20) DEFAULT NULL,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `message_form_status` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK60811752DCCF2D1` (`incoming_message_form_definition_id`),
  CONSTRAINT `FK60811752DCCF2D1` FOREIGN KEY (`incoming_message_form_definition_id`) REFERENCES `incoming_message_form_definition` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `incoming_message_form` */

/*Table structure for table `incoming_message_form_definition` */

DROP TABLE IF EXISTS `incoming_message_form_definition`;

CREATE TABLE `incoming_message_form_definition` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `form_code` varchar(100) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `duplicatable` varchar(255) DEFAULT NULL,
  `send_response` bit(1) DEFAULT 0,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `form_code` (`form_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `incoming_message_form_definition` */

/*Data Entry SMS Forms*/
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (254657657567688,0,'RegisterChild','ENCOUNTER','DISALLOWED','2010-01-08 14:40:15','2010-01-08 15:22:53',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (597658468478768,0,'PregnancyStop','ENCOUNTER','DISALLOWED','2010-01-08 14:19:05','2010-01-08 15:22:53',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (678565673457657,0,'EditPatient','ENCOUNTER','TIME_BOUND','2010-01-08 14:41:23','2010-01-08 15:22:53',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785688106549491,0,'GeneralOPD','ENCOUNTER','TIME_BOUND','2009-12-18 11:04:20','2010-01-08 15:22:53',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640001,0,'ANC','ENCOUNTER','TIME_BOUND','2010-02-03 09:02:20','2010-02-03 09:02:20',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640002,0,'Abortion','ENCOUNTER','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640093,0,'Delivery','ENCOUNTER','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640094,0,'PPC','ENCOUNTER','TIME_BOUND','2010-02-03 09:07:04','2010-02-03 09:07:04',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640095,0,'Death','ENCOUNTER','DISALLOWED','2010-02-03 09:07:04','2010-02-03 09:07:4',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640096,0,'Child','ENCOUNTER','TIME_BOUND','2010-02-03 09:10:23','2010-02-03 09:10:23',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640097,0,'ChildOPD','ENCOUNTER','TIME_BOUND','2010-02-03 09:10:25','2010-02-03 09:10:25',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640098,0,'MotherOPD','ENCOUNTER','TIME_BOUND','2010-02-03 09:10:20','2010-02-03 09:10:20',false);

/*Data Entry Java Forms */
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000000,0,'ANC-jf','JFORM','TIME_BOUND','2010-02-03 09:02:20','2010-02-03 09:02:20',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000001,0,'Abortion-jf','JFORM','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000002,0,'Delivery-jf','JFORM','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000004,0,'DeliveryNotify-jf','JFORM','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000005,0,'MotherPNC-jf','JFORM','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000006,0,'Death-jf','JFORM','DISALLOWED','2010-02-03 09:07:04','2010-02-03 09:07:4',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000007,0,'TT-jf','JFORM','TIME_BOUND','2010-02-03 09:07:04','2010-02-03 09:07:4',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000008,0,'ChildPNC-jf','JFORM','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000009,0,'ChildCWC-jf','JFORM','TIME_BOUND','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000010,0,'RegisterPatient-jf','JFORM','DISALLOWED','2010-02-03 09:04:02','2010-02-03 09:04:02',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000011,0,'RegisterPregnancy-jf','JFORM','DISALLOWED','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000012,0,'RegisterANCMother-jf','JFORM','DISALLOWED','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000013,0,'RegisterCWCChild-jf','JFORM','DISALLOWED','2010-02-03 09:04:02','2010-02-03 09:04:02',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000014,0,'EditPatient-jf','JFORM','TIME_BOUND','2010-01-08 14:41:23','2010-01-08 15:22:53',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000015,0,'GeneralOPD-jf','JFORM','TIME_BOUND','2009-12-18 11:04:20','2010-01-08 15:22:53',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000016,0,'ChildOPD-jf','JFORM','TIME_BOUND','2010-02-03 09:10:25','2010-02-03 09:10:25',false);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (200000000000017,0,'MotherOPD-jf','JFORM','TIME_BOUND','2010-02-03 09:10:20','2010-02-03 09:10:20',false);

/*Data Query Forms*/
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640100,0,'ANCDefault','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640101,0,'TTDefault','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640102,0,'PPCDefault','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640103,0,'PNCDefault','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640104,0,'CWCDefault','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640105,0,'UpcomingDeliveries','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640106,0,'RecentDeliveries','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640107,0,'OverdueDeliveries','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640108,0,'UpcomingCare','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640109,0,'ViewPatient','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (785739375640110,0,'FindMoTeCHID','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);

/*Data Query Forms Java Forms*/
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (095739375640100,0,'ANCDefault-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (985739375640101,0,'TTDefault-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
-- Rename PPC to ChildPNC
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (875739375640102,0,'PPCDefault-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
-- Rename PNC to MotherPNC
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (765739375640103,0,'PNCDefault-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (655739375640104,0,'CWCDefault-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (545739375640105,0,'UpcomingDeliveries-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (435739375640106,0,'RecentDeliveries-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (325739375640107,0,'OverdueDeliveries-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (215739375640108,0,'UpcomingCare-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (105739375640109,0,'ViewPatient-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);
insert into `incoming_message_form_definition` (`id`,`obj_vesion`,`form_code`,`type`,`duplicatable`,`date_created`,`last_modified`,`send_response`) values (005739375640110,0,'FindMoTeCHID-jf','QUERY','ALLOWED','2010-02-15 18:33:20','2010-02-15 18:33:20',true);

/*Table structure for table `incoming_message_form_parameter` */

DROP TABLE IF EXISTS `incoming_message_form_parameter`;

CREATE TABLE `incoming_message_form_parameter` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `incoming_message_from_message_definition_id` bigint(20) DEFAULT NULL,
  `incoming_message_form_id` bigint(20) DEFAULT NULL,
  `name` varchar(100) DEFAULT NULL,
  `value` varchar(100) DEFAULT NULL,
  `err_code` int(11) DEFAULT NULL,
  `err_text` varchar(200) DEFAULT NULL,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `message_form_status` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK742C315F96177926` (`incoming_message_from_message_definition_id`),
  KEY `FK742C315FA9AD8E06` (`incoming_message_form_id`),
  CONSTRAINT `FK742C315FA9AD8E06` FOREIGN KEY (`incoming_message_form_id`) REFERENCES `incoming_message_form` (`id`),
  CONSTRAINT `FK742C315F96177926` FOREIGN KEY (`incoming_message_from_message_definition_id`) REFERENCES `incoming_message_form_parameter_definition` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `incoming_message_form_parameter` */

/*Table structure for table `incoming_message_form_parameter_definition` */

DROP TABLE IF EXISTS `incoming_message_form_parameter_definition`;

CREATE TABLE `incoming_message_form_parameter_definition` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `incoming_message_form_definition_id` bigint(20) DEFAULT NULL,
  `name` varchar(50) DEFAULT NULL,
  `parameter_type` varchar(50) DEFAULT NULL,
  `length` int(11) DEFAULT NULL,
  `required` bit(1) DEFAULT NULL,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `FK584F18332DCCF2D1` (`incoming_message_form_definition_id`),
  CONSTRAINT `FK584F18332DCCF2D1` FOREIGN KEY (`incoming_message_form_definition_id`) REFERENCES `incoming_message_form_definition` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `incoming_message_form_parameter_definition` */

/*Params for RegisterChild*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (3245464634645,0,254657657567688,'chpsId','ALPHANUM',50,true,'2010-01-08 14:54:14','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (53475686867887,0,254657657567688,'motherMotechId','ALPHANUM',50,true,'2010-01-08 14:54:14','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (64348767787689,0,254657657567688,'dob','DATE',50,true,'2010-01-08 14:54:14','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (7645645756876,0,254657657567688,'childMotechId','ALPHANUM',50,true,'2010-01-08 14:54:14','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (92366865767568,0,254657657567688,'firstName','ALPHANUM',50,false,'2010-01-08 14:54:14','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (12353635757884,0,254657657567688,'sex','GENDER',50,true,'2010-01-08 14:54:14','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (24575686567567,0,254657657567688,'nhisExpiration','EXPIRYDATE',10,false,'2010-01-08 14:54:14','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (42783631278378,0,254657657567688,'nhisNo','ALPHANUM',50,false,'2010-01-08 14:54:14','2010-01-08 15:22:53');

/*Params for PregnancyStop*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (4564564645577,0,597658468478768,'chpsId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (876875676546456,0,597658468478768,'patientRegNum','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');

/*Params for Delivery Notification Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000401,0,200000000000004,'staffId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000402,0,200000000000004,'facilityId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000403,0,200000000000004,'datetime','DATETIME',30,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000404,0,200000000000004,'motechId','ALPHANUM',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Mother PNC Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000501,0,200000000000005,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000502,0,200000000000005,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000503,0,200000000000005,'date','DATETIME',30,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000504,0,200000000000005,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000505,0,200000000000005,'visitNumber','NUMERIC',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000506,0,200000000000005,'location','PNCLOCATION',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000507,0,200000000000005,'house','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000508,0,200000000000005,'community','ALPHANUM',30,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000509,0,200000000000005,'referred','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000510,0,200000000000005,'maleInvolved','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000511,0,200000000000005,'vitaminA','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000512,0,200000000000005,'ttDose','TTDOSE',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000513,0,200000000000005,'lochiaColour','LOCHIACOLOUR',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000514,0,200000000000005,'lochiaAmountExcess','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000515,0,200000000000005,'temperature','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000516,0,200000000000005,'fht','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000517,0,200000000000005,'comments','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Child PNC Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000801,0,200000000000008,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000802,0,200000000000008,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000803,0,200000000000008,'date','DATETIME',30,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000804,0,200000000000008,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000805,0,200000000000008,'visitNumber','NUMERIC',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000806,0,200000000000008,'location','PNCLOCATION',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000807,0,200000000000008,'house','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000808,0,200000000000008,'community','ALPHANUM',30,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000809,0,200000000000008,'referred','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000810,0,200000000000008,'maleInvolved','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000811,0,200000000000008,'weight','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000812,0,200000000000008,'temperature','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000813,0,200000000000008,'bcg','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000814,0,200000000000008,'opv0','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000815,0,200000000000008,'respiration','NUMERIC',5,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000816,0,200000000000008,'cordConditionNormal','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000817,0,200000000000008,'babyConditionGood','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000818,0,200000000000008,'comments','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Child CWC Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000901,0,200000000000009,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000902,0,200000000000009,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000903,0,200000000000009,'date','DATE',10,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000904,0,200000000000009,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000905,0,200000000000009,'cwcLocation','CWCLOCATION',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000906,0,200000000000009,'house','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000907,0,200000000000009,'community','ALPHANUM',30,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000908,0,200000000000009,'bcg','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000909,0,200000000000009,'opvDose','OPVDOSE',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000910,0,200000000000009,'pentaDose','PENTADOSE',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000911,0,200000000000009,'measles','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000912,0,200000000000009,'yellowFever','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000913,0,200000000000009,'csm','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000914,0,200000000000009,'ipti','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000915,0,200000000000009,'vitaminA','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000916,0,200000000000009,'dewormer','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000917,0,200000000000009,'weight','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000918,0,200000000000009,'muac','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000919,0,200000000000009,'height','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000920,0,200000000000009,'maleInvolved','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000921,0,200000000000009,'comments','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Abortion Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000101,0,200000000000001,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000102,0,200000000000001,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000103,0,200000000000001,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000104,0,200000000000001,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000105,0,200000000000001,'terminationType','ALPHANUM',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000106,0,200000000000001,'procedure','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000107,0,200000000000001,'complications','NUMERIC_ARRAY',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000108,0,200000000000001,'maternalDeath','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000109,0,200000000000001,'referred','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000110,0,200000000000001,'postAbortiobFPCounseled','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000111,0,200000000000001,'postAbortionFPAccepted','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000112,0,200000000000001,'comments','ALPHANUM',200,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for GeneralOPD*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (359809010998245,0,785688106549491,'chpsId','ALPHANUM',50,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (409624894059308,0,785688106549491,'Date','DATE',10,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447236646138029,0,785688106549491,'SerialNo','ALPHANUM',50,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (964559790068935,0,785688106549491,'Sex','GENDER',1,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (44780981663901,0,785688106549491,'DoB','DATE',10,true,'2009-12-18 11:04:20','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447617060511587,0,785688106549491,'Insured','BOOLEAN',1,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447617060511588,0,785688106549491,'NewCase','BOOLEAN',1,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447617060511586,0,785688106549491,'Diagnosis','DIAGNOSIS',2,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447617060511481,0,785688106549491,'otherDiagnosis','DIAGNOSIS',2,false,'2010-03-29 11:04:20','2010-03-29 11:04:20');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447617060511589,0,785688106549491,'secondaryDiagnosis','DIAGNOSIS',2,false,'2009-12-18 11:04:20','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (447617060511592,0,785688106549491,'otherSecondaryDiagnosis','DIAGNOSIS',2,false,'2010-03-29 11:04:20','2010-03-29 11:04:20');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (125568987021450,0,785688106549491,'Referral','BOOLEAN',1,true,'2009-12-18 11:04:20','2010-01-08 15:22:54');

/*Params for General OPD Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001501,0,200000000000015,'staffId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001502,0,200000000000015,'facilityId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001503,0,200000000000015,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001504,0,200000000000015,'serialNumber','ALPHANUM',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001505,0,200000000000015,'sex','GENDER',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001506,0,200000000000015,'dateOfBirth','DATE',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001507,0,200000000000015,'insured','BOOLEAN',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001508,0,200000000000015,'diagnosis','DIAGNOSIS',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001509,0,200000000000015,'secondDiagnosis','DIAGNOSIS',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001510,0,200000000000015,'rdtGiven','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001511,0,200000000000015,'rdtPositive','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001512,0,200000000000015,'actTreated','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001513,0,200000000000015,'newCase','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001514,0,200000000000015,'referred','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001515,0,200000000000015,'comments','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Child OPD Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001601,0,200000000000016,'staffId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001602,0,200000000000016,'facilityId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001603,0,200000000000016,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001604,0,200000000000016,'serialNumber','ALPHANUM',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001605,0,200000000000016,'motechId','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001614,0,200000000000016,'insured','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001606,0,200000000000016,'diagnosis','DIAGNOSIS',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001607,0,200000000000016,'secondDiagnosis','DIAGNOSIS',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001608,0,200000000000016,'rdtGiven','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001609,0,200000000000016,'rdtPositive','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001610,0,200000000000016,'actTreated','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001611,0,200000000000016,'newCase','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001612,0,200000000000016,'referred','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001613,0,200000000000016,'comments','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Mother OPD Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001701,0,200000000000017,'staffId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001702,0,200000000000017,'facilityId','ALPHANUM',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001703,0,200000000000017,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001704,0,200000000000017,'serialNumber','ALPHANUM',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001705,0,200000000000017,'motechId','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001714,0,200000000000017,'insured','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001706,0,200000000000017,'diagnosis','DIAGNOSIS',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001707,0,200000000000017,'secondDiagnosis','DIAGNOSIS',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001708,0,200000000000017,'rdtGiven','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001709,0,200000000000017,'rdtPositive','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001710,0,200000000000017,'actTreated','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001711,0,200000000000017,'newCase','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001712,0,200000000000017,'referred','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001713,0,200000000000017,'comments','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for EditPatient*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (7765435645455,0,678565673457657,'chpsId','ALPHANUM',50,true,'2010-01-08 15:02:43','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (15674564545534,0,678565673457657,'patientRegNum','ALPHANUM',50,true,'2010-01-08 15:02:43','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (93786634412380,0,678565673457657,'primaryPhone','NUMERIC',15,false,'2010-01-08 15:02:43','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (535767567677889,0,678565673457657,'primaryPhoneType','PHONETYPE',10,false,'2010-01-08 15:02:43','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (834459078775,0,678565673457657,'secondaryPhoneType','PHONETYPE',10,false,'2010-01-08 15:02:43','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (6378978445645,0,678565673457657,'secondaryPhone','NUMERIC',15,false,'2010-01-08 15:02:43','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (20564578745345,0,678565673457657,'nhisNo','ALPHANUM',50,false,'2010-01-08 15:02:43','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (72345769456456,0,678565673457657,'nhisExpiration','EXPIRYDATE',10,false,'2010-01-08 15:02:43','2010-01-08 15:22:54');

/*Params for ANC*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984500,0,785739375640001,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984501,0,785739375640001,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984502,0,785739375640001,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984503,0,785739375640001,'visitNo','ANCVISIT',4,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984504,0,785739375640001,'TTDose','TTDOSE',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984505,0,785739375640001,'IPTDose','IPTDOSE',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984506,0,785739375640001,'ITN','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (434546463984507,0,785739375640001,'HIVResult','HIVSTATUS',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');

/*Params for ANC java forms*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000001,0,200000000000000,'staffId','NUMERIC',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000002,0,200000000000000,'facilityId','NUMERIC',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000004,0,200000000000000,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000005,0,200000000000000,'motechId','NUMERIC',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000006,0,200000000000000,'visitNumber','ANCVISIT',4,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000007,0,200000000000000,'location','ANCLOCATION',1,true,'2010-04-30 10:29:14','2010-04-30 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000008,0,200000000000000,'house','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000009,0,200000000000000,'community','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000010,0,200000000000000,'estDeliveryDate','DELIVERYDATE',10,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000011,0,200000000000000,'bpSystolic','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000012,0,200000000000000,'bpDiastolic','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000013,0,200000000000000,'weight','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000014,0,200000000000000,'ttDose','TTDOSE',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000015,0,200000000000000,'iptDose','IPTDOSE',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000016,0,200000000000000,'iptReactive','ALPHANUM',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000017,0,200000000000000,'itnUse','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000018,0,200000000000000,'fht','NUMERIC',4,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000019,0,200000000000000,'fhr','NUMERIC',4,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000020,0,200000000000000,'urineTestProteinPositive','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000021,0,200000000000000,'urineTestGlucosePositive','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000022,0,200000000000000,'hemoglobin','NUMERIC',5,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000024,0,200000000000000,'vdrlTreatment','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000023,0,200000000000000,'vdrlReactive','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000003,0,200000000000000,'dewormer','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000025,0,200000000000000,'maleInvolved','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000026,0,200000000000000,'pmtct','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000027,0,200000000000000,'preTestCounseled','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000028,0,200000000000000,'hivTestResult','HIVSTATUS',10,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000029,0,200000000000000,'postTestCounseled','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000030,0,200000000000000,'pmtctTreament','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000031,0,200000000000000,'refered','BOOLEAN',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000032,0,200000000000000,'nextANCDate','EXPIRYDATE',10,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000033,0,200000000000000,'comments','ALPHANUM',200,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Abortion*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (464546463987800,0,785739375640002,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (464546463987801,0,785739375640002,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (464546463987802,0,785739375640002,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (464546463987803,0,785739375640002,'abortionType','ABORTIONTYPE',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (464546463987804,0,785739375640002,'complications','ABORTIONCOMPLICATIONS',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');

/*Params for Delivery*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981200,0,785739375640093,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981201,0,785739375640093,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981202,0,785739375640093,'DoD','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981203,0,785739375640093,'MoD','MOD',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981204,0,785739375640093,'OoD','OOD',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981205,0,785739375640093,'location','DELIVERYLOCATION',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981206,0,785739375640093,'deliveredBy','DELIVERER',4,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981207,0,785739375640093,'MaternalDeath','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981208,0,785739375640093,'cause','MATERNALDEATHCAUSE',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981209,0,785739375640093,'C1BirthOutcome','BIRTHOUTCOME',3,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981210,0,785739375640093,'C1MotechId','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981211,0,785739375640093,'C1Sex','GENDER',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981212,0,785739375640093,'C1Name','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981213,0,785739375640093,'C1OPV','BOOLEAN',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981214,0,785739375640093,'C1BCG','BOOLEAN',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981215,0,785739375640093,'C2BirthOutcome','BIRTHOUTCOME',3,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981216,0,785739375640093,'C2MotechId','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981217,0,785739375640093,'C2Sex','GENDER',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981218,0,785739375640093,'C2Name','ALPHANUM',10,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981219,0,785739375640093,'C2OPV','BOOLEAN',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981220,0,785739375640093,'C2BCG','BOOLEAN',3,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981221,0,785739375640093,'C3BirthOutcome','BIRTHOUTCOME',3,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981222,0,785739375640093,'C3MotechId','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981223,0,785739375640093,'C3Sex','GENDER',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981224,0,785739375640093,'C3Name','ALPHANUM',10,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981225,0,785739375640093,'C3OPV','BOOLEAN',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (473346463981226,0,785739375640093,'C3BCG','BOOLEAN',3,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');

/*Params for Delivery Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000201,0,200000000000002,'staffId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000202,0,200000000000002,'facilityId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000203,0,200000000000002,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000204,0,200000000000002,'date','DATETIME',30,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000205,0,200000000000002,'mode','MOD',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000206,0,200000000000002,'outcome','OOD',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000207,0,200000000000002,'deliveryLocation','DELIVERYLOCATION',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000208,0,200000000000002,'deliveredBy','DELIVERER',4,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000209,0,200000000000002,'maleInvolved','BOOLEAN',1,true,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000210,0,200000000000002,'complications','DELIVERYCOMPLICATIONS_ARRAY',50,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000211,0,200000000000002,'VVF','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000212,0,200000000000002,'MaternalDeath','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000213,0,200000000000002,'comments','ALPHANUM',200,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000215,0,200000000000002,'child1Outcome','BIRTHOUTCOME',3,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000216,0,200000000000002,'child1RegistrationType','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000217,0,200000000000002,'child1MotechId','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000218,0,200000000000002,'child1Sex','GENDER',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000219,0,200000000000002,'child1FirstName','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000220,0,200000000000002,'child1Weight','NUMERIC',4,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000223,0,200000000000002,'child2Outcome','BIRTHOUTCOME',3,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000224,0,200000000000002,'child2RegistrationType','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000225,0,200000000000002,'child2MotechId','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000226,0,200000000000002,'child2Sex','GENDER',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000227,0,200000000000002,'child2FirstName','ALPHANUM',10,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000228,0,200000000000002,'child2Weight','NUMERIC',4,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000231,0,200000000000002,'child3Outcome','BIRTHOUTCOME',3,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000232,0,200000000000002,'child3RegistrationType','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000233,0,200000000000002,'child3MotechId','ALPHANUM',50,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000234,0,200000000000002,'child3Sex','GENDER',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000235,0,200000000000002,'child3FirstName','ALPHANUM',10,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000236,0,200000000000002,'child3Weight','NUMERIC',4,false,'2010-04-30 00:00:00','2010-02-03 00:00:00');

/*Params for PPC*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (254546463981100,0,785739375640094,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (254546463981101,0,785739375640094,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (254546463981102,0,785739375640094,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (254546463981103,0,785739375640094,'visitNo','PPCVISIT',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (254546463981104,0,785739375640094,'vitA','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (254546463981105,0,785739375640094,'TTDose','NUMERIC',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');

/*Params for Death*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (154546463981440,0,785739375640095,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (154546463981441,0,785739375640095,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (154546463981442,0,785739375640095,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
-- insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (154546463981443,0,785739375640095,'cause','DEATHCAUSE',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');

/*Params for Death Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000601,0,200000000000006,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000602,0,200000000000006,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000603,0,200000000000006,'date','DATE',10,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000604,0,200000000000006,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
-- insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000605,0,200000000000006,'cause','NUMERIC',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for TT Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000701,0,200000000000007,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000702,0,200000000000007,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000703,0,200000000000007,'date','DATE',10,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000704,0,200000000000007,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000000705,0,200000000000007,'ttDose','TTDOSE',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Child*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981700,0,785739375640096,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981701,0,785739375640096,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981702,0,785739375640096,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981703,0,785739375640096,'BCG','BOOLEAN',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981704,0,785739375640096,'OPVDOSE','OPVDOSE',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981705,0,785739375640096,'PentaDose','PENTADOSE',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981706,0,785739375640096,'YellowFever','BOOLEAN',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981707,0,785739375640096,'CSM','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981708,0,785739375640096,'IPTi','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981709,0,785739375640096,'VitA','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (064546463981765,0,785739375640096,'Measles','BOOLEAN',1,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');

/*Params for ChildOPD*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983210,0,785739375640097,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983213,0,785739375640097,'serialNo','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983211,0,785739375640097,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983212,0,785739375640097,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983214,0,785739375640097,'newCase','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983215,0,785739375640097,'Diagnosis','DIAGNOSIS',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983216,0,785739375640097,'secondaryDiagnosis','DIAGNOSIS',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983217,0,785739375640097,'referral','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983218,0,785739375640097,'otherDiagnosis','DIAGNOSIS',2,false,'2010-03-29 11:04:20','2010-03-29 11:04:20');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (879874663983219,0,785739375640097,'otherSecondaryDiagnosis','DIAGNOSIS',2,false,'2010-03-29 11:04:20','2010-03-29 11:04:20');

/*Params for MotherOPD*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923330,0,785739375640098,'chpsId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923333,0,785739375640098,'serialNo','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923331,0,785739375640098,'motechId','ALPHANUM',50,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923332,0,785739375640098,'date','DATE',10,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923334,0,785739375640098,'newCase','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923335,0,785739375640098,'Diagnosis','DIAGNOSIS',2,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923336,0,785739375640098,'secondaryDiagnosis','DIAGNOSIS',2,false,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923337,0,785739375640098,'referral','BOOLEAN',1,true,'2010-02-03 10:29:14','2010-02-03 10:29:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923338,0,785739375640098,'otherDiagnosis','DIAGNOSIS',2,false,'2010-03-29 11:04:20','2010-03-29 11:04:20');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923339,0,785739375640098,'otherSecondaryDiagnosis','DIAGNOSIS',2,false,'2010-03-29 11:04:20','2010-03-29 11:04:20');

/*Params for Register Patient Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001001,0,200000000000010,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001002,0,200000000000010,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001003,0,200000000000010,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001004,0,200000000000010,'registrationMode','REGISTRATIONMODE',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001005,0,200000000000010,'motechId','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001006,0,200000000000010,'registrantType','REGISTRANTTYPE',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001007,0,200000000000010,'firstName','ALPHANUM',100,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001008,0,200000000000010,'middleName','ALPHANUM',100,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001009,0,200000000000010,'lastName','ALPHANUM',100,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001010,0,200000000000010,'preferredName','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001011,0,200000000000010,'dateOfBirth','DATE',10,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001012,0,200000000000010,'estimatedBirthDate','BOOLEAN',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001013,0,200000000000010,'sex','GENDER',1,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001014,0,200000000000010,'insured','BOOLEAN',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001015,0,200000000000010,'nhis','ALPHANUM',30,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001016,0,200000000000010,'nhisExpires','EXPIRYDATE',10,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001017,0,200000000000010,'motherMotechId','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001021,0,200000000000010,'community','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001022,0,200000000000010,'address','ALPHANUM',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001038,0,200000000000010,'regPhone','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001023,0,200000000000010,'phoneNumber','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001024,0,200000000000010,'expDeliveryDate','DELIVERYDATE',10,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001025,0,200000000000010,'deliveryDateConfirmed','BOOLEAN',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001028,0,200000000000010,'enroll','BOOLEAN',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001029,0,200000000000010,'consent','BOOLEAN',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001030,0,200000000000010,'ownership','PHONETYPE',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001031,0,200000000000010,'format','FORMAT',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001032,0,200000000000010,'language','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001033,0,200000000000010,'dayOfWeek','DAYOFWEEK',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001034,0,200000000000010,'timeOfDay','TIME',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001035,0,200000000000010,'reason','INTERESTREASON',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001036,0,200000000000010,'howLearned','HOWLEARNED',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001037,0,200000000000010,'messagesStartWeek','NUMERIC',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Register Pregnancy Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001101,0,200000000000011,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001102,0,200000000000011,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001103,0,200000000000011,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001104,0,200000000000011,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001105,0,200000000000011,'estDeliveryDate','DELIVERYDATE',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001106,0,200000000000011,'enroll','BOOLEAN',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001107,0,200000000000011,'consent','BOOLEAN',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001108,0,200000000000011,'ownership','PHONETYPE',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001109,0,200000000000011,'phoneNumber','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001110,0,200000000000011,'format','FORMAT',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001111,0,200000000000011,'language','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001112,0,200000000000011,'dayOfWeek','DAYOFWEEK',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001113,0,200000000000011,'timeOfDay','TIME',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001114,0,200000000000011,'reason','INTERESTREASON',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001115,0,200000000000011,'howLearned','HOWLEARNED',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Register ANC Mother Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001201,0,200000000000012,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001202,0,200000000000012,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001203,0,200000000000012,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001204,0,200000000000012,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001205,0,200000000000012,'ancRegNumber','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001206,0,200000000000012,'estDeliveryDate','DELIVERYDATE',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001207,0,200000000000012,'height','NUMERIC',5,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001208,0,200000000000012,'gravida','NUMERIC',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001209,0,200000000000012,'parity','NUMERIC',2,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001210,0,200000000000012,'enroll','BOOLEAN',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001211,0,200000000000012,'consent','BOOLEAN',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001212,0,200000000000012,'ownership','PHONETYPE',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001213,0,200000000000012,'phoneNumber','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001214,0,200000000000012,'format','FORMAT',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001215,0,200000000000012,'language','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001216,0,200000000000012,'dayOfWeek','DAYOFWEEK',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001217,0,200000000000012,'timeOfDay','TIME',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001218,0,200000000000012,'reason','INTERESTREASON',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001219,0,200000000000012,'howLearned','HOWLEARNED',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Register CWC CHILD Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001301,0,200000000000013,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001302,0,200000000000013,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001303,0,200000000000013,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001304,0,200000000000013,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001305,0,200000000000013,'cwcRegNumber','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001306,0,200000000000013,'enroll','BOOLEAN',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001307,0,200000000000013,'consent','BOOLEAN',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001308,0,200000000000013,'ownership','PHONETYPE',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001309,0,200000000000013,'phoneNumber','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001310,0,200000000000013,'format','FORMAT',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001311,0,200000000000013,'language','ALPHANUM',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001312,0,200000000000013,'dayOfWeek','DAYOFWEEK',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001313,0,200000000000013,'timeOfDay','TIME',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001314,0,200000000000013,'reason','INTERESTREASON',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001315,0,200000000000013,'howLearned','HOWLEARNED',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for Edit Patient Java form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001401,0,200000000000014,'staffId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001402,0,200000000000014,'facilityId','NUMERIC',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:53');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001403,0,200000000000014,'date','DATE',50,true,'2010-01-08 14:46:33','2010-01-08 15:22:54');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001404,0,200000000000014,'motechId','NUMERIC',50,true,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001405,0,200000000000014,'phoneNumber','NUMERIC',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001406,0,200000000000014,'ownership','PHONETYPE',50,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001407,0,200000000000014,'nhis','ALPHANUM',30,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001408,0,200000000000014,'nhisExpires','EXPIRYDATE',10,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (10000000001409,0,200000000000014,'stopEnrollment','BOOLEAN',2,false,'2010-04-30 00:00:00','2010-04-30 00:00:00');

/*Params for ANCDefault*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (595474663924238,0,785739375640100,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (595474663924239,0,785739375640100,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for ANCDefault Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123474663923338,0,095739375640100,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123574663923339,0,095739375640100,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123674663923339,0,095739375640100,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for TTDefault*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923340,0,785739375640101,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923341,0,785739375640101,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for TTDefault Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123774663923340,0,985739375640101,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123874663923341,0,985739375640101,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123974663923341,0,985739375640101,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for PPCDefault*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923342,0,785739375640102,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923343,0,785739375640102,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for ChildPNCDefault Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123074663923342,0,875739375640102,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123174663923343,0,875739375640102,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (123274663923343,0,875739375640102,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for PNCDefault*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923344,0,785739375640103,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923345,0,785739375640103,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for MotherPNCDefault Java Form */
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233004663923344,0,765739375640103,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1231474663923345,0,765739375640103,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1231574663923345,0,765739375640103,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for CWCDefault*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923346,0,785739375640104,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923347,0,785739375640104,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for CWCDefault Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1231674663923346,0,655739375640104,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1231774663923347,0,655739375640104,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1231874663923347,0,655739375640104,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for UpcomingDeliveries*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923348,0,785739375640105,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923349,0,785739375640105,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for UpcomingDeliveries Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1231974663923348,0,545739375640105,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232074663923349,0,545739375640105,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232174663923349,0,545739375640105,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for RecentDeliveries*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923350,0,785739375640106,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923351,0,785739375640106,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for RecentDeliveries Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232274663923350,0,435739375640106,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232374663923351,0,435739375640106,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232474663923351,0,435739375640106,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for OverdueDeliveries*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923352,0,785739375640107,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923353,0,785739375640107,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for OverdueDeliveries Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232574663923352,0,325739375640107,'facilityId','NUMERIC',10,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232674663923353,0,325739375640107,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232774663923353,0,325739375640107,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for UpcomingCare*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923354,0,785739375640108,'motechId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923355,0,785739375640108,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for UpcomingCare Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232874663923354,0,215739375640108,'motechId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1232974663923355,0,215739375640108,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233074663923355,0,215739375640108,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for ViewPatients*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923356,0,785739375640109,'motechId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923357,0,785739375640109,'chpsId','ALPHANUM',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for ViewPatients Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233174663923356,0,105739375640109,'motechId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233274663923357,0,105739375640109,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233374663923357,0,105739375640109,'sender','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for FindMoTeCHID*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923358,0,785739375640110,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923359,0,785739375640110,'firstName','ALPHA',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923360,0,785739375640110,'lastName','ALPHA',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923361,0,785739375640110,'preferredName','ALPHA',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923362,0,785739375640110,'dob','DATE',10,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923363,0,785739375640110,'nhisNo','ALPHANUM',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (695474663923364,0,785739375640110,'phone','NUMERIC',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Params for FindMoTeCHID Java Form*/
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233474663923358,0,005739375640110,'chpsId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233474663923365,0,005739375640110,'facilityId','NUMERIC',50,true,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233574663923359,0,005739375640110,'firstName','ALPHA',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233674663923360,0,005739375640110,'lastName','ALPHA',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233774663923361,0,005739375640110,'preferredName','ALPHA',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233874663923362,0,005739375640110,'dob','DATE',10,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1233974663923363,0,005739375640110,'nhisNo','ALPHANUM',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1234074663923364,0,005739375640110,'phone','NUMERIC',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');
insert into `incoming_message_form_parameter_definition` (`id`,`obj_vesion`,`incoming_message_form_definition_id`,`name`,`parameter_type`,`length`,`required`,`date_created`,`last_modified`) values (1234174663923364,0,005739375640110,'sender','NUMERIC',50,false,'2010-02-15 18:35:14','2010-02-15 18:35:14');

/*Table structure for table `incoming_message_response` */

DROP TABLE IF EXISTS `incoming_message_response`;

CREATE TABLE `incoming_message_response` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `response_content` text,
  `date_created` datetime DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `message_status` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `incoming_message_response` */

/*Table structure for table `incoming_message_session` */

DROP TABLE IF EXISTS `incoming_message_session`;

CREATE TABLE `incoming_message_session` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `requester_phone` varchar(20) DEFAULT NULL,
  `form_code` varchar(100) DEFAULT NULL,
  `date_started` datetime DEFAULT NULL,
  `date_ended` datetime DEFAULT NULL,
  `last_activity` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `message_session_status` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Table structure for table `language` */

DROP TABLE IF EXISTS `language`;

CREATE TABLE `language` (
  `id` bigint(20) NOT NULL,
  `code` varchar(10) DEFAULT NULL,
  `name` varchar(50) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `code` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `language` */

insert into `language` (`id`,`code`,`name`,`description`) values (1,'en','English','english language is the official spoken language in Ghana');
insert into `language` (`id`,`code`,`name`,`description`) values (2,'nan','Nankam','Nankam is the most spoken language in North Ghana');
insert into `language` (`id`,`code`,`name`,`description`) values (3,'kas','Kassim','Kassim the most spoken language');

/*Table structure for table `message_request` */

DROP TABLE IF EXISTS `message_request`;

CREATE TABLE `message_request` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `request_details_id` bigint(20) DEFAULT NULL,
  `request_id` varchar(255) DEFAULT NULL,
  `notification_type_id` bigint(20) DEFAULT NULL,
  `language_id` bigint(20) DEFAULT NULL,
  `message_type` varchar(255) DEFAULT NULL,
  `schedule` date DEFAULT NULL,
  `p113_nData` varchar(255) DEFAULT NULL,
  `recipient_number` varchar(255) DEFAULT NULL,
  `phone_number_type` varchar(255) DEFAULT NULL,
  `recipient_id` varchar(255) DEFAULT NULL,
  `date_from` datetime DEFAULT NULL,
  `date_to` datetime DEFAULT NULL,
  `date_created` datetime DEFAULT NULL,
  `date_processed` datetime DEFAULT NULL,
  `status` varchar(255) DEFAULT NULL,
  `max_try_number` int(11) DEFAULT NULL,
  `days_attempted` int(11) DEFAULT NULL,
  `last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `FKF9A8A257C247835` (`notification_type_id`),
  KEY `FKF9A8A25716C79BE` (`language_id`),
  KEY `FK81205B94A5644C7C` (`request_details_id`),
  CONSTRAINT `FKF9A8A25716C79BE` FOREIGN KEY (`language_id`) REFERENCES `language` (`id`),
  CONSTRAINT `FKF9A8A257C247835` FOREIGN KEY (`notification_type_id`) REFERENCES `notification_type` (`id`),
  CONSTRAINT `FK81205B94A5644C7C` FOREIGN KEY (`request_details_id`) REFERENCES `gateway_request_details` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Table structure for table `message_template` */

DROP TABLE IF EXISTS `message_template`;

CREATE TABLE `message_template` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `date_created` datetime DEFAULT NULL,
  `message_type` varchar(255) DEFAULT NULL,
  `template` text,
  `notification_type` bigint(20) DEFAULT NULL,
  `language` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK41715B2D5781D57` (`notification_type`),
  KEY `FK41715B2E7550DB4` (`language`),
  CONSTRAINT `FK41715B2E7550DB4` FOREIGN KEY (`language`) REFERENCES `language` (`id`),
  CONSTRAINT `FK41715B2D5781D57` FOREIGN KEY (`notification_type`) REFERENCES `notification_type` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `message_template` */

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (1,0,'2009-10-06 00:00:00','TEXT','Tetanus is a disorder that leads to severe and painful muscle spasms. It is caused by a bacterium that is commonly found in soil, dust and animal waste.',2,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (100,0,'2009-10-06 00:00:00','TEXT','Tetanus is a disorder that leads to severe and painful muscle spasms. It is caused by a bacterium that is commonly found in soil, dust and animal waste.@@',2,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (101,0,'2009-10-06 00:00:00','TEXT','Tetanus is a disorder that leads to severe and painful muscle spasms. It is caused by a bacterium that is commonly found in soil, dust and animal waste.##',2,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (2,0,'2009-10-06 00:00:00','TEXT','Immunization against tetanus is recommended especially in pregnant women. Vaccination of pregnant women is the best preventive measure against neonatal tetanus.',3,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (102,0,'2009-10-06 00:00:00','TEXT','Immunization against tetanus is recommended especially in pregnant women. Vaccination of pregnant women is the best preventive measure against neonatal tetanus.@@',3,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (103,0,'2009-10-06 00:00:00','TEXT','Immunization against tetanus is recommended especially in pregnant women. Vaccination of pregnant women is the best preventive measure against neonatal tetanus.##',3,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (3,0,'2009-10-06 00:00:00','TEXT','You are due for your first tetanus vaccination in your pregnancy.  Please go to your nearest clinic to receive your vaccination.',4,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (104,0,'2009-10-06 00:00:00','TEXT','You are due for your first tetanus vaccination in your pregnancy.  Please go to your nearest clinic to receive your vaccination.@@',4,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (105,0,'2009-10-06 00:00:00','TEXT','You are due for your first tetanus vaccination in your pregnancy.  Please go to your nearest clinic to receive your vaccination.##',4,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (4,0,'2009-10-06 00:00:00','TEXT','All wounds should be considered risky, so always be cleaned with soap and water.  Some wounds, however small, such as from thorns of roses or lemon, are highly risky and perhaps even more than other large open wounds.',5,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (106,0,'2009-10-06 00:00:00','TEXT','All wounds should be considered risky, so always be cleaned with soap and water.  Some wounds, however small, such as from thorns of roses or lemon, are highly risky and perhaps even more than other large open wounds.@@',5,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (107,0,'2009-10-06 00:00:00','TEXT','All wounds should be considered risky, so always be cleaned with soap and water.  Some wounds, however small, such as from thorns of roses or lemon, are highly risky and perhaps even more than other large open wounds.##',5,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (5,0,'2009-10-06 00:00:00','TEXT','Tetanus in newborns is severe, with high mortality rate. It usually occurs by contamination of the umbilical cord at delivery or in the first days of life. Furthermore, this disease often aggravated by complications, including infectious, which are the triggers of death.',6,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (108,0,'2009-10-06 00:00:00','TEXT','Tetanus in newborns is severe, with high mortality rate. It usually occurs by contamination of the umbilical cord at delivery or in the first days of life. Furthermore, this disease often aggravated by complications, including infectious, which are the triggers of death.@@',6,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (109,0,'2009-10-06 00:00:00','TEXT','Tetanus in newborns is severe, with high mortality rate. It usually occurs by contamination of the umbilical cord at delivery or in the first days of life. Furthermore, this disease often aggravated by complications, including infectious, which are the triggers of death.##',6,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (6,0,'2009-10-06 00:00:00','TEXT','You have missed your first tetanus vaccination.  Please go to your nearest clinic to receive your vaccination.',7,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (110,0,'2009-10-06 00:00:00','TEXT','You have missed your first tetanus vaccination.  Please go to your nearest clinic to receive your vaccination.@@',7,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (111,0,'2009-10-06 00:00:00','TEXT','You have missed your first tetanus vaccination.  Please go to your nearest clinic to receive your vaccination.##',7,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (7,0,'2009-10-06 00:00:00','TEXT','This is your second reminder for missing your first tetanus vaccination.  Please go to your nearest clinic.',8,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (112,0,'2009-10-06 00:00:00','TEXT','This is your second reminder for missing your first tetanus vaccination.  Please go to your nearest clinic.@@',8,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (113,0,'2009-10-06 00:00:00','TEXT','This is your second reminder for missing your first tetanus vaccination.  Please go to your nearest clinic.##',8,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (8,0,'2009-10-06 00:00:00','TEXT','You are due for your second tetanus vaccination in your pregnancy.  Please go to your nearest clinic to receive your vaccination.',9,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (114,0,'2009-10-06 00:00:00','TEXT','You are due for your second tetanus vaccination in your pregnancy.  Please go to your nearest clinic to receive your vaccination.@@',9,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (115,0,'2009-10-06 00:00:00','TEXT','You are due for your second tetanus vaccination in your pregnancy.  Please go to your nearest clinic to receive your vaccination.##',9,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (9,0,'2009-10-06 00:00:00','TEXT','You have missed your second tetanus vaccination.  Please go to your nearest clinic to receive your vaccination.',10,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (116,0,'2009-10-06 00:00:00','TEXT','You have missed your second tetanus vaccination.  Please go to your nearest clinic to receive your vaccination.@@',10,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (117,0,'2009-10-06 00:00:00','TEXT','You have missed your second tetanus vaccination.  Please go to your nearest clinic to receive your vaccination.##',10,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (10,0,'2009-10-06 00:00:00','TEXT','This is your second reminder for missing your second tetanus vaccination.  Please go to your nearest clinic.',11,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (118,0,'2009-10-06 00:00:00','TEXT','This is your second reminder for missing your second tetanus vaccination.  Please go to your nearest clinic.@@',11,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (119,0,'2009-10-06 00:00:00','TEXT','This is your second reminder for missing your second tetanus vaccination.  Please go to your nearest clinic.##',11,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (11,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 1.  Your estimated due date is <DueDate>.',14,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (121,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 1.  Your estimated due date is <DueDate>.@@',14,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (122,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 1.  Your estimated due date is <DueDate>.##',14,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (12,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 2.  Your estimated due date is <DueDate>.',15,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (123,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 2.  Your estimated due date is <DueDate>.',15,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (124,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 2.  Your estimated due date is <DueDate>.',15,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (13,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 3.  Your estimated due date is <DueDate>.',16,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (125,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 3.  Your estimated due date is <DueDate>.@@',16,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (126,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 3.  Your estimated due date is <DueDate>.##',16,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (14,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 4.  Your estimated due date is <DueDate>.',17,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (127,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 4.  Your estimated due date is <DueDate>.@@',17,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (128,0,'2009-10-06 00:00:00','TEXT','Hello <PatientFirstName>.  This is your message for week 4.  Your estimated due date is <DueDate>.##',17,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (15,0,'2009-10-06 00:00:00','TEXT','If U are pregnant&feel like hiding it for now,its normal.But remember the evil eye does not bring problems in pregnancy,most problems are because of things that can be treated if U go to clinic early.If U miss a period or think U are pregnant go to clinic NOW!Dont fear-midwives want to make sure U stay healthy&have a healthy baby.They will keep your secret.U get National Health Insurance free for 1year when pregnant so register now.*From Mobile Midwife*.',18,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (129,0,'2009-10-06 00:00:00','TEXT','If U are pregnant&feel like hiding it for now,its normal.But remember the evil eye does not bring problems in pregnancy,most problems are because of things that can be treated if U go to clinic early.If U miss a period or think U are pregnant go to clinic NOW!Dont fear-midwives want to make sure U stay healthy&have a healthy baby.They will keep your secret.U get National Health Insurance free for 1year when pregnant so register now.*From Mobile Midwife*.@@',18,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (130,0,'2009-10-06 00:00:00','TEXT','If U are pregnant&feel like hiding it for now,its normal.But remember the evil eye does not bring problems in pregnancy,most problems are because of things that can be treated if U go to clinic early.If U miss a period or think U are pregnant go to clinic NOW!Dont fear-midwives want to make sure U stay healthy&have a healthy baby.They will keep your secret.U get National Health Insurance free for 1year when pregnant so register now.*From Mobile Midwife*.##',18,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (16,0,'2009-10-06 00:00:00','TEXT','When pregnant there are reasons that U must go to clinic right away.If U have a bad headache,fever or vomiting.If U feel pain in the womb,or a very strong pain on 1 side of your body.If U are bleeding or more important if bleeding is heavy&painful.If U have dark yellow urine or blood&a burning feeling when you urinate.If U are very dizzy or have a very fast heartbeat.Don''t be afraid to go to the clinic as the problem may be easy to cure.*From Mobile Midwife*',19,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (131,0,'2009-10-06 00:00:00','TEXT','When pregnant there are reasons that U must go to clinic right away.If U have a bad headache,fever or vomiting.If U feel pain in the womb,or a very strong pain on 1 side of your body.If U are bleeding or more important if bleeding is heavy&painful.If U have dark yellow urine or blood&a burning feeling when you urinate.If U are very dizzy or have a very fast heartbeat.Don''t be afraid to go to the clinic as the problem may be easy to cure.*From Mobile Midwife*.@@',19,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (132,0,'2009-10-06 00:00:00','TEXT','When pregnant there are reasons that U must go to clinic right away.If U have a bad headache,fever or vomiting.If U feel pain in the womb,or a very strong pain on 1 side of your body.If U are bleeding or more important if bleeding is heavy&painful.If U have dark yellow urine or blood&a burning feeling when you urinate.If U are very dizzy or have a very fast heartbeat.Don''t be afraid to go to the clinic as the problem may be easy to cure.*From Mobile Midwife*.##',19,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (17,0,'2009-10-06 00:00:00','TEXT','Even though U are not big yet,your baby''s heart&brain are growing fast.As your womb grows U may have some light cramps&waist pain.U need to eat well now for your baby.Please avoid eating clay,ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor or midwife before using any traditional medicines.*From Mobile Midwife*.',20,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (133,0,'2009-10-06 00:00:00','TEXT','Even though U are not big yet,your baby''s heart&brain are growing fast.As your womb grows U may have some light cramps&waist pain.U need to eat well now for your baby.Please avoid eating clay,ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor or midwife before using any traditional medicines.*From Mobile Midwife*.@@',20,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (134,0,'2009-10-06 00:00:00','TEXT','Even though U are not big yet,your baby''s heart&brain are growing fast.As your womb grows U may have some light cramps&waist pain.U need to eat well now for your baby.Please avoid eating clay,ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor or midwife before using any traditional medicines.*From Mobile Midwife*.##',20,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (18,0,'2009-10-06 00:00:00','TEXT','How are U feeling this week?Baby is growing.He or she may be moving now& U will be able to feel it with time.Pregnancy is nice but there are some things U must get ready.Start by putting down some money each week for things for the baby. You don''t need too much.Important things are baby napkins,dresses for U&baby,cot sheets sewn from aligudon,soap,towels,powder,shea butter,disenfectant like Camel & sanitary towels for U.*From Mobile Midwife*.',21,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (135,0,'2009-10-06 00:00:00','TEXT','How are U feeling this week?Baby is growing.He or she may be moving now& U will be able to feel it with time.Pregnancy is nice but there are some things U must get ready.Start by putting down some money each week for things for the baby. You don''t need too much.Important things are baby napkins,dresses for U&baby,cot sheets sewn from aligudon,soap,towels,powder,shea butter,disenfectant like Camel & sanitary towels for U.*From Mobile Midwife*.@@',21,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (136,0,'2009-10-06 00:00:00','TEXT','How are U feeling this week?Baby is growing.He or she may be moving now& U will be able to feel it with time.Pregnancy is nice but there are some things U must get ready.Start by putting down some money each week for things for the baby. You don''t need too much.Important things are baby napkins,dresses for U&baby,cot sheets sewn from aligudon,soap,towels,powder,shea butter,disenfectant like Camel & sanitary towels for U.*From Mobile Midwife*.##',21,3);


insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (19,0,'2009-10-06 00:00:00','TEXT','Bleeding in early pregnancy can make U worry but it is common.There are a few reasons for it happening.1.As the baby is settling in the womb U may have small bleeding for a day or two. 2.You might bleed small at the normal time for your period. 3.It could be from an infection. It is important to tell your midwife right away even if it is only small bleeding.Always report to the clinic straight away if bleeding is heavy or is painful.*From Mobile Midwife*.',22,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (137,0,'2009-10-06 00:00:00','TEXT','Bleeding in early pregnancy can make U worry but it is common.There are a few reasons for it happening.1.As the baby is settling in the womb U may have small bleeding for a day or two. 2.You might bleed small at the normal time for your period. 3.It could be from an infection. It is important to tell your midwife right away even if it is only small bleeding.Always report to the clinic straight away if bleeding is heavy or is painful.*From Mobile Midwife*.@@',22,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (138,0,'2009-10-06 00:00:00','TEXT','Bleeding in early pregnancy can make U worry but it is common.There are a few reasons for it happening.1.As the baby is settling in the womb U may have small bleeding for a day or two. 2.You might bleed small at the normal time for your period. 3.It could be from an infection. It is important to tell your midwife right away even if it is only small bleeding.Always report to the clinic straight away if bleeding is heavy or is painful.*From Mobile Midwife*.##',22,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (20,0,'2009-10-06 00:00:00','TEXT','All your baby''s body parts are there now but not fully formed yet.U might not look pregnant but your waist is getting thicker. Are U feeling tired&sick now?It is normal&here are a few tips to help U cope. 1.U feel worse if hungry or worried so eat well&try to relax. 2.Take lots of water in small bits through day. 3.Don''t eat heavy,spicy or oily food. 4.Take your tablets for the health of baby&talk to midwife if it is too much*From Mobile Midwife*.',23,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (139,0,'2009-10-06 00:00:00','TEXT','All your baby''s body parts are there now but not fully formed yet.U might not look pregnant but your waist is getting thicker. Are U feeling tired&sick now?It is normal&here are a few tips to help U cope. 1.U feel worse if hungry or worried so eat well&try to relax. 2.Take lots of water in small bits through day. 3.Don''t eat heavy,spicy or oily food. 4.Take your tablets for the health of baby&talk to midwife if it is too much*From Mobile Midwife*.@@',23,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (140,0,'2009-10-06 00:00:00','TEXT','All your baby''s body parts are there now but not fully formed yet.U might not look pregnant but your waist is getting thicker. Are U feeling tired&sick now?It is normal&here are a few tips to help U cope. 1.U feel worse if hungry or worried so eat well&try to relax. 2.Take lots of water in small bits through day. 3.Don''t eat heavy,spicy or oily food. 4.Take your tablets for the health of baby&talk to midwife if it is too much*From Mobile Midwife*.##',23,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (21,0,'2009-10-06 00:00:00','TEXT','Even though people may tell U not to have sex when pregnant,gentle sex is safe.If you&your partner feel OK with it then go ahead.If U have bleeding or pain then stop&speak to your midwife.If U have had miscarriages or sexually transmitted infections then talk to your midwife first.If U or your partner are HIV positive use condoms EVERY TIME.If U have itching down there or a change in your discharge get treated straight away at the clinic.*From Mobile Midwife*.',24,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (141,0,'2009-10-06 00:00:00','TEXT','Even though people may tell U not to have sex when pregnant,gentle sex is safe.If you&your partner feel OK with it then go ahead.If U have bleeding or pain then stop&speak to your midwife.If U have had miscarriages or sexually transmitted infections then talk to your midwife first.If U or your partner are HIV positive use condoms EVERY TIME.If U have itching down there or a change in your discharge get treated straight away at the clinic.*From Mobile Midwife*.@@',24,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (142,0,'2009-10-06 00:00:00','TEXT','Even though people may tell U not to have sex when pregnant,gentle sex is safe.If you&your partner feel OK with it then go ahead.If U have bleeding or pain then stop&speak to your midwife.If U have had miscarriages or sexually transmitted infections then talk to your midwife first.If U or your partner are HIV positive use condoms EVERY TIME.If U have itching down there or a change in your discharge get treated straight away at the clinic.*From Mobile Midwife*.##',24,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (22,0,'2009-10-06 00:00:00','TEXT','Now you are almost finished with the 1st stage of pregnancy.Just 2 more to go! U should be feeling brighter now with more energy.Now your baby''s heart is beating&all body parts are formed.Your baby is the size of your thumb now & for the next 6 months will grow big,strong&ready for outside world.Congratulations & keep up the good work!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.',25,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (143,0,'2009-10-06 00:00:00','TEXT','Now you are almost finished with the 1st stage of pregnancy.Just 2 more to go! U should be feeling brighter now with more energy.Now your baby''s heart is beating&all body parts are formed.Your baby is the size of your thumb now & for the next 6 months will grow big,strong&ready for outside world.Congratulations & keep up the good work!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.@@',25,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (144,0,'2009-10-06 00:00:00','TEXT','Now you are almost finished with the 1st stage of pregnancy.Just 2 more to go! U should be feeling brighter now with more energy.Now your baby''s heart is beating&all body parts are formed.Your baby is the size of your thumb now & for the next 6 months will grow big,strong&ready for outside world.Congratulations & keep up the good work!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.##',25,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (23,0,'2009-10-06 00:00:00','TEXT','Congratulations for successfully going through the first stage of pregnancy!Have U gone to the midwife yet?Now is the time to go&its even better if you go with the baby''s father.Its good for the father to be involved in the pregnancy.The support is helpful&it is also exciting for the father to learn what U are learning about the baby,taking care of yourself&the baby. Pregnancy is not easy-as U are seeing-so the help is nice*From Mobile Midwife*.',26,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (145,0,'2009-10-06 00:00:00','TEXT','Congratulations for successfully going through the first stage of pregnancy!Have U gone to the midwife yet?Now is the time to go&its even better if you go with the baby''s father.Its good for the father to be involved in the pregnancy.The support is helpful&it is also exciting for the father to learn what U are learning about the baby,taking care of yourself&the baby. Pregnancy is not easy-as U are seeing-so the help is nice*From Mobile Midwife*.@@',26,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (146,0,'2009-10-06 00:00:00','TEXT','Congratulations for successfully going through the first stage of pregnancy!Have U gone to the midwife yet?Now is the time to go&its even better if you go with the baby''s father.Its good for the father to be involved in the pregnancy.The support is helpful&it is also exciting for the father to learn what U are learning about the baby,taking care of yourself&the baby. Pregnancy is not easy-as U are seeing-so the help is nice*From Mobile Midwife*.##',26,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (24,0,'2009-10-06 00:00:00','TEXT','U may be showing your pregnancy now,but your baby is very small-about half the size of a banana.Baby can smile&suck its thumb.U should feel brighter now.If U are still vomitting a lot,see the midwife.Your baby now needs a range of food to grow strong.It is important to eat dairy now,like cow milk,yoghurt,wagashie&soya milk.U should still eat meat,fish,greens,grains&peas.Make sure your salt is iodated to prevent miscarriage&a disabled child.*From Mobile Midwife*.',27,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (147,0,'2009-10-06 00:00:00','TEXT','U may be showing your pregnancy now,but your baby is very small-about half the size of a banana.Baby can smile&suck its thumb.U should feel brighter now.If U are still vomitting a lot,see the midwife.Your baby now needs a range of food to grow strong.It is important to eat dairy now,like cow milk,yoghurt,wagashie&soya milk.U should still eat meat,fish,greens,grains&peas.Make sure your salt is iodated to prevent miscarriage&a disabled child.*From Mobile Midwife*.@@',27,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (148,0,'2009-10-06 00:00:00','TEXT','U may be showing your pregnancy now,but your baby is very small-about half the size of a banana.Baby can smile&suck its thumb.U should feel brighter now.If U are still vomitting a lot,see the midwife.Your baby now needs a range of food to grow strong.It is important to eat dairy now,like cow milk,yoghurt,wagashie&soya milk.U should still eat meat,fish,greens,grains&peas.Make sure your salt is iodated to prevent miscarriage&a disabled child.*From Mobile Midwife*.##',27,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (25,0,'2009-10-06 00:00:00','TEXT','U are nearly 4 months pregnant now.If U havent been to antenatal care (ANC) yet U need to go this week.Its free&best way to make sure U&baby are healthy.U need to join National Health Insurance at ANC,also free for pregnant women.At ANC you will be offered lab tests to check your blood for anaemia (low blood level) infections like syphilis,hepatitis&HIV/AIDS.Testing is important so treatment can be started for a healthy pregnancy & baby.*From Mobile Midwife*.',28,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (149,0,'2009-10-06 00:00:00','TEXT','U are nearly 4 months pregnant now.If U havent been to antenatal care (ANC) yet U need to go this week.Its free&best way to make sure U&baby are healthy.U need to join National Health Insurance at ANC,also free for pregnant women.At ANC you will be offered lab tests to check your blood for anaemia (low blood level) infections like syphilis,hepatitis&HIV/AIDS.Testing is important so treatment can be started for a healthy pregnancy & baby.*From Mobile Midwife*.@@',28,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (150,0,'2009-10-06 00:00:00','TEXT','U are nearly 4 months pregnant now.If U havent been to antenatal care (ANC) yet U need to go this week.Its free&best way to make sure U&baby are healthy.U need to join National Health Insurance at ANC,also free for pregnant women.At ANC you will be offered lab tests to check your blood for anaemia (low blood level) infections like syphilis,hepatitis&HIV/AIDS.Testing is important so treatment can be started for a healthy pregnancy & baby.*From Mobile Midwife*.##',28,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (26,0,'2009-10-06 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage.Help yourself by sleeping under insecticide treated nets.Now is the time to get a drug called SP at clinic to protect U.Wear long clothes in light colors in evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the rooms.Go to clinic STRAIGHT AWAY if you are feeling cold,fever or headache.*From Mobile Midwife*.',29,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (151,0,'2009-10-06 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage.Help yourself by sleeping under insecticide treated nets.Now is the time to get a drug called SP at clinic to protect U.Wear long clothes in light colors in evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the rooms.Go to clinic STRAIGHT AWAY if you are feeling cold,fever or headache.*From Mobile Midwife*.@@',29,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (152,0,'2009-10-06 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage.Help yourself by sleeping under insecticide treated nets.Now is the time to get a drug called SP at clinic to protect U.Wear long clothes in light colors in evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the rooms.Go to clinic STRAIGHT AWAY if you are feeling cold,fever or headache.*From Mobile Midwife*.##',29,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (27,0,'2009-10-06 00:00:00','TEXT','Your womb is growing now which may be causing some waist pains but they will soon go.U are probably showing signs of pregnancy now&may still fear the evil eye.Remember that the evil eye doesn''t cause complications but rather medical conditions cause problems.Its time to go to antenatal care at your nearest clinic.Its free&runs everyday.What you tell the midwife will be kept secret so don''t fear.No one will really know why U are there.*From Mobile Midwife*.',30,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (153,0,'2009-10-06 00:00:00','TEXT','Your womb is growing now which may be causing some waist pains but they will soon go.U are probably showing signs of pregnancy now&may still fear the evil eye.Remember that the evil eye doesn''t cause complications but rather medical conditions cause problems.Its time to go to antenatal care at your nearest clinic.Its free&runs everyday.What you tell the midwife will be kept secret so don''t fear.No one will really know why U are there.*From Mobile Midwife*.@@',30,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (154,0,'2009-10-06 00:00:00','TEXT','Your womb is growing now which may be causing some waist pains but they will soon go.U are probably showing signs of pregnancy now&may still fear the evil eye.Remember that the evil eye doesn''t cause complications but rather medical conditions cause problems.Its time to go to antenatal care at your nearest clinic.Its free&runs everyday.What you tell the midwife will be kept secret so don''t fear.No one will really know why U are there.*From Mobile Midwife*.##',30,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (28,0,'2009-10-06 00:00:00','TEXT','Most women feel fine during pregnancy so try not to worry but its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if its a sharp one-sided pain.Go for bloody or dark yellow urine or burning when U urinate.Go if you have very swollen feet hands or face.Try not to worry just see the midwife.*From Mobile Midwife*.',31,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (155,0,'2009-10-06 00:00:00','TEXT','Most women feel fine during pregnancy so try not to worry but its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if its a sharp one-sided pain.Go for bloody or dark yellow urine or burning when U urinate.Go if you have very swollen feet hands or face.Try not to worry just see the midwife.*From Mobile Midwife*.@@',31,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (156,0,'2009-10-06 00:00:00','TEXT','Most women feel fine during pregnancy so try not to worry but its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if its a sharp one-sided pain.Go for bloody or dark yellow urine or burning when U urinate.Go if you have very swollen feet hands or face.Try not to worry just see the midwife.*From Mobile Midwife*.##',31,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (29,0,'2009-10-06 00:00:00','TEXT','Congratulations! U are about halfway through your pregnancy.Well Done so far! Baby can now kick,roll over,stretch each arm&even suck a thumb.By now most of the major body parts are formed-heart,kidneys,liver&brain are complete but still small.Keep eating well&taking good care of yourself&your baby.If U haven''t been to antenatal clinic yet please go now,even if you feel fine-U need a check up.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.',32,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (157,0,'2009-10-06 00:00:00','TEXT','Congratulations! U are about halfway through your pregnancy.Well Done so far! Baby can now kick,roll over,stretch each arm&even suck a thumb.By now most of the major body parts are formed-heart,kidneys,liver&brain are complete but still small.Keep eating well&taking good care of yourself&your baby.If U haven''t been to antenatal clinic yet please go now,even if you feel fine-U need a check up.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.@@',32,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (158,0,'2009-10-06 00:00:00','TEXT','Congratulations! U are about halfway through your pregnancy.Well Done so far! Baby can now kick,roll over,stretch each arm&even suck a thumb.By now most of the major body parts are formed-heart,kidneys,liver&brain are complete but still small.Keep eating well&taking good care of yourself&your baby.If U haven''t been to antenatal clinic yet please go now,even if you feel fine-U need a check up.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.##',32,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (30,0,'2009-10-06 00:00:00','TEXT','A creamy white substance now coats baby''s body.Some babies still have the coating when born.Its not from having sex during pregnancy-its a natural protection for baby.U may have heard that difficult labor is because mother has been unfaithful-not true!Difficult labor is caused by medical conditions that can usually be managed if medical help is early.Call midwife as soon as U go into labour.Mother&baby''s life can depend on it.*From Mobile Midwife*.',33,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (159,0,'2009-10-06 00:00:00','TEXT','A creamy white substance now coats baby''s body.Some babies still have the coating when born.Its not from having sex during pregnancy-its a natural protection for baby.U may have heard that difficult labor is because mother has been unfaithful-not true!Difficult labor is caused by medical conditions that can usually be managed if medical help is early.Call midwife as soon as U go into labour.Mother&baby''s life can depend on it.*From Mobile Midwife*.@@',33,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (160,0,'2009-10-06 00:00:00','TEXT','A creamy white substance now coats baby''s body.Some babies still have the coating when born.Its not from having sex during pregnancy-its a natural protection for baby.U may have heard that difficult labor is because mother has been unfaithful-not true!Difficult labor is caused by medical conditions that can usually be managed if medical help is early.Call midwife as soon as U go into labour.Mother&baby''s life can depend on it.*From Mobile Midwife*.##',33,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (31,0,'2009-10-06 00:00:00','TEXT','Your baby can hear U now so talk&have your husband talk so baby will know your voices&feel bonded with U.Think about baby''s arrival&your delivery.Do U have transport to hospital or clinic in an emergency?Should U move closer to where U will deliver to save on transport?Have you been to ANC&know your midwifes phone number.Remember all births are safer at a health facility&if it is your 1st baby it is important to be at a clinic or hospital.*From Mobile Midwife*.',34,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (161,0,'2009-10-06 00:00:00','TEXT','Your baby can hear U now so talk&have your husband talk so baby will know your voices&feel bonded with U.Think about baby''s arrival&your delivery.Do U have transport to hospital or clinic in an emergency?Should U move closer to where U will deliver to save on transport?Have you been to ANC&know your midwifes phone number.Remember all births are safer at a health facility&if it is your 1st baby it is important to be at a clinic or hospital.*From Mobile Midwife*.@@',34,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (162,0,'2009-10-06 00:00:00','TEXT','Your baby can hear U now so talk&have your husband talk so baby will know your voices&feel bonded with U.Think about baby''s arrival&your delivery.Do U have transport to hospital or clinic in an emergency?Should U move closer to where U will deliver to save on transport?Have you been to ANC&know your midwifes phone number.Remember all births are safer at a health facility&if it is your 1st baby it is important to be at a clinic or hospital.*From Mobile Midwife*.##',34,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (32,0,'2009-10-06 00:00:00','TEXT','Tetanus is a serious sickness that enters the body through open wounds,a juke or skin scratch.U are at high risk for tetanus during&after birth because of wounds from delivery.Baby is at risk because the chord is open when born.U must get a tetanus immunization to protect you&baby.U need 2 tetanus jabs before or during pregnancy.Tetanus infection can put U&baby''s life at risk.Tetanus is given at antenatal.One more reason to see the midwife!*From Mobile Midwife*.',35,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (163,0,'2009-10-06 00:00:00','TEXT','Tetanus is a serious sickness that enters the body through open wounds,a juke or skin scratch.U are at high risk for tetanus during&after birth because of wounds from delivery.Baby is at risk because the chord is open when born.U must get a tetanus immunization to protect you&baby.U need 2 tetanus jabs before or during pregnancy.Tetanus infection can put U&baby''s life at risk.Tetanus is given at antenatal.One more reason to see the midwife!*From Mobile Midwife*.@@',35,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (164,0,'2009-10-06 00:00:00','TEXT','Tetanus is a serious sickness that enters the body through open wounds,a juke or skin scratch.U are at high risk for tetanus during&after birth because of wounds from delivery.Baby is at risk because the chord is open when born.U must get a tetanus immunization to protect you&baby.U need 2 tetanus jabs before or during pregnancy.Tetanus infection can put U&baby''s life at risk.Tetanus is given at antenatal.One more reason to see the midwife!*From Mobile Midwife*.##',35,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (33,0,'2009-10-06 00:00:00','TEXT','Don''t be afraid to ask the midwife questions at antenatal-he or she is there for U.Ask about delivery&where U will deliver.It would be nice to have baby''s father go with U.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure to take all tablets given to U to keep U both healthy.Also Register now with NHIS for 1 year of free medical cover.*From Mobile Midwife*.',36,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (165,0,'2009-10-06 00:00:00','TEXT','Don''t be afraid to ask the midwife questions at antenatal-he or she is there for U.Ask about delivery&where U will deliver.It would be nice to have baby''s father go with U.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure to take all tablets given to U to keep U both healthy.Also Register now with NHIS for 1 year of free medical cover.*From Mobile Midwife*.@@',36,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (166,0,'2009-10-06 00:00:00','TEXT','Don''t be afraid to ask the midwife questions at antenatal-he or she is there for U.Ask about delivery&where U will deliver.It would be nice to have baby''s father go with U.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure to take all tablets given to U to keep U both healthy.Also Register now with NHIS for 1 year of free medical cover.*From Mobile Midwife*.##',36,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (34,0,'2009-10-06 00:00:00','TEXT','We hope U have been to antental clinic recently.By now U should have been 2 times or more.This week U should go as U need a 2nd dose of antimalaria medicine called SP.Malaria while pregnant serious.Malaria causes a shortage of blood in the Mum.Shortage of blood is one of the causes of death in pregnancy&delivery.If U have signs of malaria like fever,feeling cold,headache or pains in bones,go to the clinic straight away for treatment.*From Mobile Midwife*.',37,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (167,0,'2009-10-06 00:00:00','TEXT','We hope U have been to antental clinic recently.By now U should have been 2 times or more.This week U should go as U need a 2nd dose of antimalaria medicine called SP.Malaria while pregnant serious.Malaria causes a shortage of blood in the Mum.Shortage of blood is one of the causes of death in pregnancy&delivery.If U have signs of malaria like fever,feeling cold,headache or pains in bones,go to the clinic straight away for treatment.*From Mobile Midwife*.@@',37,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (168,0,'2009-10-06 00:00:00','TEXT','We hope U have been to antental clinic recently.By now U should have been 2 times or more.This week U should go as U need a 2nd dose of antimalaria medicine called SP.Malaria while pregnant serious.Malaria causes a shortage of blood in the Mum.Shortage of blood is one of the causes of death in pregnancy&delivery.If U have signs of malaria like fever,feeling cold,headache or pains in bones,go to the clinic straight away for treatment.*From Mobile Midwife*.##',37,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (35,0,'2009-10-06 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood doing the job of carrying food&oxygen around the body keeping it well.Low iron levels can make U tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*.',38,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (169,0,'2009-10-06 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood doing the job of carrying food&oxygen around the body keeping it well.Low iron levels can make U tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*.@@',38,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (170,0,'2009-10-06 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood doing the job of carrying food&oxygen around the body keeping it well.Low iron levels can make U tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*.##',38,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (36,0,'2009-10-06 00:00:00','TEXT','Yeah!U are now 7 months pregnant&entering the final stage of pregnancy.Soon U will be able to hold the little one growing inside U.Baby is getting ready for the outside world forming fat layers to be a healthy newborn.Worries are normal now&it may be hard to sleep.Wear light cool sleep clothes,avoid coffee&tea.Eat small before bed&avoid spicy,oily food.If U can''t sleep just get up,take a walk&think happy thoughts.*From Mobile Midwife*.',39,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (171,0,'2009-10-06 00:00:00','TEXT','Yeah!U are now 7 months pregnant&entering the final stage of pregnancy.Soon U will be able to hold the little one growing inside U.Baby is getting ready for the outside world forming fat layers to be a healthy newborn.Worries are normal now&it may be hard to sleep.Wear light cool sleep clothes,avoid coffee&tea.Eat small before bed&avoid spicy,oily food.If U can''t sleep just get up,take a walk&think happy thoughts.*From Mobile Midwife*.@@',39,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (172,0,'2009-10-06 00:00:00','TEXT','Yeah!U are now 7 months pregnant&entering the final stage of pregnancy.Soon U will be able to hold the little one growing inside U.Baby is getting ready for the outside world forming fat layers to be a healthy newborn.Worries are normal now&it may be hard to sleep.Wear light cool sleep clothes,avoid coffee&tea.Eat small before bed&avoid spicy,oily food.If U can''t sleep just get up,take a walk&think happy thoughts.*From Mobile Midwife*.##',39,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (37,0,'2009-10-06 00:00:00','TEXT','U are closer to delivery&we still have info for U!Some beliefs about babies are not really true.If baby is deformed it is a medical problem-see a doctor.If too serious AFRIKIDS@Sirigu or Bolga can help.If baby cries alot,falls sick alot,or bites mum''s breast its normal child behavior,not a curse.Babies are gifts from God&have a better chance at life if born at a health facility.If U have problems with traditions,ask your midwife for help.*From Mobile Midwife*.',40,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (173,0,'2009-10-06 00:00:00','TEXT','U are closer to delivery&we still have info for U!Some beliefs about babies are not really true.If baby is deformed it is a medical problem-see a doctor.If too serious AFRIKIDS@Sirigu or Bolga can help.If baby cries alot,falls sick alot,or bites mum''s breast its normal child behavior,not a curse.Babies are gifts from God&have a better chance at life if born at a health facility.If U have problems with traditions,ask your midwife for help.*From Mobile Midwife*.@@',40,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (174,0,'2009-10-06 00:00:00','TEXT','U are closer to delivery&we still have info for U!Some beliefs about babies are not really true.If baby is deformed it is a medical problem-see a doctor.If too serious AFRIKIDS@Sirigu or Bolga can help.If baby cries alot,falls sick alot,or bites mum''s breast its normal child behavior,not a curse.Babies are gifts from God&have a better chance at life if born at a health facility.If U have problems with traditions,ask your midwife for help.*From Mobile Midwife*.##',40,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (38,0,'2009-10-06 00:00:00','TEXT','Are your feet&hands swollen?It is called edema.This does not mean that baby is a boy.It happens as extra blood U have 4 baby gets trapped&pushes water into hands or ankles.It is common,not serious&goes away when baby is born.Help make it better by sitting with feet up,drink lots of water,avoid too much salt&maggi.If swelling comes sudden&your hands&face get big see midwife straight as this is dangerous.*From Mobile Midwife*.',41,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (175,0,'2009-10-06 00:00:00','TEXT','Are your feet&hands swollen?It is called edema.This does not mean that baby is a boy.It happens as extra blood U have 4 baby gets trapped&pushes water into hands or ankles.It is common,not serious&goes away when baby is born.Help make it better by sitting with feet up,drink lots of water,avoid too much salt&maggi.If swelling comes sudden&your hands&face get big see midwife straight as this is dangerous.*From Mobile Midwife*.@@',41,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (176,0,'2009-10-06 00:00:00','TEXT','Are your feet&hands swollen?It is called edema.This does not mean that baby is a boy.It happens as extra blood U have 4 baby gets trapped&pushes water into hands or ankles.It is common,not serious&goes away when baby is born.Help make it better by sitting with feet up,drink lots of water,avoid too much salt&maggi.If swelling comes sudden&your hands&face get big see midwife straight as this is dangerous.*From Mobile Midwife*.##',41,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (39,0,'2009-10-06 00:00:00','TEXT','It is good to be informed about when U must go to clinic.Go if bleeding,it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy,blurry or flashing vision.Go if U have pain in the belly,especially if it is a sharp one-sided pain or baby is moving less.Go if suddenly too thirsty&urinating too much.Go if U have very swollen feet hands,face or eyes.Try not to worry just see the midwife.*From Mobile Midwife*.',42,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (177,0,'2009-10-06 00:00:00','TEXT','It is good to be informed about when U must go to clinic.Go if bleeding,it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy,blurry or flashing vision.Go if U have pain in the belly,especially if it is a sharp one-sided pain or baby is moving less.Go if suddenly too thirsty&urinating too much.Go if U have very swollen feet hands,face or eyes.Try not to worry just see the midwife.*From Mobile Midwife*.@@',42,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (178,0,'2009-10-06 00:00:00','TEXT','It is good to be informed about when U must go to clinic.Go if bleeding,it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy,blurry or flashing vision.Go if U have pain in the belly,especially if it is a sharp one-sided pain or baby is moving less.Go if suddenly too thirsty&urinating too much.Go if U have very swollen feet hands,face or eyes.Try not to worry just see the midwife.*From Mobile Midwife*.##',42,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (40,0,'2009-10-06 00:00:00','TEXT','Soon baby will join us in the outside world. Baby will need to be protected from infection&sickness.To help baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the BEST!Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*.',43,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (179,0,'2009-10-06 00:00:00','TEXT','Soon baby will join us in the outside world. Baby will need to be protected from infection&sickness.To help baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the BEST!Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*.@@',43,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (180,0,'2009-10-06 00:00:00','TEXT','Soon baby will join us in the outside world. Baby will need to be protected from infection&sickness.To help baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the BEST!Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*.##',43,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (41,0,'2009-10-06 00:00:00','TEXT','Labour is different for each woman&some signs show U are in labour.Contractions-when belly muscles tighten&harden-will come regular&hurt.They get stronger,longer&more painful as birth gets close.U may feel pain in the low back&cramps like a period.U may see a “show”-when the mucus plug that blocks neck of womb comes out&looks jelly-like.If waters break&U have contractions contact midwife&get to clinic as babies can sometimes come fast.*From Mobile Midwife*.',44,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (181,0,'2009-10-06 00:00:00','TEXT','Labour is different for each woman&some signs show U are in labour.Contractions-when belly muscles tighten&harden-will come regular&hurt.They get stronger,longer&more painful as birth gets close.U may feel pain in the low back&cramps like a period.U may see a “show”-when the mucus plug that blocks neck of womb comes out&looks jelly-like.If waters break&U have contractions contact midwife&get to clinic as babies can sometimes come fast.*From Mobile Midwife*.@@',44,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (182,0,'2009-10-06 00:00:00','TEXT','Labour is different for each woman&some signs show U are in labour.Contractions-when belly muscles tighten&harden-will come regular&hurt.They get stronger,longer&more painful as birth gets close.U may feel pain in the low back&cramps like a period.U may see a “show”-when the mucus plug that blocks neck of womb comes out&looks jelly-like.If waters break&U have contractions contact midwife&get to clinic as babies can sometimes come fast.*From Mobile Midwife*.##',44,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (42,0,'2009-10-06 00:00:00','TEXT','Babies get food&oxygen in womb through placenta(or afterbirth).Placenta passes nutrients from mum to baby through umbilical cord attached to baby''s belly.After birth,cord is cut&a stump remains that soon falls off.Care of the stump before it falls off is very important.Keep it clean&dry.Dont apply anything to it.No spirit,ash,glass or anything.Make sure baby napkins dont rub or cover stump.Dont force stump to fall,it will go in 10-21 days.*From Mobile Midwife*.',45,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (183,0,'2009-10-06 00:00:00','TEXT','Babies get food&oxygen in womb through placenta(or afterbirth).Placenta passes nutrients from mum to baby through umbilical cord attached to baby''s belly.After birth,cord is cut&a stump remains that soon falls off.Care of the stump before it falls off is very important.Keep it clean&dry.Dont apply anything to it.No spirit,ash,glass or anything.Make sure baby napkins dont rub or cover stump.Dont force stump to fall,it will go in 10-21 days.*From Mobile Midwife*.@@',45,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (184,0,'2009-10-06 00:00:00','TEXT','Babies get food&oxygen in womb through placenta(or afterbirth).Placenta passes nutrients from mum to baby through umbilical cord attached to baby''s belly.After birth,cord is cut&a stump remains that soon falls off.Care of the stump before it falls off is very important.Keep it clean&dry.Dont apply anything to it.No spirit,ash,glass or anything.Make sure baby napkins dont rub or cover stump.Dont force stump to fall,it will go in 10-21 days.*From Mobile Midwife*.##',45,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (43,0,'2009-10-06 00:00:00','TEXT','Well done!U are 33 weeks pregnant!From now U must do all U can to ensure baby is born healthy.Babies born before 36 weeks are early but can still be healthy.If baby comes early follow these tips.Don''t bath small babies,wipe with clean damp cloth.Tie baby between your breasts with a lappa all the day.Shea butter on their body helps baby stay warm.Breastfeed straight away&don''t give anything but breastmilk for first 6months of life.*From Mobile Midwife*.',46,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (185,0,'2009-10-06 00:00:00','TEXT','Well done!U are 33 weeks pregnant!From now U must do all U can to ensure baby is born healthy.Babies born before 36 weeks are early but can still be healthy.If baby comes early follow these tips.Don''t bath small babies,wipe with clean damp cloth.Tie baby between your breasts with a lappa all the day.Shea butter on their body helps baby stay warm.Breastfeed straight away&don''t give anything but breastmilk for first 6months of life.*From Mobile Midwife*.@@',46,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (186,0,'2009-10-06 00:00:00','TEXT','Well done!U are 33 weeks pregnant!From now U must do all U can to ensure baby is born healthy.Babies born before 36 weeks are early but can still be healthy.If baby comes early follow these tips.Don''t bath small babies,wipe with clean damp cloth.Tie baby between your breasts with a lappa all the day.Shea butter on their body helps baby stay warm.Breastfeed straight away&don''t give anything but breastmilk for first 6months of life.*From Mobile Midwife*.##',46,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (44,0,'2009-10-06 00:00:00','TEXT','Baby is about the size of a medium grasscutter now&is practicing breathing&has hair now.Labour time is coming soon&when U go into labour it is very important to contact your midwife straight.Every labour is different.U need to be sure U call the midwife so any problem can be solved right away.Signs of true labour include,contractions,pain,show&breaking of waters.Midwife can confirm true labour so don''t be afraid to contact them to be sure.*From Mobile Midwife*.',47,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (187,0,'2009-10-06 00:00:00','TEXT','Baby is about the size of a medium grasscutter now&is practicing breathing&has hair now.Labour time is coming soon&when U go into labour it is very important to contact your midwife straight.Every labour is different.U need to be sure U call the midwife so any problem can be solved right away.Signs of true labour include,contractions,pain,show&breaking of waters.Midwife can confirm true labour so don''t be afraid to contact them to be sure.*From Mobile Midwife*.@@',47,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (188,0,'2009-10-06 00:00:00','TEXT','Baby is about the size of a medium grasscutter now&is practicing breathing&has hair now.Labour time is coming soon&when U go into labour it is very important to contact your midwife straight.Every labour is different.U need to be sure U call the midwife so any problem can be solved right away.Signs of true labour include,contractions,pain,show&breaking of waters.Midwife can confirm true labour so don''t be afraid to contact them to be sure.*From Mobile Midwife*.##',47,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (45,0,'2009-10-06 00:00:00','TEXT','First breastmilk is called colostrum-a thick yellowish fluid,rich in protien,antibodies&other infection fighting things.Its not dirty.Its the best milk for baby.Later breastmilk comes bluish-white&more watery.Newborns eat 8-12 times or more through 1day&night.Feeding often helps U increase milk production.Start feeding on 1 breast til baby stops or breast is empty then move to other breast.Baby needs nothing but breastmilk for first 6months.*From Mobile Midwife*.',48,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (189,0,'2009-10-06 00:00:00','TEXT','First breastmilk is called colostrum-a thick yellowish fluid,rich in protien,antibodies&other infection fighting things.Its not dirty.Its the best milk for baby.Later breastmilk comes bluish-white&more watery.Newborns eat 8-12 times or more through 1day&night.Feeding often helps U increase milk production.Start feeding on 1 breast til baby stops or breast is empty then move to other breast.Baby needs nothing but breastmilk for first 6months.*From Mobile Midwife*.@@',48,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (190,0,'2009-10-06 00:00:00','TEXT','First breastmilk is called colostrum-a thick yellowish fluid,rich in protien,antibodies&other infection fighting things.Its not dirty.Its the best milk for baby.Later breastmilk comes bluish-white&more watery.Newborns eat 8-12 times or more through 1day&night.Feeding often helps U increase milk production.Start feeding on 1 breast til baby stops or breast is empty then move to other breast.Baby needs nothing but breastmilk for first 6months.*From Mobile Midwife*.##',48,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (46,0,'2009-10-06 00:00:00','TEXT','Your baby is almost ready for the world now.Well Done!The BEST thing you can do for U&your baby is DELIVER AT A HEALTH FACILITY.Health workers can help deal with any emergencies that come up&make sure that your baby gets the best care in his/her first few minutes in this world.Give your baby the best start in life!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.',49,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (191,0,'2009-10-06 00:00:00','TEXT','Your baby is almost ready for the world now.Well Done!The BEST thing you can do for U&your baby is DELIVER AT A HEALTH FACILITY.Health workers can help deal with any emergencies that come up&make sure that your baby gets the best care in his/her first few minutes in this world.Give your baby the best start in life!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.@@',49,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (192,0,'2009-10-06 00:00:00','TEXT','Your baby is almost ready for the world now.Well Done!The BEST thing you can do for U&your baby is DELIVER AT A HEALTH FACILITY.Health workers can help deal with any emergencies that come up&make sure that your baby gets the best care in his/her first few minutes in this world.Give your baby the best start in life!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.##',49,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (47,0,'2009-10-06 00:00:00','TEXT','Babies who are breastfed are healthier&better nourished than those given other drinks&food.Baby needs no other food or drink for first 6 months of life.Breastmilk alone meets all their needs including water.Right position for breastfeeding is:baby''s body is turned to face mum belly to belly.Baby''s chin touchs mum''s breast,more of dark skin around mum''s nipple is seen above baby''s mouth than below,baby takes long deep sucks&mum has no pain.*From Mobile Midwife*.',50,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (193,0,'2009-10-06 00:00:00','TEXT','Babies who are breastfed are healthier&better nourished than those given other drinks&food.Baby needs no other food or drink for first 6 months of life.Breastmilk alone meets all their needs including water.Right position for breastfeeding is:baby''s body is turned to face mum belly to belly.Baby''s chin touchs mum''s breast,more of dark skin around mum''s nipple is seen above baby''s mouth than below,baby takes long deep sucks&mum has no pain.*From Mobile Midwife*.@@',50,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (194,0,'2009-10-06 00:00:00','TEXT','Babies who are breastfed are healthier&better nourished than those given other drinks&food.Baby needs no other food or drink for first 6 months of life.Breastmilk alone meets all their needs including water.Right position for breastfeeding is:baby''s body is turned to face mum belly to belly.Baby''s chin touchs mum''s breast,more of dark skin around mum''s nipple is seen above baby''s mouth than below,baby takes long deep sucks&mum has no pain.*From Mobile Midwife*.##',50,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (48,0,'2009-10-06 00:00:00','TEXT','Baby can come anytime now!Great!Do U have all U need for delivery packed in a bag?U need baby napkins,cloths,soap,Camel,baby soap,shea butter,Aligudon for baby,towels&Makintosh.Do U have midwife''s phone number?Where are U delivering?How will U get there?If U dont deliver at hospital U must report to clinic as soon as possible after the birth.This is to be sure U&baby have a great start at taking care of yourself&the blessing God has given U.*From Mobile Midwife*.',51,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (195,0,'2009-10-06 00:00:00','TEXT','Baby can come anytime now!Great!Do U have all U need for delivery packed in a bag?U need baby napkins,cloths,soap,Camel,baby soap,shea butter,Aligudon for baby,towels&Makintosh.Do U have midwife''s phone number?Where are U delivering?How will U get there?If U dont deliver at hospital U must report to clinic as soon as possible after the birth.This is to be sure U&baby have a great start at taking care of yourself&the blessing God has given U.*From Mobile Midwife*.@@',51,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (196,0,'2009-10-06 00:00:00','TEXT','Baby can come anytime now!Great!Do U have all U need for delivery packed in a bag?U need baby napkins,cloths,soap,Camel,baby soap,shea butter,Aligudon for baby,towels&Makintosh.Do U have midwife''s phone number?Where are U delivering?How will U get there?If U dont deliver at hospital U must report to clinic as soon as possible after the birth.This is to be sure U&baby have a great start at taking care of yourself&the blessing God has given U.*From Mobile Midwife*.##',51,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (49,0,'2009-10-06 00:00:00','TEXT','If baby has arrived,congrats!!If not it will be here soon.Be ready to go to health facility as soon as labour starts-delivering there is safer for mum&baby.When baby is born take baby to clinic within 1 day of birth for check by nurse.Also take baby to facility STRAIGHT if they have fever,high temperature,trouble breathing,if baby is not sucking as before,wont feed,not crying or weak&limp.Ask a doctor for help before its too late*From Mobile Midwife*.',52,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (197,0,'2009-10-06 00:00:00','TEXT','If baby has arrived,congrats!!If not it will be here soon.Be ready to go to health facility as soon as labour starts-delivering there is safer for mum&baby.When baby is born take baby to clinic within 1 day of birth for check by nurse.Also take baby to facility STRAIGHT if they have fever,high temperature,trouble breathing,if baby is not sucking as before,wont feed,not crying or weak&limp.Ask a doctor for help before its too late*From Mobile Midwife*.@@',52,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (198,0,'2009-10-06 00:00:00','TEXT','If baby has arrived,congrats!!If not it will be here soon.Be ready to go to health facility as soon as labour starts-delivering there is safer for mum&baby.When baby is born take baby to clinic within 1 day of birth for check by nurse.Also take baby to facility STRAIGHT if they have fever,high temperature,trouble breathing,if baby is not sucking as before,wont feed,not crying or weak&limp.Ask a doctor for help before its too late*From Mobile Midwife*.##',52,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (50,0,'2009-10-06 00:00:00','TEXT','If baby hasn''t arrived yet,don''t worry but go to ANC to be sure all is fine.If U have delivered,congrats!!If baby was born outside hospital its very important U&baby visit clinic for checkup before 1day passes.It is to make sure U&baby are fine.Baby gets immunizations to protect from TB&Polio,so they can grow healthy&strong.U can also ask questions U have about baby''s care&health.*From Mobile Midwife*.',53,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (199,0,'2009-10-06 00:00:00','TEXT','If baby hasn''t arrived yet,don''t worry but go to ANC to be sure all is fine.If U have delivered,congrats!!If baby was born outside hospital its very important U&baby visit clinic for checkup before 1day passes.It is to make sure U&baby are fine.Baby gets immunizations to protect from TB&Polio,so they can grow healthy&strong.U can also ask questions U have about baby''s care&health.*From Mobile Midwife*.@@',53,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (200,0,'2009-10-06 00:00:00','TEXT','If baby hasn''t arrived yet,don''t worry but go to ANC to be sure all is fine.If U have delivered,congrats!!If baby was born outside hospital its very important U&baby visit clinic for checkup before 1day passes.It is to make sure U&baby are fine.Baby gets immunizations to protect from TB&Polio,so they can grow healthy&strong.U can also ask questions U have about baby''s care&health.*From Mobile Midwife*.##',53,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (201,0,'2010-02-02 00:00:00','TEXT','Malaria is very dangerous for pregnant women&more for new babies.U&baby should sleep under insecticide treated nets.Cover baby''s arms,legs&feet in evening&at dawn.Try burning neem leaves or orange peels to keep mosquitos away or spray rooms.Clearing bushes around house&covering water containers helps too.If baby has fever go to clinic straight for early treatment that can save baby''s life.*From Mobile Midwife*.',54,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (202,0,'2010-02-02 00:00:00','TEXT','Malaria is very dangerous for pregnant women&more for new babies.U&baby should sleep under insecticide treated nets.Cover baby''s arms,legs&feet in evening&at dawn.Try burning neem leaves or orange peels to keep mosquitos away or spray rooms.Clearing bushes around house&covering water containers helps too.If baby has fever go to clinic straight for early treatment that can save baby''s life.*From Mobile Midwife*.@@',54,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (203,0,'2010-02-02 00:00:00','TEXT','Malaria is very dangerous for pregnant women&more for new babies.U&baby should sleep under insecticide treated nets.Cover baby''s arms,legs&feet in evening&at dawn.Try burning neem leaves or orange peels to keep mosquitos away or spray rooms.Clearing bushes around house&covering water containers helps too.If baby has fever go to clinic straight for early treatment that can save baby''s life.*From Mobile Midwife*.##',54,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (204,0,'2010-02-02 00:00:00','TEXT','If you haven''t delivered yet,make sure U go to clinic to be sure all is fine.Don''t just wait at home.If labour is not coming there may be a problem&your midwife can help.Waiting at home can be dangerous for U&baby.Try not to worry that something is wrong,but at times we need to help nature along&help start your labour.Remember,delivery at a health facility is safer for mother&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.',55,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (205,0,'2010-02-02 00:00:00','TEXT','If you haven''t delivered yet,make sure U go to clinic to be sure all is fine.Don''t just wait at home.If labour is not coming there may be a problem&your midwife can help.Waiting at home can be dangerous for U&baby.Try not to worry that something is wrong,but at times we need to help nature along&help start your labour.Remember,delivery at a health facility is safer for mother&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.@@',55,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (206,0,'2010-02-02 00:00:00','TEXT','If you haven''t delivered yet,make sure U go to clinic to be sure all is fine.Don''t just wait at home.If labour is not coming there may be a problem&your midwife can help.Waiting at home can be dangerous for U&baby.Try not to worry that something is wrong,but at times we need to help nature along&help start your labour.Remember,delivery at a health facility is safer for mother&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*.##',55,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (207,0,'2010-02-02 00:00:00','TEXT','We hope you are finding motherhood good&are trying to get some rest.Are U breastfeeding? Do U have painful breasts?Its common as breasts try to make the right amount of milk for baby.Don''t give up,it will soon be easier.Feed baby when they want to eat&they should be feeding at least 10times through a day&night.Don''t be afraid to wake baby for feeding in order to release pressure in your breasts.Breastmilk ALONE is best for a healthy baby.*From Mobile Midwife*.',56,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (208,0,'2010-02-02 00:00:00','TEXT','We hope you are finding motherhood good&are trying to get some rest.Are U breastfeeding? Do U have painful breasts?Its common as breasts try to make the right amount of milk for baby.Don''t give up,it will soon be easier.Feed baby when they want to eat&they should be feeding at least 10times through a day&night.Don''t be afraid to wake baby for feeding in order to release pressure in your breasts.Breastmilk ALONE is best for a healthy baby.*From Mobile Midwife*.@@',56,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (209,0,'2010-02-02 00:00:00','TEXT','We hope you are finding motherhood good&are trying to get some rest.Are U breastfeeding? Do U have painful breasts?Its common as breasts try to make the right amount of milk for baby.Don''t give up,it will soon be easier.Feed baby when they want to eat&they should be feeding at least 10times through a day&night.Don''t be afraid to wake baby for feeding in order to release pressure in your breasts.Breastmilk ALONE is best for a healthy baby.*From Mobile Midwife*.##',56,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (210,0,'2010-02-02 00:00:00','TEXT','Newborns only need a few things to be happy.Food,love,sleep&a clean nappy.Changing baby''s nappy often is important-bacteria in urine&faeces can make skin sore&give rashes.This happens very quick in warm weather.Expect to change nappy before or after every feed.This should every 1-3hrs.Baby is well fed if you change 6-10 nappies/day.Clean baby''s buttocks with soft,damp,clean cloth&be sure to wash hands with soap after every change*From Mobile Midwife*.',57,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (211,0,'2010-02-02 00:00:00','TEXT','Newborns only need a few things to be happy.Food,love,sleep&a clean nappy.Changing baby''s nappy often is important-bacteria in urine&faeces can make skin sore&give rashes.This happens very quick in warm weather.Expect to change nappy before or after every feed.This should every 1-3hrs.Baby is well fed if you change 6-10 nappies/day.Clean baby''s buttocks with soft,damp,clean cloth&be sure to wash hands with soap after every change*From Mobile Midwife*.@@',57,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (212,0,'2010-02-02 00:00:00','TEXT','Newborns only need a few things to be happy.Food,love,sleep&a clean nappy.Changing baby''s nappy often is important-bacteria in urine&faeces can make skin sore&give rashes.This happens very quick in warm weather.Expect to change nappy before or after every feed.This should every 1-3hrs.Baby is well fed if you change 6-10 nappies/day.Clean baby''s buttocks with soft,damp,clean cloth&be sure to wash hands with soap after every change*From Mobile Midwife*.##',57,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (213,0,'2010-02-02 00:00:00','TEXT','When pregnant there are reasons that you must go to the clinic right away.If you have a bad headache,fever or vomiting.If you feel pain in the womb,or a very strong pain on one side of your body.If you are bleeding or more important if the bleeding is heavy+painful.If you have dark yellow urine or blood+a burning feeling when you urinate.If you are very dizzy or have a very fast heart beat.Don''t be afraid to go to the clinic as the problem may be easy to cure.',58,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (214,0,'2010-02-02 00:00:00','TEXT','When pregnant there are reasons that you must go to the clinic right away.If you have a bad headache,fever or vomiting.If you feel pain in the womb,or a very strong pain on one side of your body.If you are bleeding or more important if the bleeding is heavy+painful.If you have dark yellow urine or blood+a burning feeling when you urinate.If you are very dizzy or have a very fast heart beat.Don''t be afraid to go to the clinic as the problem may be easy to cure.@@',58,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (215,0,'2010-02-02 00:00:00','TEXT','When pregnant there are reasons that you must go to the clinic right away.If you have a bad headache,fever or vomiting.If you feel pain in the womb,or a very strong pain on one side of your body.If you are bleeding or more important if the bleeding is heavy+painful.If you have dark yellow urine or blood+a burning feeling when you urinate.If you are very dizzy or have a very fast heart beat.Don''t be afraid to go to the clinic as the problem may be easy to cure.##',58,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (216,0,'2010-02-02 00:00:00','TEXT','Once you know you are pregnant,register with national health insurance to get a full year of free medical care.Health insurance also covers the first 6 weeks of your baby''s life.It is important to go for antenatal care so you are sure you are healthy for this baby.You will get free vitamins to keep you+baby healthy during pregnancy+you can ask questions about how you are both doing.Antenatal is at your nearest CHPS compound daily so no one knows why you are there.',59,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (217,0,'2010-02-02 00:00:00','TEXT','Once you know you are pregnant,register with national health insurance to get a full year of free medical care.Health insurance also covers the first 6 weeks of your baby''s life.It is important to go for antenatal care so you are sure you are healthy for this baby.You will get free vitamins to keep you+baby healthy during pregnancy+you can ask questions about how you are both doing.Antenatal is at your nearest CHPS compound daily so no one knows why you are there@@',59,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (218,0,'2010-02-02 00:00:00','TEXT','Once you know you are pregnant,register with national health insurance to get a full year of free medical care.Health insurance also covers the first 6 weeks of your baby''s life.It is important to go for antenatal care so you are sure you are healthy for this baby.You will get free vitamins to keep you+baby healthy during pregnancy+you can ask questions about how you are both doing.Antenatal is at your nearest CHPS compound daily so no one knows why you are there##',59,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (219,0,'2010-02-02 00:00:00','TEXT','Now that you are pregnant you are not sick but you must be a bit careful.Rough movements+heavy work can cause body pains+damage your body so please ask for help when doing heavy work like fetching firewood or water.When working take plenty of clean water,ginger beer or zonkom to help keep your body cool+try to avoid working in the very hot afternoon sun.If you can,try to find a shady place to do your work.',60,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (220,0,'2010-02-02 00:00:00','TEXT','Now that you are pregnant you are not sick but you must be a bit careful.Rough movements+heavy work can cause body pains+damage your body so please ask for help when doing heavy work like fetching firewood or water.When working take plenty of clean water,ginger beer or zonkom to help keep your body cool+try to avoid working in the very hot afternoon sun.If you can,try to find a shady place to do your work.@@',60,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (221,0,'2010-02-02 00:00:00','TEXT','Now that you are pregnant you are not sick but you must be a bit careful.Rough movements+heavy work can cause body pains+damage your body so please ask for help when doing heavy work like fetching firewood or water.When working take plenty of clean water,ginger beer or zonkom to help keep your body cool+try to avoid working in the very hot afternoon sun.If you can,try to find a shady place to do your work.##',60,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (222,0,'2010-02-02 00:00:00','TEXT','Even though you might not be showing yet your baby''s heart+brain are growing quickly.As your womb grows you may have some light cramps+waist pain. You need to eat well now for your baby.Please avoid eating ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor before using any traditional medicines.',61,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (223,0,'2010-02-02 00:00:00','TEXT','Even though you might not be showing yet your baby''s heart+brain are growing quickly.As your womb grows you may have some light cramps+waist pain. You need to eat well now for your baby.Please avoid eating ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor before using any traditional medicines.@@',61,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (224,0,'2010-02-02 00:00:00','TEXT','Even though you might not be showing yet your baby''s heart+brain are growing quickly.As your womb grows you may have some light cramps+waist pain. You need to eat well now for your baby.Please avoid eating ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor before using any traditional medicines.##',61,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (225,0,'2010-02-02 00:00:00','TEXT','If you are feeling tired+weak now don''t worry as it is a natural part of pregnancy.Your body is working hard to grow the baby which can make you feel very tired+sometimes your body feels very weak.As you grow bigger you will feel the weight on your body+if you are worrying too much you may not sleep at night.Try to rest when you can.Ask for help with heavy work like fetching water or firewood.Try to take time to relax your body+your mind when you can.',62,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (226,0,'2010-02-02 00:00:00','TEXT','If you are feeling tired+weak now don''t worry as it is a natural part of pregnancy.Your body is working hard to grow the baby which can make you feel very tired+sometimes your body feels very weak.As you grow bigger you will feel the weight on your body+if you are worrying too much you may not sleep at night.Try to rest when you can.Ask for help with heavy work like fetching water or firewood.Try to take time to relax your body+your mind when you can.@@',62,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (227,0,'2010-02-02 00:00:00','TEXT','If you are feeling tired+weak now don''t worry as it is a natural part of pregnancy.Your body is working hard to grow the baby which can make you feel very tired+sometimes your body feels very weak.As you grow bigger you will feel the weight on your body+if you are worrying too much you may not sleep at night.Try to rest when you can.Ask for help with heavy work like fetching water or firewood.Try to take time to relax your body+your mind when you can.##',62,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (228,0,'2010-02-02 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother+miscarriage.Help yourself by sleeping under insecticide treated nets.Soon you will be given medicine called SP at the clinic to protect you.Wear long clothes in light colors in the evening.Try burning neem leaves or orange peels to keep mosquitos away or you can spray the rooms.Avoid hanging many clothes in your room,mosquitos hide in them.Fold your clothes up.Go to the clinic if you feel cold or have headache.',63,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (229,0,'2010-02-02 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother+miscarriage.Help yourself by sleeping under insecticide treated nets.Soon you will be given medicine called SP at the clinic to protect you.Wear long clothes in light colors in the evening.Try burning neem leaves or orange peels to keep mosquitos away or you can spray the rooms.Avoid hanging many clothes in your room,mosquitos hide in them.Fold your clothes up.Go to the clinic if you feel cold or have headache.@@',63,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (230,0,'2010-02-02 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother+miscarriage.Help yourself by sleeping under insecticide treated nets.Soon you will be given medicine called SP at the clinic to protect you.Wear long clothes in light colors in the evening.Try burning neem leaves or orange peels to keep mosquitos away or you can spray the rooms.Avoid hanging many clothes in your room,mosquitos hide in them.Fold your clothes up.Go to the clinic if you feel cold or have headache.##',63,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (231,0,'2010-02-02 00:00:00','TEXT','message 7',64,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (232,0,'2010-02-02 00:00:00','TEXT','message 7@@',64,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (233,0,'2010-02-02 00:00:00','TEXT','message 7##',64,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (234,0,'2010-02-02 00:00:00','TEXT','message 8',65,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (235,0,'2010-02-02 00:00:00','TEXT','message 8@@',65,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (236,0,'2010-02-02 00:00:00','TEXT','message 8##',65,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (237,0,'2010-02-02 00:00:00','TEXT','message 9',66,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (238,0,'2010-02-02 00:00:00','TEXT','message 9@@',66,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (239,0,'2010-02-02 00:00:00','TEXT','message 9##',66,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (240,0,'2010-02-02 00:00:00','TEXT','message 10',67,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (241,0,'2010-02-02 00:00:00','TEXT','message 10@@',67,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (242,0,'2010-02-02 00:00:00','TEXT','message 10##',67,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (243,0,'2010-02-02 00:00:00','TEXT','message 11',68,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (244,0,'2010-02-02 00:00:00','TEXT','message 11@@',68,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (245,0,'2010-02-02 00:00:00','TEXT','message 11##',68,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (246,0,'2010-02-02 00:00:00','TEXT','message 12',69,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (247,0,'2010-02-02 00:00:00','TEXT','message 12@@',69,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (248,0,'2010-02-02 00:00:00','TEXT','message 12##',69,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (249,0,'2010-02-02 00:00:00','TEXT','message 13',70,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (250,0,'2010-02-02 00:00:00','TEXT','message 13@@',70,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (251,0,'2010-02-02 00:00:00','TEXT','message 13##',70,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (252,0,'2010-02-02 00:00:00','TEXT','message 14',71,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (253,0,'2010-02-02 00:00:00','TEXT','message 14@@',71,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (254,0,'2010-02-02 00:00:00','TEXT','message 14##',71,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (255,0,'2010-02-02 00:00:00','TEXT','message 15',72,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (256,0,'2010-02-02 00:00:00','TEXT','message 15@@',72,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (257,0,'2010-02-02 00:00:00','TEXT','message 15##',72,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (258,0,'2010-02-02 00:00:00','TEXT','message 16',73,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (259,0,'2010-02-02 00:00:00','TEXT','message 16@@',73,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (260,0,'2010-02-02 00:00:00','TEXT','message 16##',73,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (261,0,'2010-02-02 00:00:00','TEXT','message 17',74,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (262,0,'2010-02-02 00:00:00','TEXT','message 17@@',74,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (263,0,'2010-02-02 00:00:00','TEXT','message 17##',74,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (264,0,'2010-02-02 00:00:00','TEXT','message 18',75,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (265,0,'2010-02-02 00:00:00','TEXT','message 18@@',75,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (266,0,'2010-02-02 00:00:00','TEXT','message 18##',75,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (267,0,'2010-02-02 00:00:00','TEXT','message 19',76,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (268,0,'2010-02-02 00:00:00','TEXT','message 19@@',76,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (269,0,'2010-02-02 00:00:00','TEXT','message 19##',76,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (270,0,'2010-02-02 00:00:00','TEXT','message 20',77,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (271,0,'2010-02-02 00:00:00','TEXT','message 20@@',77,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (272,0,'2010-02-02 00:00:00','TEXT','message 20##',77,3);

/*Data entry for care*/

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (273,0,'2010-04-26 00:00:00','TEXT','This week U need a tetanus vaccination.Tetanus is a serious sickness that U get thru wounds.U are at risk for tetanus because of wounds U get during delivery.',78,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (274,0,'2010-04-26 00:00:00','TEXT','This week U need a tetanus vaccination.Tetanus is a serious sickness that U get thru wounds.U are at risk for tetanus because of wounds U get during delivery@@.',78,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (275,0,'2010-04-26 00:00:00','TEXT','This week U need a tetanus vaccination.Tetanus is a serious sickness that U get thru wounds.U are at risk for tetanus because of wounds U get during delivery##.',78,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (276,0,'2010-04-26 00:00:00','TEXT','You have missed a tetanus vaccination.Tetanus is a serious sickness.U will not be protected from tetanus unless you have the vaccination.Go to the clinic NOW!',79,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (277,0,'2010-04-26 00:00:00','TEXT','You have missed a tetanus vaccination.Tetanus is a serious sickness.U will not be protected from tetanus unless you have the vaccination.Go to the clinic NOW!@@',79,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (278,0,'2010-04-26 00:00:00','TEXT','You have missed a tetanus vaccination.Tetanus is a serious sickness.U will not be protected from tetanus unless you have the vaccination.Go to the clinic NOW!##',79,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (279,0,'2010-04-26 00:00:00','TEXT','This week U need to get a drug called SP which protects U from malaria.Malaria can kill U&your baby so make sure to get SP at the clinic this week.',80,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (280,0,'2010-04-26 00:00:00','TEXT','This week U need to get a drug called SP which protects U from malaria.Malaria can kill U&your baby so make sure to get SP at the clinic this week.@@',80,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (281,0,'2010-04-26 00:00:00','TEXT','This week U need to get a drug called SP which protects U from malaria.Malaria can kill U&your baby so make sure to get SP at the clinic this week.##',80,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (282,0,'2010-04-26 00:00:00','TEXT','You have missed a dose of SP, a drug which protects you from malaria.Malaria can kill U&your unborn baby,so go to the clinic NOW to get protection.',81,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (283,0,'2010-04-26 00:00:00','TEXT','You have missed a dose of SP, a drug which protects you from malaria.Malaria can kill U&your unborn baby,so go to the clinic NOW to get protection@@.',81,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (284,0,'2010-04-26 00:00:00','TEXT','You have missed a dose of SP, a drug which protects you from malaria.Malaria can kill U&your unborn baby,so go to the clinic NOW to get protection##.',81,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (285,0,'2010-04-26 00:00:00','TEXT','This week you are due for an antenatal appointment so make sure to go to the health facility. Antenatal care helps you stay healthy during pregnancy.',82,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (286,0,'2010-04-26 00:00:00','TEXT','This week you are due for an antenatal appointment so make sure to go to the health facility. Antenatal care helps you stay healthy during pregnancy@@.',82,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (287,0,'2010-04-26 00:00:00','TEXT','This week you are due for an antenatal appointment so make sure to go to the health facility. Antenatal care helps you stay healthy during pregnancy.##',82,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (288,0,'2010-04-26 00:00:00','TEXT','U have missed an antenatal care appointment!Antenatal care is very important to keep U&baby healthy so do not delay in going to clinic.Make sure to go THIS WEEK.',83,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (289,0,'2010-04-26 00:00:00','TEXT','U have missed an antenatal care appointment!Antenatal care is very important to keep U&baby healthy so do not delay in going to clinic.Make sure to go THIS WEEK@@',83,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (290,0,'2010-04-26 00:00:00','TEXT','U have missed an antenatal care appointment!Antenatal care is very important to keep U&baby healthy so do not delay in going to clinic.Make sure to go THIS WEEK##',83,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (291,0,'2010-04-26 00:00:00','TEXT','This week U need to have a post natal care visit to make sure that U are recovering well after delivery.Go to the clinic as soon as possible.',84,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (292,0,'2010-04-26 00:00:00','TEXT','This week U need to have a post natal care visit to make sure that U are recovering well after delivery.Go to the clinic as soon as possible@@.',84,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (293,0,'2010-04-26 00:00:00','TEXT','This week U need to have a post natal care visit to make sure that U are recovering well after delivery.Go to the clinic as soon as possible.##',84,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (294,0,'2010-04-26 00:00:00','TEXT','U have missed a post natal care visit.These are VERY important for checking U are recovering from delivery.Even if U dont feel sick,go to the clinic',85,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (295,0,'2010-04-26 00:00:00','TEXT','U have missed a post natal care visit.These are VERY important for checking U are recovering from delivery.Even if U dont feel sick,go to the clinic@@',85,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (296,0,'2010-04-26 00:00:00','TEXT','U have missed a post natal care visit.These are VERY important for checking U are recovering from delivery.Even if U dont feel sick,go to the clinic##',85,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (297,0,'2010-04-26 00:00:00','TEXT','Your baby needs to go for a post natal care visit.This is VERY important to keep baby healthy.Do not delay.Go to the clinic as soon as possible.',86,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (298,0,'2010-04-26 00:00:00','TEXT','Your baby needs to go for a post natal care visit.This is VERY important to keep baby healthy.Do not delay.Go to the clinic as soon as possible.@@',86,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (299,0,'2010-04-26 00:00:00','TEXT','Your baby needs to go for a post natal care visit.This is VERY important to keep baby healthy.Do not delay.Go to the clinic as soon as possible.##',86,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (300,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a postnatal care visit.By missing this visit your baby is at risk.Do not delay.Take your baby for a check up at the clinic as soon as possible.',87,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (301,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a postnatal care visit.By missing this visit your baby is at risk.Do not delay.Take your baby for a check up at the clinic as soon as possible.@@',87,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (302,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a postnatal care visit.By missing this visit your baby is at risk.Do not delay.Take your baby for a check up at the clinic as soon as possible.##',87,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (303,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.',88,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (304,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.@@',88,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (305,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.##',88,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (306,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.',89,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (307,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.@@',89,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (308,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.##',89,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (309,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.',90,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (310,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe@@.',90,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (311,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.##',90,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (312,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.',91,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (313,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe@@.',91,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (314,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe##.',91,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (315,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.',92,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (316,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe@@.',92,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (317,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe##.',92,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (318,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.',93,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (319,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe@@.',93,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (320,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe##.',93,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (321,0,'2010-04-26 00:00:00','TEXT','Your baby needs medication to protect from malaria this week.Malaria is very dangerous for babies so make sure to go to the clinic as soon as possible.',94,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (322,0,'2010-04-26 00:00:00','TEXT','Your baby needs medication to protect from malaria this week.Malaria is very dangerous for babies so make sure to go to the clinic as soon as possible@@.',94,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (323,0,'2010-04-26 00:00:00','TEXT','Your baby needs medication to protect from malaria this week.Malaria is very dangerous for babies so make sure to go to the clinic as soon as possible.##',94,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (324,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a dose of a drug to protect against malaria.Malaria can kill babies.Go to the clinic straight away to get this drug&keep your baby safe.',95,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (325,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a dose of a drug to protect against malaria.Malaria can kill babies.Go to the clinic straight away to get this drug&keep your baby safe@@.',95,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (326,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a dose of a drug to protect against malaria.Malaria can kill babies.Go to the clinic straight away to get this drug&keep your baby safe##.',95,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (327,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.',96,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (328,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.@@',96,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (329,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.##',96,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (330,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.',97,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (331,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.@@',97,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (332,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.##',97,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (333,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.',98,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (334,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.@@',98,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (335,0,'2010-04-26 00:00:00','TEXT','Your baby needs an immunization.These protect your baby from diseases which can kill.Make sure to go to the clinic as soon as possible to keep your child safe.##',98,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (336,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.',99,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (337,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.@@',99,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (338,0,'2010-04-26 00:00:00','TEXT','Your baby has missed an immunization.These protect babies from diseases that can kill them,so take your baby to the facility to keep him or her safe.##',99,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (339,0,'2010-04-26 00:00:00','TEXT','Your baby needs a dose of Vitamin A.This helps to keep him or her healthy.Make sure to take your baby to the clinic for Vitamin A this week.',100,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (340,0,'2010-04-26 00:00:00','TEXT','Your baby needs a dose of Vitamin A.This helps to keep him or her healthy.Make sure to take your baby to the clinic for Vitamin A this week.@@',100,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (341,0,'2010-04-26 00:00:00','TEXT','Your baby needs a dose of Vitamin A.This helps to keep him or her healthy.Make sure to take your baby to the clinic for Vitamin A this week.##',100,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (342,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a dose of Vitamin A.This helps keep baby healthy,so take him or her to the health facility soon.',101,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (343,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a dose of Vitamin A.This helps keep baby healthy,so take him or her to the health facility soon.@@',101,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (344,0,'2010-04-26 00:00:00','TEXT','Your baby has missed a dose of Vitamin A.This helps keep baby healthy,so take him or her to the health facility soon.##',101,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (345,0,'2010-04-26 00:00:00','TEXT','Congratulations! Your patient, <PreferredName> <LastName>, in <Community> has just delivered. Please see her immediately to register the new baby and provide post-natal care',102,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (346,0,'2010-04-26 00:00:00','TEXT','Congratulations! Your patient, <PreferredName> <LastName>, in <Community> has just delivered. Please see her immediately to register the new baby and provide post-natal care@@',102,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (347,0,'2010-04-26 00:00:00','TEXT','Congratulations! Your patient, <PreferredName> <LastName>, in <Community> has just delivered. Please see her immediately to register the new baby and provide post-natal care##',102,3);

/**Pregnant parent SMS**/
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (348,0,'2010-04-30 00:00:00','TEXT','If U are pregnant&feel like hiding it for now,its normal.But remember the evil eye does not bring problems in pregnancy,most problems are because of things that can be treated if U go to clinic early.If U miss a period or think U are pregnant go to clinic NOW!Dont fear-midwives want to make sure U stay healthy&have a healthy baby.They will keep your secret.U get National Health Insurance free for 1year when pregnant so register now.*From Mobile Midwife*',104,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (349,0,'2010-04-30 00:00:00','TEXT','If U are pregnant&feel like hiding it for now,its normal.But remember the evil eye does not bring problems in pregnancy,most problems are because of things that can be treated if U go to clinic early.If U miss a period or think U are pregnant go to clinic NOW!Dont fear-midwives want to make sure U stay healthy&have a healthy baby.They will keep your secret.U get National Health Insurance free for 1year when pregnant so register now.*From Mobile Midwife*@@',104,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (350,0,'2010-04-30 00:00:00','TEXT','If U are pregnant&feel like hiding it for now,its normal.But remember the evil eye does not bring problems in pregnancy,most problems are because of things that can be treated if U go to clinic early.If U miss a period or think U are pregnant go to clinic NOW!Dont fear-midwives want to make sure U stay healthy&have a healthy baby.They will keep your secret.U get National Health Insurance free for 1year when pregnant so register now.*From Mobile Midwife*##',104,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (351,0,'2010-04-30 00:00:00','TEXT','Our ancestors didnt know the effects of foods on a mother&her baby so we were told not to eat some food.Now doctors know that there is no harm in eating certain foods.Maybe U have been told not to eat eggs,meat,fruits,okro or other foods while pregnant because the baby will be a thief or have other problems.There are no proven harmful effects for the baby from eating these foods.They are very good for the baby''s health so try to eat them.*From Mobile Midwife*',105,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (352,0,'2010-04-30 00:00:00','TEXT','Our ancestors didnt know the effects of foods on a mother&her baby so we were told not to eat some food.Now doctors know that there is no harm in eating certain foods.Maybe U have been told not to eat eggs,meat,fruits,okro or other foods while pregnant because the baby will be a thief or have other problems.There are no proven harmful effects for the baby from eating these foods.They are very good for the baby''s health so try to eat them.*From Mobile Midwife*@@',105,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (353,0,'2010-04-30 00:00:00','TEXT','Our ancestors didnt know the effects of foods on a mother&her baby so we were told not to eat some food.Now doctors know that there is no harm in eating certain foods.Maybe U have been told not to eat eggs,meat,fruits,okro or other foods while pregnant because the baby will be a thief or have other problems.There are no proven harmful effects for the baby from eating these foods.They are very good for the baby''s health so try to eat them.*From Mobile Midwife*##',105,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (354,0,'2010-04-30 00:00:00','TEXT','Now your baby''s body is forming.U must eat well to help baby grow well.Eat lots of greens like nkontomire,alefu&garden eggs,okro&tomatoes.Protein like beans,egushi,neri,groundnut,eggs,fish&meat help baby grow.Fruit is important like oranges,bananas,pineapples,shea fruits,mangoes,pawpaw&melons.The midwife will give U iron&folic acid tablets to take which are for preventing low blood&helping the baby''s brain grow well.*From Mobile Midwife*',106,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (355,0,'2010-04-30 00:00:00','TEXT','Now your baby''s body is forming.U must eat well to help baby grow well.Eat lots of greens like nkontomire,alefu&garden eggs,okro&tomatoes.Protein like beans,egushi,neri,groundnut,eggs,fish&meat help baby grow.Fruit is important like oranges,bananas,pineapples,shea fruits,mangoes,pawpaw&melons.The midwife will give U iron&folic acid tablets to take which are for preventing low blood&helping the baby''s brain grow well.*From Mobile Midwife*@@',106,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (356,0,'2010-04-30 00:00:00','TEXT','Now your baby''s body is forming.U must eat well to help baby grow well.Eat lots of greens like nkontomire,alefu&garden eggs,okro&tomatoes.Protein like beans,egushi,neri,groundnut,eggs,fish&meat help baby grow.Fruit is important like oranges,bananas,pineapples,shea fruits,mangoes,pawpaw&melons.The midwife will give U iron&folic acid tablets to take which are for preventing low blood&helping the baby''s brain grow well.*From Mobile Midwife*##',106,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (357,0,'2010-04-30 00:00:00','TEXT','When pregnant there are reasons that U must go to clinic right away.If U have a bad headache,fever or vomiting.If U feel pain in the womb,or a very strong pain on 1 side of your body.If U are bleeding or more important if bleeding is heavy&painful.If U have dark yellow urine or blood&a burning feeling when you urinate.If U are very dizzy or have a very fast heartbeat.Don''t be afraid to go to the clinic as the problem may be easy to cure.*From Mobile Midwife*',107,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (358,0,'2010-04-30 00:00:00','TEXT','When pregnant there are reasons that U must go to clinic right away.If U have a bad headache,fever or vomiting.If U feel pain in the womb,or a very strong pain on 1 side of your body.If U are bleeding or more important if bleeding is heavy&painful.If U have dark yellow urine or blood&a burning feeling when you urinate.If U are very dizzy or have a very fast heartbeat.Don''t be afraid to go to the clinic as the problem may be easy to cure.*From Mobile Midwife*@@',107,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (359,0,'2010-04-30 00:00:00','TEXT','When pregnant there are reasons that U must go to clinic right away.If U have a bad headache,fever or vomiting.If U feel pain in the womb,or a very strong pain on 1 side of your body.If U are bleeding or more important if bleeding is heavy&painful.If U have dark yellow urine or blood&a burning feeling when you urinate.If U are very dizzy or have a very fast heartbeat.Don''t be afraid to go to the clinic as the problem may be easy to cure.*From Mobile Midwife*##',107,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (360,0,'2010-04-30 00:00:00','TEXT','Once you know U are pregnant U should register with NHIS for a full year of free medical care.NHIS also covers the first 6 weeks of your baby''s life.It is important to go to antenatal care clinic so U are sure U are healthy for this baby.U will be given free vitamins to keep U&baby healthy during the pregnancy&U can ask questions about how U are both doing.Antenatal is at your nearest CHPS compound daily.*From Mobile Midwife*',108,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (361,0,'2010-04-30 00:00:00','TEXT','Once you know U are pregnant U should register with NHIS for a full year of free medical care.NHIS also covers the first 6 weeks of your baby''s life.It is important to go to antenatal care clinic so U are sure U are healthy for this baby.U will be given free vitamins to keep U&baby healthy during the pregnancy&U can ask questions about how U are both doing.Antenatal is at your nearest CHPS compound daily.*From Mobile Midwife*@@',108,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (362,0,'2010-04-30 00:00:00','TEXT','Once you know U are pregnant U should register with NHIS for a full year of free medical care.NHIS also covers the first 6 weeks of your baby''s life.It is important to go to antenatal care clinic so U are sure U are healthy for this baby.U will be given free vitamins to keep U&baby healthy during the pregnancy&U can ask questions about how U are both doing.Antenatal is at your nearest CHPS compound daily.*From Mobile Midwife*##',108,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (363,0,'2010-04-30 00:00:00','TEXT','Now that U are pregnant U are not sick but you must be a bit careful.Rough movements&heavy work can cause body pains&damage your body so please ask for help when doing heavy work like fetching firewood or water.Remember to take plenty of clean water,ginger beer or zonkom when working to help keep your body cool&try to avoid working in the very hot afternoon sun.If U can,try to find a shady place to do your work.*From Mobile Midwife*',109,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (364,0,'2010-04-30 00:00:00','TEXT','Now that U are pregnant U are not sick but you must be a bit careful.Rough movements&heavy work can cause body pains&damage your body so please ask for help when doing heavy work like fetching firewood or water.Remember to take plenty of clean water,ginger beer or zonkom when working to help keep your body cool&try to avoid working in the very hot afternoon sun.If U can,try to find a shady place to do your work.*From Mobile Midwife*@@',109,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (365,0,'2010-04-30 00:00:00','TEXT','Now that U are pregnant U are not sick but you must be a bit careful.Rough movements&heavy work can cause body pains&damage your body so please ask for help when doing heavy work like fetching firewood or water.Remember to take plenty of clean water,ginger beer or zonkom when working to help keep your body cool&try to avoid working in the very hot afternoon sun.If U can,try to find a shady place to do your work.*From Mobile Midwife*##',109,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (366,0,'2010-04-30 00:00:00','TEXT','Even though U are not big yet,your baby''s heart&brain are growing fast.As your womb grows U may have some light cramps&waist pain.U need to eat well now for your baby.Please avoid eating clay,ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor or midwife before using any traditional medicines.*From Mobile Midwife*',110,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (367,0,'2010-04-30 00:00:00','TEXT','Even though U are not big yet,your baby''s heart&brain are growing fast.As your womb grows U may have some light cramps&waist pain.U need to eat well now for your baby.Please avoid eating clay,ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor or midwife before using any traditional medicines.*From Mobile Midwife*',110,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (368,0,'2010-04-30 00:00:00','TEXT','Even though U are not big yet,your baby''s heart&brain are growing fast.As your womb grows U may have some light cramps&waist pain.U need to eat well now for your baby.Please avoid eating clay,ayilo or shrei.It can cause low blood,infection or worms.Try chewing on biscuits or vegetables instead.Don''t smoke or take alcohol including Guiness as it will damage the baby.Please ask your doctor or midwife before using any traditional medicines.*From Mobile Midwife*',110,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (369,0,'2010-04-30 00:00:00','TEXT','If U are feeling tired&weak now don''t worry,it is a natural part of pregnancy.Your body is working hard to grow the baby&it can make U feel very tired&sometimes your body feels very weak.As U grow bigger U will feel the weight on your body&if U are worrying too much U may not sleep at night.Try to rest when U can.Ask for help with heavy work like fetching water or firewood.Try to take time to relax your body & your mind when you can.*From Mobile Midwife*',111,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (370,0,'2010-04-30 00:00:00','TEXT','If U are feeling tired&weak now don''t worry,it is a natural part of pregnancy.Your body is working hard to grow the baby&it can make U feel very tired&sometimes your body feels very weak.As U grow bigger U will feel the weight on your body&if U are worrying too much U may not sleep at night.Try to rest when U can.Ask for help with heavy work like fetching water or firewood.Try to take time to relax your body & your mind when you can.*From Mobile Midwife*@@',111,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (371,0,'2010-04-30 00:00:00','TEXT','If U are feeling tired&weak now don''t worry,it is a natural part of pregnancy.Your body is working hard to grow the baby&it can make U feel very tired&sometimes your body feels very weak.As U grow bigger U will feel the weight on your body&if U are worrying too much U may not sleep at night.Try to rest when U can.Ask for help with heavy work like fetching water or firewood.Try to take time to relax your body & your mind when you can.*From Mobile Midwife*##',111,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (372,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage-where you lose the baby.Help yourself by sleeping under insecticide treated nets.Soon U will be given a drug calleed SP at clinic to protect U from malaria.Wear long clothes in light colors in the evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the room.Go to the clinic STRAIGHT AWAY if U are feeling cold or have headache.*From Mobile Midwife*',112,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (373,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage-where you lose the baby.Help yourself by sleeping under insecticide treated nets.Soon U will be given a drug calleed SP at clinic to protect U from malaria.Wear long clothes in light colors in the evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the room.Go to the clinic STRAIGHT AWAY if U are feeling cold or have headache.*From Mobile Midwife*@@',112,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (374,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage-where you lose the baby.Help yourself by sleeping under insecticide treated nets.Soon U will be given a drug calleed SP at clinic to protect U from malaria.Wear long clothes in light colors in the evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the room.Go to the clinic STRAIGHT AWAY if U are feeling cold or have headache.*From Mobile Midwife*##',112,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (375,0,'2010-04-30 00:00:00','TEXT','How are U feeling this week?Baby is growing.He or she may be moving now& U will be able to feel it with time.Pregnancy is nice but there are some things U must get ready.Start by putting down some money each week for things for the baby. You don''t need too much.Important things are baby napkins,dresses for U&baby,cot sheets sewn from aligudon,soap,towels,powder,shea butter,disenfectant like Camel & sanitary towels for U.*From Mobile Midwife*',113,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (376,0,'2010-04-30 00:00:00','TEXT','How are U feeling this week?Baby is growing.He or she may be moving now& U will be able to feel it with time.Pregnancy is nice but there are some things U must get ready.Start by putting down some money each week for things for the baby. You don''t need too much.Important things are baby napkins,dresses for U&baby,cot sheets sewn from aligudon,soap,towels,powder,shea butter,disenfectant like Camel & sanitary towels for U.*From Mobile Midwife*',113,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (377,0,'2010-04-30 00:00:00','TEXT','How are U feeling this week?Baby is growing.He or she may be moving now& U will be able to feel it with time.Pregnancy is nice but there are some things U must get ready.Start by putting down some money each week for things for the baby. You don''t need too much.Important things are baby napkins,dresses for U&baby,cot sheets sewn from aligudon,soap,towels,powder,shea butter,disenfectant like Camel & sanitary towels for U.*From Mobile Midwife*',113,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (378,0,'2010-04-30 00:00:00','TEXT','For baby to grow well U must eat well.U may have been told not to eat some foods but there is no proof they will harm your baby.Try to eat energy foods-maize,all grains,oats,plantain,cassava,yams.Body building foods are good-this is beans&peas,egushie groundnut,meat,chicken,fowl,fish.Protective foods are important-this is greens,okro,tomatoes&garden eggs&all fruits too.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',114,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (379,0,'2010-04-30 00:00:00','TEXT','For baby to grow well U must eat well.U may have been told not to eat some foods but there is no proof they will harm your baby.Try to eat energy foods-maize,all grains,oats,plantain,cassava,yams.Body building foods are good-this is beans&peas,egushie groundnut,meat,chicken,fowl,fish.Protective foods are important-this is greens,okro,tomatoes&garden eggs&all fruits too.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',114,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (380,0,'2010-04-30 00:00:00','TEXT','For baby to grow well U must eat well.U may have been told not to eat some foods but there is no proof they will harm your baby.Try to eat energy foods-maize,all grains,oats,plantain,cassava,yams.Body building foods are good-this is beans&peas,egushie groundnut,meat,chicken,fowl,fish.Protective foods are important-this is greens,okro,tomatoes&garden eggs&all fruits too.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',114,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (381,0,'2010-04-30 00:00:00','TEXT','Lots of pregnant women get constipation-when you cant go to toilet easily.Pressure of the growing baby on your system can slow food going down.Its usually not serious.To solve constipation eat grains,fruits&vegetables.Drink 8-10 glasses of juice or clean water each day.If U get piles see your midwife for treatment.Don''t take any herbal or traditional rememdies or enemas.Ask your midwife first as some medicines can cause miscarriage.*From Mobile Midwife*',115,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (382,0,'2010-04-30 00:00:00','TEXT','Lots of pregnant women get constipation-when you cant go to toilet easily.Pressure of the growing baby on your system can slow food going down.Its usually not serious.To solve constipation eat grains,fruits&vegetables.Drink 8-10 glasses of juice or clean water each day.If U get piles see your midwife for treatment.Don''t take any herbal or traditional rememdies or enemas.Ask your midwife first as some medicines can cause miscarriage.*From Mobile Midwife*@@',115,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (383,0,'2010-04-30 00:00:00','TEXT','Lots of pregnant women get constipation-when you cant go to toilet easily.Pressure of the growing baby on your system can slow food going down.Its usually not serious.To solve constipation eat grains,fruits&vegetables.Drink 8-10 glasses of juice or clean water each day.If U get piles see your midwife for treatment.Don''t take any herbal or traditional rememdies or enemas.Ask your midwife first as some medicines can cause miscarriage.*From Mobile Midwife*##',115,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (384,0,'2010-04-30 00:00:00','TEXT','Bleeding in early pregnancy can make U worry but it is common.There are a few reasons for it happening.1.As the baby is settling in the womb U may have small bleeding for a day or two. 2.You might bleed small at the normal time for your period. 3.It could be from an infection. It is important to tell your midwife right away even if it is only small bleeding.Always report to the clinic straight away if bleeding is heavy or is painful.*From Mobile Midwife*',116,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (385,0,'2010-04-30 00:00:00','TEXT','Bleeding in early pregnancy can make U worry but it is common.There are a few reasons for it happening.1.As the baby is settling in the womb U may have small bleeding for a day or two. 2.You might bleed small at the normal time for your period. 3.It could be from an infection. It is important to tell your midwife right away even if it is only small bleeding.Always report to the clinic straight away if bleeding is heavy or is painful.*From Mobile Midwife*@@',116,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (386,0,'2010-04-30 00:00:00','TEXT','Bleeding in early pregnancy can make U worry but it is common.There are a few reasons for it happening.1.As the baby is settling in the womb U may have small bleeding for a day or two. 2.You might bleed small at the normal time for your period. 3.It could be from an infection. It is important to tell your midwife right away even if it is only small bleeding.Always report to the clinic straight away if bleeding is heavy or is painful.*From Mobile Midwife*##',116,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (387,0,'2010-04-30 00:00:00','TEXT','There are some lab tests to do during pregnancy to make sure all is well.Some test for infection,some check blood level&type.Make sure U do the tests so any problems can be treated early.All pregnant women are offered HIV test&counselling.This is important so if U are infected U can protect your baby from the virus.If positive then U will also be given medicines to keep U healthy.Test results are kept secret so no one will know your results.*From Mobile Midwife*',117,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (388,0,'2010-04-30 00:00:00','TEXT','There are some lab tests to do during pregnancy to make sure all is well.Some test for infection,some check blood level&type.Make sure U do the tests so any problems can be treated early.All pregnant women are offered HIV test&counselling.This is important so if U are infected U can protect your baby from the virus.If positive then U will also be given medicines to keep U healthy.Test results are kept secret so no one will know your results.*From Mobile Midwife*@@',117,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (389,0,'2010-04-30 00:00:00','TEXT','There are some lab tests to do during pregnancy to make sure all is well.Some test for infection,some check blood level&type.Make sure U do the tests so any problems can be treated early.All pregnant women are offered HIV test&counselling.This is important so if U are infected U can protect your baby from the virus.If positive then U will also be given medicines to keep U healthy.Test results are kept secret so no one will know your results.*From Mobile Midwife*##',117,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (390,0,'2010-04-30 00:00:00','TEXT','Your breasts may be painful now.This is normal during pregnancy&breastfeeding.Why do they pain?Your breasts are growing&parts that bring milk are developing.The pain will go but wearing a good bra will help.If U cant cope with the pain or U have any red,hot spots report to your midwife.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',118,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (391,0,'2010-04-30 00:00:00','TEXT','Your breasts may be painful now.This is normal during pregnancy&breastfeeding.Why do they pain?Your breasts are growing&parts that bring milk are developing.The pain will go but wearing a good bra will help.If U cant cope with the pain or U have any red,hot spots report to your midwife.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',118,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (392,0,'2010-04-30 00:00:00','TEXT','Your breasts may be painful now.This is normal during pregnancy&breastfeeding.Why do they pain?Your breasts are growing&parts that bring milk are developing.The pain will go but wearing a good bra will help.If U cant cope with the pain or U have any red,hot spots report to your midwife.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',118,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (393,0,'2010-04-30 00:00:00','TEXT','All your baby''s body parts are there now but not fully formed yet.U might not look pregnant but your waist is getting thicker. Are U feeling tired&sick now?It is normal&here are a few tips to help U cope. 1.U feel worse if hungry or worried so eat well&try to relax. 2.Take lots of water in small bits through day. 3.Don''t eat heavy,spicy or oily food. 4.Take your tablets for the health of baby&talk to midwife if it is too much*From Mobile Midwife*',119,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (394,0,'2010-04-30 00:00:00','TEXT','All your baby''s body parts are there now but not fully formed yet.U might not look pregnant but your waist is getting thicker. Are U feeling tired&sick now?It is normal&here are a few tips to help U cope. 1.U feel worse if hungry or worried so eat well&try to relax. 2.Take lots of water in small bits through day. 3.Don''t eat heavy,spicy or oily food. 4.Take your tablets for the health of baby&talk to midwife if it is too much*From Mobile Midwife*@@',119,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (395,0,'2010-04-30 00:00:00','TEXT','All your baby''s body parts are there now but not fully formed yet.U might not look pregnant but your waist is getting thicker. Are U feeling tired&sick now?It is normal&here are a few tips to help U cope. 1.U feel worse if hungry or worried so eat well&try to relax. 2.Take lots of water in small bits through day. 3.Don''t eat heavy,spicy or oily food. 4.Take your tablets for the health of baby&talk to midwife if it is too much*From Mobile Midwife*##',119,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (396,0,'2010-04-30 00:00:00','TEXT','Needing to urinate a lot is a normal part of pregnancy.The weight of growing baby presses on the bladder which makes U feel the urge to go.Try to drink less water before bed.If U feel pain or burning when U go you may have infection.See your midwife right away for treatment.Urinating often will go away when the baby is born but for now to try to drink less tea,coffee &cola.Instead try water&fresh fruit juice.*From Mobile Midwife*',120,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (397,0,'2010-04-30 00:00:00','TEXT','Needing to urinate a lot is a normal part of pregnancy.The weight of growing baby presses on the bladder which makes U feel the urge to go.Try to drink less water before bed.If U feel pain or burning when U go you may have infection.See your midwife right away for treatment.Urinating often will go away when the baby is born but for now to try to drink less tea,coffee &cola.Instead try water&fresh fruit juice.*From Mobile Midwife*@@',120,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (398,0,'2010-04-30 00:00:00','TEXT','Needing to urinate a lot is a normal part of pregnancy.The weight of growing baby presses on the bladder which makes U feel the urge to go.Try to drink less water before bed.If U feel pain or burning when U go you may have infection.See your midwife right away for treatment.Urinating often will go away when the baby is born but for now to try to drink less tea,coffee &cola.Instead try water&fresh fruit juice.*From Mobile Midwife*##',120,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (399,0,'2010-04-30 00:00:00','TEXT','Medications can be very dangerous for your unborn baby.Don''t take anything that is not given to U by your midwife or doctor.Don''t drink alcohol or smoke while pregnant.It can cause your baby to be born early or too small.Herbal&traditional medicine may not be safe for your baby-talk to your midwife or doctor first.Try to relax& drink lots of water for headaches.If U get aches or pains ask your doctor about which pain medicines are safe.*From Mobile Midwife*',121,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (400,0,'2010-04-30 00:00:00','TEXT','Medications can be very dangerous for your unborn baby.Don''t take anything that is not given to U by your midwife or doctor.Don''t drink alcohol or smoke while pregnant.It can cause your baby to be born early or too small.Herbal&traditional medicine may not be safe for your baby-talk to your midwife or doctor first.Try to relax& drink lots of water for headaches.If U get aches or pains ask your doctor about which pain medicines are safe.*From Mobile Midwife*@@',121,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (401,0,'2010-04-30 00:00:00','TEXT','Medications can be very dangerous for your unborn baby.Don''t take anything that is not given to U by your midwife or doctor.Don''t drink alcohol or smoke while pregnant.It can cause your baby to be born early or too small.Herbal&traditional medicine may not be safe for your baby-talk to your midwife or doctor first.Try to relax& drink lots of water for headaches.If U get aches or pains ask your doctor about which pain medicines are safe.*From Mobile Midwife*##',121,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (402,0,'2010-04-30 00:00:00','TEXT','Even though people may tell U not to have sex when pregnant,gentle sex is safe.If you&your partner feel OK with it then go ahead.If U have bleeding or pain then stop&speak to your midwife.If U have had miscarriages or sexually transmitted infections then talk to your midwife first.If U or your partner are HIV positive use condoms EVERY TIME.If U have itching down there or a change in your discharge get treated straight away at the clinic.*From Mobile Midwife*',122,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (403,0,'2010-04-30 00:00:00','TEXT','Even though people may tell U not to have sex when pregnant,gentle sex is safe.If you&your partner feel OK with it then go ahead.If U have bleeding or pain then stop&speak to your midwife.If U have had miscarriages or sexually transmitted infections then talk to your midwife first.If U or your partner are HIV positive use condoms EVERY TIME.If U have itching down there or a change in your discharge get treated straight away at the clinic.*From Mobile Midwife*@@',122,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (404,0,'2010-04-30 00:00:00','TEXT','Even though people may tell U not to have sex when pregnant,gentle sex is safe.If you&your partner feel OK with it then go ahead.If U have bleeding or pain then stop&speak to your midwife.If U have had miscarriages or sexually transmitted infections then talk to your midwife first.If U or your partner are HIV positive use condoms EVERY TIME.If U have itching down there or a change in your discharge get treated straight away at the clinic.*From Mobile Midwife*##',122,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (405,0,'2010-04-30 00:00:00','TEXT','As your muscles are stretching to fit your growing baby U may start seeing stretch marks.U may also notice a dark line running up your belly.This line fades after birth.Your nipples may be getting darker too but this will also fade after birth.For stretch marks,try not to gain weight too fast,eat healthy&rub your skin with shea butter.Eating groundnuts,cashews,coconut &peas might also help.*From Mobile Midwife*',123,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (406,0,'2010-04-30 00:00:00','TEXT','As your muscles are stretching to fit your growing baby U may start seeing stretch marks.U may also notice a dark line running up your belly.This line fades after birth.Your nipples may be getting darker too but this will also fade after birth.For stretch marks,try not to gain weight too fast,eat healthy&rub your skin with shea butter.Eating groundnuts,cashews,coconut &peas might also help.*From Mobile Midwife*@@',123,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (407,0,'2010-04-30 00:00:00','TEXT','As your muscles are stretching to fit your growing baby U may start seeing stretch marks.U may also notice a dark line running up your belly.This line fades after birth.Your nipples may be getting darker too but this will also fade after birth.For stretch marks,try not to gain weight too fast,eat healthy&rub your skin with shea butter.Eating groundnuts,cashews,coconut &peas might also help.*From Mobile Midwife*##',123,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (408,0,'2010-04-30 00:00:00','TEXT','Belly pains or cramps are normal now&not a serious problem.As baby grows the weight puts pressure on your insides which is uncomfortable.If pains are not serious try to ease them by sitting down,put your feet up&relax.Drink plenty clean water.Avoid oily,spicy or heavy food like bean cake in evenings.Call your midwife straight away if pain comes with bleeding,fever,chills or a change in vaginal discharge.*From Mobile Midwife*',124,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (409,0,'2010-04-30 00:00:00','TEXT','Belly pains or cramps are normal now&not a serious problem.As baby grows the weight puts pressure on your insides which is uncomfortable.If pains are not serious try to ease them by sitting down,put your feet up&relax.Drink plenty clean water.Avoid oily,spicy or heavy food like bean cake in evenings.Call your midwife straight away if pain comes with bleeding,fever,chills or a change in vaginal discharge.*From Mobile Midwife*@@',124,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (410,0,'2010-04-30 00:00:00','TEXT','Belly pains or cramps are normal now&not a serious problem.As baby grows the weight puts pressure on your insides which is uncomfortable.If pains are not serious try to ease them by sitting down,put your feet up&relax.Drink plenty clean water.Avoid oily,spicy or heavy food like bean cake in evenings.Call your midwife straight away if pain comes with bleeding,fever,chills or a change in vaginal discharge.*From Mobile Midwife*##',124,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (411,0,'2010-04-30 00:00:00','TEXT','Now you are almost finished with the 1st stage of pregnancy.Just 2 more to go! U should be feeling brighter now with more energy.Now your baby''s heart is beating&all body parts are formed.Your baby is the size of your thumb now & for the next 6 months will grow big,strong&ready for outside world.Congratulations & keep up the good work!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',125,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (412,0,'2010-04-30 00:00:00','TEXT','Now you are almost finished with the 1st stage of pregnancy.Just 2 more to go! U should be feeling brighter now with more energy.Now your baby''s heart is beating&all body parts are formed.Your baby is the size of your thumb now & for the next 6 months will grow big,strong&ready for outside world.Congratulations & keep up the good work!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',125,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (413,0,'2010-04-30 00:00:00','TEXT','Now you are almost finished with the 1st stage of pregnancy.Just 2 more to go! U should be feeling brighter now with more energy.Now your baby''s heart is beating&all body parts are formed.Your baby is the size of your thumb now & for the next 6 months will grow big,strong&ready for outside world.Congratulations & keep up the good work!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',125,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (414,0,'2010-04-30 00:00:00','TEXT','Feeling dizzy now is normal as your blood flow trys to catch up with the baby''s needs.You may feel dizzy if U are hungry.Try to eat something small&healthy to give U some energy like zoomkom,ice kenkey or koko.U can get dizzy if U get up too fast so take time&try to avoid the hot sun.If U have blurred vision,headaches,fast heartbeat,belly pain or vaginal bleeding go to clinic straight as it could be serious.Don''t be afraid to ask for help.*From Mobile Midwife*',126,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (415,0,'2010-04-30 00:00:00','TEXT','Feeling dizzy now is normal as your blood flow trys to catch up with the baby''s needs.You may feel dizzy if U are hungry.Try to eat something small&healthy to give U some energy like zoomkom,ice kenkey or koko.U can get dizzy if U get up too fast so take time&try to avoid the hot sun.If U have blurred vision,headaches,fast heartbeat,belly pain or vaginal bleeding go to clinic straight as it could be serious.Don''t be afraid to ask for help.*From Mobile Midwife*@@',126,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (416,0,'2010-04-30 00:00:00','TEXT','Feeling dizzy now is normal as your blood flow trys to catch up with the baby''s needs.You may feel dizzy if U are hungry.Try to eat something small&healthy to give U some energy like zoomkom,ice kenkey or koko.U can get dizzy if U get up too fast so take time&try to avoid the hot sun.If U have blurred vision,headaches,fast heartbeat,belly pain or vaginal bleeding go to clinic straight as it could be serious.Don''t be afraid to ask for help.*From Mobile Midwife*##',126,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (418,0,'2010-04-30 00:00:00','TEXT','Many women feel like eating strange things during pregnancy like clay,ice or sand.The feeling is from body changes that affect taste&smell.Eating well should meet all your body''s needs.Please avoid eating white clay “ayilo” or “shrei”.It can give U constipation,infections or worms.Worms can lower your blood level (anemia)&drains good nutrients from your blood&hurts your baby.If U feel like chewing something try biscuits,fruits or vegetables.*From Mobile Midwife*',127,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (419,0,'2010-04-30 00:00:00','TEXT','Many women feel like eating strange things during pregnancy like clay,ice or sand.The feeling is from body changes that affect taste&smell.Eating well should meet all your body''s needs.Please avoid eating white clay “ayilo” or “shrei”.It can give U constipation,infections or worms.Worms can lower your blood level (anemia)&drains good nutrients from your blood&hurts your baby.If U feel like chewing something try biscuits,fruits or vegetables.*From Mobile Midwife*@@',127,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (420,0,'2010-04-30 00:00:00','TEXT','Many women feel like eating strange things during pregnancy like clay,ice or sand.The feeling is from body changes that affect taste&smell.Eating well should meet all your body''s needs.Please avoid eating white clay “ayilo” or “shrei”.It can give U constipation,infections or worms.Worms can lower your blood level (anemia)&drains good nutrients from your blood&hurts your baby.If U feel like chewing something try biscuits,fruits or vegetables.*From Mobile Midwife*##',127,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (421,0,'2010-04-30 00:00:00','TEXT','Congratulations for successfully going through the first stage of pregnancy!Have U gone to the midwife yet?Now is the time to go&its even better if you go with the baby''s father.Its good for the father to be involved in the pregnancy.The support is helpful&it is also exciting for the father to learn what U are learning about the baby,taking care of yourself&the baby. Pregnancy is not easy-as U are seeing-so the help is nice*From Mobile Midwife*',128,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (422,0,'2010-04-30 00:00:00','TEXT','Congratulations for successfully going through the first stage of pregnancy!Have U gone to the midwife yet?Now is the time to go&its even better if you go with the baby''s father.Its good for the father to be involved in the pregnancy.The support is helpful&it is also exciting for the father to learn what U are learning about the baby,taking care of yourself&the baby. Pregnancy is not easy-as U are seeing-so the help is nice*From Mobile Midwife*@@',128,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (423,0,'2010-04-30 00:00:00','TEXT','Congratulations for successfully going through the first stage of pregnancy!Have U gone to the midwife yet?Now is the time to go&its even better if you go with the baby''s father.Its good for the father to be involved in the pregnancy.The support is helpful&it is also exciting for the father to learn what U are learning about the baby,taking care of yourself&the baby. Pregnancy is not easy-as U are seeing-so the help is nice*From Mobile Midwife*##',128,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (424,0,'2010-04-30 00:00:00','TEXT','We hope by now U have seen a midwife or doctor.If not,please go for antenatal visit at nearest clinic.It helps make sure U have a healthy pregancy&a well baby.Make sure that after U go to clinic,take the tablets the midwife gives U.The iron is for your blood level,folate is for baby''s brain development&SP is to prevent malaria.They are all very important.Make sure that U do the lab tests to be sure all is well.Also,get your antenatal card.*From Mobile Midwife*',129,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (425,0,'2010-04-30 00:00:00','TEXT','We hope by now U have seen a midwife or doctor.If not,please go for antenatal visit at nearest clinic.It helps make sure U have a healthy pregancy&a well baby.Make sure that after U go to clinic,take the tablets the midwife gives U.The iron is for your blood level,folate is for baby''s brain development&SP is to prevent malaria.They are all very important.Make sure that U do the lab tests to be sure all is well.Also,get your antenatal card.*From Mobile Midwife*@@',129,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (426,0,'2010-04-30 00:00:00','TEXT','We hope by now U have seen a midwife or doctor.If not,please go for antenatal visit at nearest clinic.It helps make sure U have a healthy pregancy&a well baby.Make sure that after U go to clinic,take the tablets the midwife gives U.The iron is for your blood level,folate is for baby''s brain development&SP is to prevent malaria.They are all very important.Make sure that U do the lab tests to be sure all is well.Also,get your antenatal card.*From Mobile Midwife*##',129,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (427,0,'2010-04-30 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood carrying food&oxygen around the body keeping it well.Low iron levels can make U feel tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*',130,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (428,0,'2010-04-30 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood carrying food&oxygen around the body keeping it well.Low iron levels can make U feel tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*@@',130,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (429,0,'2010-04-30 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood carrying food&oxygen around the body keeping it well.Low iron levels can make U feel tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*##',130,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (430,0,'2010-04-30 00:00:00','TEXT','U may be showing your pregnancy now,but your baby is very small-about half the size of a banana.Baby can smile&suck its thumb.U should feel brighter now.If U are still vomitting a lot,see the midwife.Your baby now needs a range of food to grow strong.It is important to eat dairy now,like cow milk,yoghurt,wagashie&soya milk.U should still eat meat,fish,greens,grains&peas.Make sure your salt is iodated to prevent miscarriage&a disabled child.*From Mobile Midwife*',131,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (431,0,'2010-04-30 00:00:00','TEXT','U may be showing your pregnancy now,but your baby is very small-about half the size of a banana.Baby can smile&suck its thumb.U should feel brighter now.If U are still vomitting a lot,see the midwife.Your baby now needs a range of food to grow strong.It is important to eat dairy now,like cow milk,yoghurt,wagashie&soya milk.U should still eat meat,fish,greens,grains&peas.Make sure your salt is iodated to prevent miscarriage&a disabled child.*From Mobile Midwife*@@',131,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (432,0,'2010-04-30 00:00:00','TEXT','U may be showing your pregnancy now,but your baby is very small-about half the size of a banana.Baby can smile&suck its thumb.U should feel brighter now.If U are still vomitting a lot,see the midwife.Your baby now needs a range of food to grow strong.It is important to eat dairy now,like cow milk,yoghurt,wagashie&soya milk.U should still eat meat,fish,greens,grains&peas.Make sure your salt is iodated to prevent miscarriage&a disabled child.*From Mobile Midwife*##',131,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (433,0,'2010-04-30 00:00:00','TEXT','Feeling very tired now is normal as your body works hard to grow to fit the growing baby.As U get bigger it puts strain on your body which can make U feel weak or tired.Try to get rest when you can.Ask family to help with heavy work & heavy lifting.Try not to worry too much about things that are not so important.Take time out of your day to rest until U are feeling better.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',132,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (434,0,'2010-04-30 00:00:00','TEXT','Feeling very tired now is normal as your body works hard to grow to fit the growing baby.As U get bigger it puts strain on your body which can make U feel weak or tired.Try to get rest when you can.Ask family to help with heavy work & heavy lifting.Try not to worry too much about things that are not so important.Take time out of your day to rest until U are feeling better.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',132,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (435,0,'2010-04-30 00:00:00','TEXT','Feeling very tired now is normal as your body works hard to grow to fit the growing baby.As U get bigger it puts strain on your body which can make U feel weak or tired.Try to get rest when you can.Ask family to help with heavy work & heavy lifting.Try not to worry too much about things that are not so important.Take time out of your day to rest until U are feeling better.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',132,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (436,0,'2010-04-30 00:00:00','TEXT','When pregnant your vaginal discharge may be more.The discharge should be mild milky&does not smell strong or bad.Make sure that U keep yourself clean,wear cotton panties&nothing very tight.See your midwife straight away if discharge smells bad,gets thick,yellow,brown,green or U have itching or burning.Dont insert herbs,soap,cloth or water into the birth passage.It can cause infection&serious complications which can damage your baby.*From Mobile Midwife*',133,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (437,0,'2010-04-30 00:00:00','TEXT','When pregnant your vaginal discharge may be more.The discharge should be mild milky&does not smell strong or bad.Make sure that U keep yourself clean,wear cotton panties&nothing very tight.See your midwife straight away if discharge smells bad,gets thick,yellow,brown,green or U have itching or burning.Dont insert herbs,soap,cloth or water into the birth passage.It can cause infection&serious complications which can damage your baby.*From Mobile Midwife*@@',133,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (438,0,'2010-04-30 00:00:00','TEXT','When pregnant your vaginal discharge may be more.The discharge should be mild milky&does not smell strong or bad.Make sure that U keep yourself clean,wear cotton panties&nothing very tight.See your midwife straight away if discharge smells bad,gets thick,yellow,brown,green or U have itching or burning.Dont insert herbs,soap,cloth or water into the birth passage.It can cause infection&serious complications which can damage your baby.*From Mobile Midwife*##',133,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (439,0,'2010-04-30 00:00:00','TEXT','U are nearly 4 months pregnant now.If U havent been to antenatal care (ANC) yet U need to go this week.Its free&best way to make sure U&baby are healthy.U need to join National Health Insurance at ANC,also free for pregnant women.At ANC you will be offered lab tests to check your blood for anaemia (low blood level) infections like syphilis,hepatitis&HIV/AIDS.Testing is important so treatment can be started for a healthy pregnancy & baby.*From Mobile Midwife*',134,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (440,0,'2010-04-30 00:00:00','TEXT','U are nearly 4 months pregnant now.If U havent been to antenatal care (ANC) yet U need to go this week.Its free&best way to make sure U&baby are healthy.U need to join National Health Insurance at ANC,also free for pregnant women.At ANC you will be offered lab tests to check your blood for anaemia (low blood level) infections like syphilis,hepatitis&HIV/AIDS.Testing is important so treatment can be started for a healthy pregnancy & baby.*From Mobile Midwife*@@',134,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (441,0,'2010-04-30 00:00:00','TEXT','U are nearly 4 months pregnant now.If U havent been to antenatal care (ANC) yet U need to go this week.Its free&best way to make sure U&baby are healthy.U need to join National Health Insurance at ANC,also free for pregnant women.At ANC you will be offered lab tests to check your blood for anaemia (low blood level) infections like syphilis,hepatitis&HIV/AIDS.Testing is important so treatment can be started for a healthy pregnancy & baby.*From Mobile Midwife*##',134,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (442,0,'2010-04-30 00:00:00','TEXT','Your baby is still small enough to fit in the palm of your hand but U might start to feel movements soon,like a flutter low down in your belly.As baby grows U need a small amount of Iodine.Without iodine U are at risk for miscarriage&having a child that is mentally or physically disabled.Iodine is in cooking salt&in eggs.Local rock salt may not have iodine,so try to check.U don''t need much so don''t over do it.*From Mobile Midwife*',135,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (443,0,'2010-04-30 00:00:00','TEXT','Your baby is still small enough to fit in the palm of your hand but U might start to feel movements soon,like a flutter low down in your belly.As baby grows U need a small amount of Iodine.Without iodine U are at risk for miscarriage&having a child that is mentally or physically disabled.Iodine is in cooking salt&in eggs.Local rock salt may not have iodine,so try to check.U don''t need much so don''t over do it.*From Mobile Midwife*@@',135,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (444,0,'2010-04-30 00:00:00','TEXT','Your baby is still small enough to fit in the palm of your hand but U might start to feel movements soon,like a flutter low down in your belly.As baby grows U need a small amount of Iodine.Without iodine U are at risk for miscarriage&having a child that is mentally or physically disabled.Iodine is in cooking salt&in eggs.Local rock salt may not have iodine,so try to check.U don''t need much so don''t over do it.*From Mobile Midwife*##',135,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (445,0,'2010-04-30 00:00:00','TEXT','Pregnancy brings lots of worries.There are a lot of changes in your body&a baby will bring changes in life especially financial.To fight worries try a few things to help you feel calmer.1.start putting down small money each wk for baby things 2. Join National Health Insurance for free to help with medical bills. 3.Look for help with work 4.Talk to a friend or family about problems.*From Mobile Midwife*',136,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (446,0,'2010-04-30 00:00:00','TEXT','Pregnancy brings lots of worries.There are a lot of changes in your body&a baby will bring changes in life especially financial.To fight worries try a few things to help you feel calmer.1.start putting down small money each wk for baby things 2. Join National Health Insurance for free to help with medical bills. 3.Look for help with work 4.Talk to a friend or family about problems.*From Mobile Midwife*@@',136,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (447,0,'2010-04-30 00:00:00','TEXT','Pregnancy brings lots of worries.There are a lot of changes in your body&a baby will bring changes in life especially financial.To fight worries try a few things to help you feel calmer.1.start putting down small money each wk for baby things 2. Join National Health Insurance for free to help with medical bills. 3.Look for help with work 4.Talk to a friend or family about problems.*From Mobile Midwife*##',136,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (448,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage.Help yourself by sleeping under insecticide treated nets.Now is the time to get a drug called SP at clinic to protect U.Wear long clothes in light colors in evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the rooms.Go to clinic STRAIGHT AWAY if you are feeling cold,fever or headache.*From Mobile Midwife*',137,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (449,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage.Help yourself by sleeping under insecticide treated nets.Now is the time to get a drug called SP at clinic to protect U.Wear long clothes in light colors in evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the rooms.Go to clinic STRAIGHT AWAY if you are feeling cold,fever or headache.*From Mobile Midwife*@@',137,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (450,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous.It can cause low blood in the mother&miscarriage.Help yourself by sleeping under insecticide treated nets.Now is the time to get a drug called SP at clinic to protect U.Wear long clothes in light colors in evening.Try burning neem leaves or orange peels to keep mosquitos away or spray the rooms.Go to clinic STRAIGHT AWAY if you are feeling cold,fever or headache.*From Mobile Midwife*##',137,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (451,0,'2010-04-30 00:00:00','TEXT','Bleeding at this time in pregnancy could be serious.It may be beacause the placenta is not positioned well,putting baby at risk.If U start bleeding go to the midwife immediately.At worst bleeding may be a sign that the pregnancy is going to end.This can happen even to healthy women.Things like smoking,drinking alcohol,taking some drugs like aspirin/brufen&conditions like fibroids/infections can cause this.Try not to worry,recover&try again.*From Mobile Midwife*',138,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (452,0,'2010-04-30 00:00:00','TEXT','Bleeding at this time in pregnancy could be serious.It may be beacause the placenta is not positioned well,putting baby at risk.If U start bleeding go to the midwife immediately.At worst bleeding may be a sign that the pregnancy is going to end.This can happen even to healthy women.Things like smoking,drinking alcohol,taking some drugs like aspirin/brufen&conditions like fibroids/infections can cause this.Try not to worry,recover&try again.*From Mobile Midwife*@@',138,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (453,0,'2010-04-30 00:00:00','TEXT','Bleeding at this time in pregnancy could be serious.It may be beacause the placenta is not positioned well,putting baby at risk.If U start bleeding go to the midwife immediately.At worst bleeding may be a sign that the pregnancy is going to end.This can happen even to healthy women.Things like smoking,drinking alcohol,taking some drugs like aspirin/brufen&conditions like fibroids/infections can cause this.Try not to worry,recover&try again.*From Mobile Midwife*##',138,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (454,0,'2010-04-30 00:00:00','TEXT','Being pregnant&carrying extra weight can be very uncomfortable especially when it''s hot.Stay out of the hot midday sun if you can,but if you can''t try to keep your head covered.Wear loose cotton clothes.Make sure U drink lots of cool pure water too.Try eating fresh fruits which contain water like watermelon,coconut,oranges&pineapple.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',139,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (455,0,'2010-04-30 00:00:00','TEXT','Being pregnant&carrying extra weight can be very uncomfortable especially when it''s hot.Stay out of the hot midday sun if you can,but if you can''t try to keep your head covered.Wear loose cotton clothes.Make sure U drink lots of cool pure water too.Try eating fresh fruits which contain water like watermelon,coconut,oranges&pineapple.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',139,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (456,0,'2010-04-30 00:00:00','TEXT','Being pregnant&carrying extra weight can be very uncomfortable especially when it''s hot.Stay out of the hot midday sun if you can,but if you can''t try to keep your head covered.Wear loose cotton clothes.Make sure U drink lots of cool pure water too.Try eating fresh fruits which contain water like watermelon,coconut,oranges&pineapple.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',139,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (457,0,'2010-04-30 00:00:00','TEXT','Your womb is growing now which may be causing some waist pains but they will soon go.U are probably showing signs of pregnancy now&may still fear the evil eye.Remember that the evil eye doesn''t cause complications but rather medical conditions cause problems.Its time to go to antenatal care at your nearest clinic.Its free&runs everyday.What you tell the midwife will be kept secret so don''t fear.No one will really know why U are there.*From Mobile Midwife*',140,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (458,0,'2010-04-30 00:00:00','TEXT','Your womb is growing now which may be causing some waist pains but they will soon go.U are probably showing signs of pregnancy now&may still fear the evil eye.Remember that the evil eye doesn''t cause complications but rather medical conditions cause problems.Its time to go to antenatal care at your nearest clinic.Its free&runs everyday.What you tell the midwife will be kept secret so don''t fear.No one will really know why U are there.*From Mobile Midwife*@@',140,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (459,0,'2010-04-30 00:00:00','TEXT','Your womb is growing now which may be causing some waist pains but they will soon go.U are probably showing signs of pregnancy now&may still fear the evil eye.Remember that the evil eye doesn''t cause complications but rather medical conditions cause problems.Its time to go to antenatal care at your nearest clinic.Its free&runs everyday.What you tell the midwife will be kept secret so don''t fear.No one will really know why U are there.*From Mobile Midwife*##',140,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (460,0,'2010-04-30 00:00:00','TEXT','Its good to involve your husband/family as U prepare for baby''s birth.Some tips: 1.know where nearest hospital/clinic is&plan how to get there quick in emergency. 2.All births are safer in a health facility with medical professionals,plan with your midwife 3.know your midwife''s phone number for emergency 3.Put down small money weekly for things needed at delivery-baby napkins,soap,antiseptic,cot sheets,clean clothes for baby&towels.*From Mobile Midwife*',141,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (461,0,'2010-04-30 00:00:00','TEXT','Its good to involve your husband/family as U prepare for baby''s birth.Some tips: 1.know where nearest hospital/clinic is&plan how to get there quick in emergency. 2.All births are safer in a health facility with medical professionals,plan with your midwife 3.know your midwife''s phone number for emergency 3.Put down small money weekly for things needed at delivery-baby napkins,soap,antiseptic,cot sheets,clean clothes for baby&towels.*From Mobile Midwife*@@',141,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (462,0,'2010-04-30 00:00:00','TEXT','Its good to involve your husband/family as U prepare for baby''s birth.Some tips: 1.know where nearest hospital/clinic is&plan how to get there quick in emergency. 2.All births are safer in a health facility with medical professionals,plan with your midwife 3.know your midwife''s phone number for emergency 3.Put down small money weekly for things needed at delivery-baby napkins,soap,antiseptic,cot sheets,clean clothes for baby&towels.*From Mobile Midwife*##',141,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (463,0,'2010-04-30 00:00:00','TEXT','Every pregnancy is different.Its important to go to antenatal clinic to be sure all is well with this one.Dont be afraid,ask questions.The doctor or midwife is there for U. It would be nice for the baby''s father to go with U to the clinic.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure U tell midwife your full medical history.Register with NHIS for 1year of free medical cover.*From Mobile Midwife*',142,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (464,0,'2010-04-30 00:00:00','TEXT','Every pregnancy is different.Its important to go to antenatal clinic to be sure all is well with this one.Dont be afraid,ask questions.The doctor or midwife is there for U. It would be nice for the baby''s father to go with U to the clinic.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure U tell midwife your full medical history.Register with NHIS for 1year of free medical cover.*From Mobile Midwife*@@',142,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (465,0,'2010-04-30 00:00:00','TEXT','Every pregnancy is different.Its important to go to antenatal clinic to be sure all is well with this one.Dont be afraid,ask questions.The doctor or midwife is there for U. It would be nice for the baby''s father to go with U to the clinic.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure U tell midwife your full medical history.Register with NHIS for 1year of free medical cover.*From Mobile Midwife*##',142,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (466,0,'2010-04-30 00:00:00','TEXT','Most women feel fine during pregnancy so try not to worry but its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if its a sharp one-sided pain.Go for bloody or dark yellow urine or burning when U urinate.Go if you have very swollen feet hands or face.Try not to worry just see the midwife.*From Mobile Midwife*',143,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (467,0,'2010-04-30 00:00:00','TEXT','Most women feel fine during pregnancy so try not to worry but its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if its a sharp one-sided pain.Go for bloody or dark yellow urine or burning when U urinate.Go if you have very swollen feet hands or face.Try not to worry just see the midwife.*From Mobile Midwife*@@',143,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (468,0,'2010-04-30 00:00:00','TEXT','Most women feel fine during pregnancy so try not to worry but its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if its a sharp one-sided pain.Go for bloody or dark yellow urine or burning when U urinate.Go if you have very swollen feet hands or face.Try not to worry just see the midwife.*From Mobile Midwife*##',143,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (469,0,'2010-04-30 00:00:00','TEXT','A message for MEN! Have U been to clinic with baby''s mother yet?It is great to be involved in the pregnancy.Its exciting to learn how your baby is growing&expecting mums appreciate support.Helping with household chores,helping her get to antenatal clinic at this time&emotional support go a long way for a happier mum-to-be.Remember that delivery at a health facility is safer for mum&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',144,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (470,0,'2010-04-30 00:00:00','TEXT','A message for MEN! Have U been to clinic with baby''s mother yet?It is great to be involved in the pregnancy.Its exciting to learn how your baby is growing&expecting mums appreciate support.Helping with household chores,helping her get to antenatal clinic at this time&emotional support go a long way for a happier mum-to-be.Remember that delivery at a health facility is safer for mum&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',144,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (471,0,'2010-04-30 00:00:00','TEXT','A message for MEN! Have U been to clinic with baby''s mother yet?It is great to be involved in the pregnancy.Its exciting to learn how your baby is growing&expecting mums appreciate support.Helping with household chores,helping her get to antenatal clinic at this time&emotional support go a long way for a happier mum-to-be.Remember that delivery at a health facility is safer for mum&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',144,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (472,0,'2010-04-30 00:00:00','TEXT','Piles are swellings of tissues around anus.They can cause itching&bleeding after using the toilet.They are common in pregnancy from the pressure of extra weight.Constipation adds to piles.To help,try not to get constipated.Eat lots of fibre like fruits&vegetables.Have piles?After toileting,clean area gently but well.Try not to sit or stand too long&sleep on your side.If nothing helps&they bleed,tell midwife-there is a cream that can help.*From Mobile Midwife*',145,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (473,0,'2010-04-30 00:00:00','TEXT','Piles are swellings of tissues around anus.They can cause itching&bleeding after using the toilet.They are common in pregnancy from the pressure of extra weight.Constipation adds to piles.To help,try not to get constipated.Eat lots of fibre like fruits&vegetables.Have piles?After toileting,clean area gently but well.Try not to sit or stand too long&sleep on your side.If nothing helps&they bleed,tell midwife-there is a cream that can help.*From Mobile Midwife*@@',145,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (474,0,'2010-04-30 00:00:00','TEXT','Piles are swellings of tissues around anus.They can cause itching&bleeding after using the toilet.They are common in pregnancy from the pressure of extra weight.Constipation adds to piles.To help,try not to get constipated.Eat lots of fibre like fruits&vegetables.Have piles?After toileting,clean area gently but well.Try not to sit or stand too long&sleep on your side.If nothing helps&they bleed,tell midwife-there is a cream that can help.*From Mobile Midwife*##',145,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (475,0,'2010-04-30 00:00:00','TEXT','Congratulations! U are about halfway through your pregnancy.Well Done so far! Baby can now kick,roll over,stretch each arm&even suck a thumb.By now most of the major body parts are formed-heart,kidneys,liver&brain are complete but still small.Keep eating well&taking good care of yourself&your baby.If U haven''t been to antenatal clinic yet please go now,even if you feel fine-U need a check up.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',146,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (476,0,'2010-04-30 00:00:00','TEXT','Congratulations! U are about halfway through your pregnancy.Well Done so far! Baby can now kick,roll over,stretch each arm&even suck a thumb.By now most of the major body parts are formed-heart,kidneys,liver&brain are complete but still small.Keep eating well&taking good care of yourself&your baby.If U haven''t been to antenatal clinic yet please go now,even if you feel fine-U need a check up.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',146,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (477,0,'2010-04-30 00:00:00','TEXT','Congratulations! U are about halfway through your pregnancy.Well Done so far! Baby can now kick,roll over,stretch each arm&even suck a thumb.By now most of the major body parts are formed-heart,kidneys,liver&brain are complete but still small.Keep eating well&taking good care of yourself&your baby.If U haven''t been to antenatal clinic yet please go now,even if you feel fine-U need a check up.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',146,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (478,0,'2010-04-30 00:00:00','TEXT','Washing hands is very important to control germs&worms that can make your baby&the rest of your family sick.Hands must be washed with soap or ash&clean water.Always wash hands after using toilet or cleaning a child who has been to toilet.Wash hands after touching animals or raw meat.Wash hands before cooking,serving food or eating.Cover food to protect from germs&cook foods until hot all the way through.Don''t eat meat if pink in the center.*From Mobile Midwife*',147,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (479,0,'2010-04-30 00:00:00','TEXT','Washing hands is very important to control germs&worms that can make your baby&the rest of your family sick.Hands must be washed with soap or ash&clean water.Always wash hands after using toilet or cleaning a child who has been to toilet.Wash hands after touching animals or raw meat.Wash hands before cooking,serving food or eating.Cover food to protect from germs&cook foods until hot all the way through.Don''t eat meat if pink in the center.*From Mobile Midwife*@@',147,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (480,0,'2010-04-30 00:00:00','TEXT','Washing hands is very important to control germs&worms that can make your baby&the rest of your family sick.Hands must be washed with soap or ash&clean water.Always wash hands after using toilet or cleaning a child who has been to toilet.Wash hands after touching animals or raw meat.Wash hands before cooking,serving food or eating.Cover food to protect from germs&cook foods until hot all the way through.Don''t eat meat if pink in the center.*From Mobile Midwife*##',147,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (481,0,'2010-04-30 00:00:00','TEXT','In the next few weeks your baby''s movements will get stronger&more regular.If this is your first pregnancy it is exciting to feel this.Every baby has their own time to be sleeping&awake so if you don''t feel anything baby may be asleep.Later U will be able to encourage your baby to move by lying on your side,supporting your belly,relaxing&playing music for baby.Now try to adjust to the movements-they show your baby is growing well.*From Mobile Midwife*',148,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (482,0,'2010-04-30 00:00:00','TEXT','In the next few weeks your baby''s movements will get stronger&more regular.If this is your first pregnancy it is exciting to feel this.Every baby has their own time to be sleeping&awake so if you don''t feel anything baby may be asleep.Later U will be able to encourage your baby to move by lying on your side,supporting your belly,relaxing&playing music for baby.Now try to adjust to the movements-they show your baby is growing well.*From Mobile Midwife*@@',148,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (483,0,'2010-04-30 00:00:00','TEXT','In the next few weeks your baby''s movements will get stronger&more regular.If this is your first pregnancy it is exciting to feel this.Every baby has their own time to be sleeping&awake so if you don''t feel anything baby may be asleep.Later U will be able to encourage your baby to move by lying on your side,supporting your belly,relaxing&playing music for baby.Now try to adjust to the movements-they show your baby is growing well.*From Mobile Midwife*##',148,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (484,0,'2010-04-30 00:00:00','TEXT','A creamy white substance now coats baby''s body.Some babies still have the coating when born.Its not from having sex during pregnancy-its a natural protection for baby.U may have heard that difficult labor is because mother has been unfaithful-not true!Difficult labor is caused by medical conditions that can usually be managed if medical help is early.Call midwife as soon as U go into labour.Mother&baby''s life can depend on it.*From Mobile Midwife*',149,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (485,0,'2010-04-30 00:00:00','TEXT','A creamy white substance now coats baby''s body.Some babies still have the coating when born.Its not from having sex during pregnancy-its a natural protection for baby.U may have heard that difficult labor is because mother has been unfaithful-not true!Difficult labor is caused by medical conditions that can usually be managed if medical help is early.Call midwife as soon as U go into labour.Mother&baby''s life can depend on it.*From Mobile Midwife*@@',149,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (486,0,'2010-04-30 00:00:00','TEXT','A creamy white substance now coats baby''s body.Some babies still have the coating when born.Its not from having sex during pregnancy-its a natural protection for baby.U may have heard that difficult labor is because mother has been unfaithful-not true!Difficult labor is caused by medical conditions that can usually be managed if medical help is early.Call midwife as soon as U go into labour.Mother&baby''s life can depend on it.*From Mobile Midwife*##',149,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (487,0,'2010-04-30 00:00:00','TEXT','It is good to try to keep up with your normal routine during pregnancy,but as you get bigger try to take things a bit easier.Ask for help with heavy lifting&fetching firewood.If U have asthma,heart problems or diabetes hard work may be harmful.If U have had bleeding,miscarriages in the past or your previous children were born early talk to your midwife about how much hard work U can do.*From Mobile Midwife*',150,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (488,0,'2010-04-30 00:00:00','TEXT','It is good to try to keep up with your normal routine during pregnancy,but as you get bigger try to take things a bit easier.Ask for help with heavy lifting&fetching firewood.If U have asthma,heart problems or diabetes hard work may be harmful.If U have had bleeding,miscarriages in the past or your previous children were born early talk to your midwife about how much hard work U can do.*From Mobile Midwife*@@',150,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (489,0,'2010-04-30 00:00:00','TEXT','It is good to try to keep up with your normal routine during pregnancy,but as you get bigger try to take things a bit easier.Ask for help with heavy lifting&fetching firewood.If U have asthma,heart problems or diabetes hard work may be harmful.If U have had bleeding,miscarriages in the past or your previous children were born early talk to your midwife about how much hard work U can do.*From Mobile Midwife*##',150,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (490,0,'2010-04-30 00:00:00','TEXT','Don''t worry if U find yourself belching lots or feeling bloated.This is normal in pregnancy.Your womb is growing&pushing on your stomach which causes bloating,wind,burping&discomfort in your stomach.Try to eat smaller meals more often through the day.Take time eating&chew your food well.Also wear loose clothes that are not tight around your belly.*From Mobile Midwife*',151,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (491,0,'2010-04-30 00:00:00','TEXT','Don''t worry if U find yourself belching lots or feeling bloated.This is normal in pregnancy.Your womb is growing&pushing on your stomach which causes bloating,wind,burping&discomfort in your stomach.Try to eat smaller meals more often through the day.Take time eating&chew your food well.Also wear loose clothes that are not tight around your belly.*From Mobile Midwife*@@',151,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (492,0,'2010-04-30 00:00:00','TEXT','Don''t worry if U find yourself belching lots or feeling bloated.This is normal in pregnancy.Your womb is growing&pushing on your stomach which causes bloating,wind,burping&discomfort in your stomach.Try to eat smaller meals more often through the day.Take time eating&chew your food well.Also wear loose clothes that are not tight around your belly.*From Mobile Midwife*##',151,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (493,0,'2010-04-30 00:00:00','TEXT','Your baby can hear U now so talk&have your husband talk so baby will know your voices&feel bonded with U.Think about baby''s arrival&your delivery.Do U have transport to hospital or clinic in an emergency?Should U move closer to where U will deliver to save on transport?Have you been to ANC&know your midwifes phone number.Remember all births are safer at a health facility&if it is your 1st baby it is important to be at a clinic or hospital.*From Mobile Midwife*',152,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (494,0,'2010-04-30 00:00:00','TEXT','Your baby can hear U now so talk&have your husband talk so baby will know your voices&feel bonded with U.Think about baby''s arrival&your delivery.Do U have transport to hospital or clinic in an emergency?Should U move closer to where U will deliver to save on transport?Have you been to ANC&know your midwifes phone number.Remember all births are safer at a health facility&if it is your 1st baby it is important to be at a clinic or hospital.*From Mobile Midwife*@@',152,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (495,0,'2010-04-30 00:00:00','TEXT','Your baby can hear U now so talk&have your husband talk so baby will know your voices&feel bonded with U.Think about baby''s arrival&your delivery.Do U have transport to hospital or clinic in an emergency?Should U move closer to where U will deliver to save on transport?Have you been to ANC&know your midwifes phone number.Remember all births are safer at a health facility&if it is your 1st baby it is important to be at a clinic or hospital.*From Mobile Midwife*##',152,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (496,0,'2010-04-30 00:00:00','TEXT','Most women feel fine when pregnant so dont worry.But its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if it is a sharp pain on 1 side.Go for bloody or dark yellow urine or burning when urinating.Go if U have swollen feet hands/face.Also report blurred vision.Don''t fear,just go to the clinic.*From Mobile Midwife*',153,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (497,0,'2010-04-30 00:00:00','TEXT','Most women feel fine when pregnant so dont worry.But its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if it is a sharp pain on 1 side.Go for bloody or dark yellow urine or burning when urinating.Go if U have swollen feet hands/face.Also report blurred vision.Don''t fear,just go to the clinic.*From Mobile Midwife*@@',153,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (498,0,'2010-04-30 00:00:00','TEXT','Most women feel fine when pregnant so dont worry.But its good to be informed about when U must go to clinic.Go if bleeding-it can be serious.Go for headaches,fever,vomitting,feeling dizzy or a blow to the belly.Go if U have pain in the belly,especially if it is a sharp pain on 1 side.Go for bloody or dark yellow urine or burning when urinating.Go if U have swollen feet hands/face.Also report blurred vision.Don''t fear,just go to the clinic.*From Mobile Midwife*##',153,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (499,0,'2010-04-30 00:00:00','TEXT','For baby to grow well U must eat well. U may have been told not to eat some foods but there is no proof they will harm your baby. 3 food groups are energy giving,body building&protective foods.Try to eat items from each group at meals.Energy foods are maize,grains,oats,plantain,cassava,yams.Body building foods are all beans&peas,egushie groundnut,meat,chicken,fowl,fish.Protective foods are greens,okro,tomatoes,garden eggs&all fruits too.*From Mobile Midwife*',154,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (500,0,'2010-04-30 00:00:00','TEXT','For baby to grow well U must eat well. U may have been told not to eat some foods but there is no proof they will harm your baby. 3 food groups are energy giving,body building&protective foods.Try to eat items from each group at meals.Energy foods are maize,grains,oats,plantain,cassava,yams.Body building foods are all beans&peas,egushie groundnut,meat,chicken,fowl,fish.Protective foods are greens,okro,tomatoes,garden eggs&all fruits too.*From Mobile Midwife*@@',154,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (501,0,'2010-04-30 00:00:00','TEXT','For baby to grow well U must eat well. U may have been told not to eat some foods but there is no proof they will harm your baby. 3 food groups are energy giving,body building&protective foods.Try to eat items from each group at meals.Energy foods are maize,grains,oats,plantain,cassava,yams.Body building foods are all beans&peas,egushie groundnut,meat,chicken,fowl,fish.Protective foods are greens,okro,tomatoes,garden eggs&all fruits too.*From Mobile Midwife*##',154,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (502,0,'2010-04-30 00:00:00','TEXT','Tetanus is a serious sickness that enters the body through open wounds,a juke or skin scratch.U are at high risk for tetanus during&after birth because of wounds from delivery.Baby is at risk because the chord is open when born.U must get a tetanus immunization to protect you&baby.U need 2 tetanus jabs before or during pregnancy.Tetanus infection can put U&baby''s life at risk.Tetanus is given at antenatal.One more reason to see the midwife!*From Mobile Midwife*',155,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (503,0,'2010-04-30 00:00:00','TEXT','Tetanus is a serious sickness that enters the body through open wounds,a juke or skin scratch.U are at high risk for tetanus during&after birth because of wounds from delivery.Baby is at risk because the chord is open when born.U must get a tetanus immunization to protect you&baby.U need 2 tetanus jabs before or during pregnancy.Tetanus infection can put U&baby''s life at risk.Tetanus is given at antenatal.One more reason to see the midwife!*From Mobile Midwife*@@',155,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (504,0,'2010-04-30 00:00:00','TEXT','Tetanus is a serious sickness that enters the body through open wounds,a juke or skin scratch.U are at high risk for tetanus during&after birth because of wounds from delivery.Baby is at risk because the chord is open when born.U must get a tetanus immunization to protect you&baby.U need 2 tetanus jabs before or during pregnancy.Tetanus infection can put U&baby''s life at risk.Tetanus is given at antenatal.One more reason to see the midwife!*From Mobile Midwife*##',155,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (505,0,'2010-04-30 00:00:00','TEXT','Message for MEN!People may warn U off sex during pregnancy.Your sex life will change but gentle sex is safe.If your wife has been bleeding or having belly pains see midwife straight away.If your wife has had a miscarriage,problems getting pregnant or is over 35 U may need to abstain from sex-ask your midwife.If one of U has more than 1 sex partner use condoms to prevent infections.Infections can kill or harm the baby,so be safe.*From Mobile Midwife*',156,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (506,0,'2010-04-30 00:00:00','TEXT','Message for MEN!People may warn U off sex during pregnancy.Your sex life will change but gentle sex is safe.If your wife has been bleeding or having belly pains see midwife straight away.If your wife has had a miscarriage,problems getting pregnant or is over 35 U may need to abstain from sex-ask your midwife.If one of U has more than 1 sex partner use condoms to prevent infections.Infections can kill or harm the baby,so be safe.*From Mobile Midwife*@@',156,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (507,0,'2010-04-30 00:00:00','TEXT','Message for MEN!People may warn U off sex during pregnancy.Your sex life will change but gentle sex is safe.If your wife has been bleeding or having belly pains see midwife straight away.If your wife has had a miscarriage,problems getting pregnant or is over 35 U may need to abstain from sex-ask your midwife.If one of U has more than 1 sex partner use condoms to prevent infections.Infections can kill or harm the baby,so be safe.*From Mobile Midwife*##',156,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (508,0,'2010-04-30 00:00:00','TEXT','If U or your partner is HIV positive always use condoms.If U have not both been tested go to counseling&testing centre.If an expectant mother is HIV positive she will be started on medicines to protect help the baby from the virus.If U or your partner have itching in your private parts or there are changes in smell,color or thickness of vaginal discharge,get tested immediately at your local health facility.*From Mobile Midwife*',157,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (509,0,'2010-04-30 00:00:00','TEXT','If U or your partner is HIV positive always use condoms.If U have not both been tested go to counseling&testing centre.If an expectant mother is HIV positive she will be started on medicines to protect help the baby from the virus.If U or your partner have itching in your private parts or there are changes in smell,color or thickness of vaginal discharge,get tested immediately at your local health facility.*From Mobile Midwife*@@',157,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (510,0,'2010-04-30 00:00:00','TEXT','If U or your partner is HIV positive always use condoms.If U have not both been tested go to counseling&testing centre.If an expectant mother is HIV positive she will be started on medicines to protect help the baby from the virus.If U or your partner have itching in your private parts or there are changes in smell,color or thickness of vaginal discharge,get tested immediately at your local health facility.*From Mobile Midwife*##',157,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (511,0,'2010-04-30 00:00:00','TEXT','Don''t be afraid to ask the midwife questions at antenatal-he or she is there for U.Ask about delivery&where U will deliver.It would be nice to have baby''s father go with U.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure to take all tablets given to U to keep U both healthy.Also Register now with NHIS for 1 year of free medical cover.*From Mobile Midwife*',158,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (512,0,'2010-04-30 00:00:00','TEXT','Don''t be afraid to ask the midwife questions at antenatal-he or she is there for U.Ask about delivery&where U will deliver.It would be nice to have baby''s father go with U.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure to take all tablets given to U to keep U both healthy.Also Register now with NHIS for 1 year of free medical cover.*From Mobile Midwife*@@',158,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (513,0,'2010-04-30 00:00:00','TEXT','Don''t be afraid to ask the midwife questions at antenatal-he or she is there for U.Ask about delivery&where U will deliver.It would be nice to have baby''s father go with U.He can ask questions to learn about the pregnancy&U can listen to baby''s heartbeat together.Be sure to take all tablets given to U to keep U both healthy.Also Register now with NHIS for 1 year of free medical cover.*From Mobile Midwife*##',158,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (514,0,'2010-04-30 00:00:00','TEXT','Most women have low iron when pregnant.The midwife will give you tablets for this.U need iron to keep your blood levels up so it can carry oxygen around your body keeping U well.Anaemia or low iron in the blood is dangerous.Baby can be born too small&face alot of risks.Be sure to take iron tablets&eat food like liver,red meat&greens.Eat fruit to help iron enter the blood easier.Avoid eating clay-it can give you worms that eat up your iron.*From Mobile Midwife*',159,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (515,0,'2010-04-30 00:00:00','TEXT','Most women have low iron when pregnant.The midwife will give you tablets for this.U need iron to keep your blood levels up so it can carry oxygen around your body keeping U well.Anaemia or low iron in the blood is dangerous.Baby can be born too small&face alot of risks.Be sure to take iron tablets&eat food like liver,red meat&greens.Eat fruit to help iron enter the blood easier.Avoid eating clay-it can give you worms that eat up your iron.*From Mobile Midwife*@@',159,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (516,0,'2010-04-30 00:00:00','TEXT','Most women have low iron when pregnant.The midwife will give you tablets for this.U need iron to keep your blood levels up so it can carry oxygen around your body keeping U well.Anaemia or low iron in the blood is dangerous.Baby can be born too small&face alot of risks.Be sure to take iron tablets&eat food like liver,red meat&greens.Eat fruit to help iron enter the blood easier.Avoid eating clay-it can give you worms that eat up your iron.*From Mobile Midwife*##',159,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (517,0,'2010-04-30 00:00:00','TEXT','At antenatal clinic your midwife will give U folic acid tablets.Folic Acid helps the baby''s brain&spine grow well.It can help prevent deformities like cleft lip,cleft palate&some heart problems.Your body needs folic acid too to help prevent low iron levels in the blood which is dangerous.It is important to remember to take your folic acid as told by your midwife.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',160,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (518,0,'2010-04-30 00:00:00','TEXT','At antenatal clinic your midwife will give U folic acid tablets.Folic Acid helps the baby''s brain&spine grow well.It can help prevent deformities like cleft lip,cleft palate&some heart problems.Your body needs folic acid too to help prevent low iron levels in the blood which is dangerous.It is important to remember to take your folic acid as told by your midwife.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',160,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (519,0,'2010-04-30 00:00:00','TEXT','At antenatal clinic your midwife will give U folic acid tablets.Folic Acid helps the baby''s brain&spine grow well.It can help prevent deformities like cleft lip,cleft palate&some heart problems.Your body needs folic acid too to help prevent low iron levels in the blood which is dangerous.It is important to remember to take your folic acid as told by your midwife.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',160,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (520,0,'2010-04-30 00:00:00','TEXT','We hope U have been to antental clinic recently.By now U should have been 2 times or more.This week U should go as U need a 2nd dose of antimalaria medicine called SP.Malaria while pregnant serious.Malaria causes a shortage of blood in the Mum.Shortage of blood is one of the causes of death in pregnancy&delivery.If U have signs of malaria like fever,feeling cold,headache or pains in bones,go to the clinic straight away for treatment.*From Mobile Midwife*',161,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (521,0,'2010-04-30 00:00:00','TEXT','We hope U have been to antental clinic recently.By now U should have been 2 times or more.This week U should go as U need a 2nd dose of antimalaria medicine called SP.Malaria while pregnant serious.Malaria causes a shortage of blood in the Mum.Shortage of blood is one of the causes of death in pregnancy&delivery.If U have signs of malaria like fever,feeling cold,headache or pains in bones,go to the clinic straight away for treatment.*From Mobile Midwife*@@',161,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (522,0,'2010-04-30 00:00:00','TEXT','We hope U have been to antental clinic recently.By now U should have been 2 times or more.This week U should go as U need a 2nd dose of antimalaria medicine called SP.Malaria while pregnant serious.Malaria causes a shortage of blood in the Mum.Shortage of blood is one of the causes of death in pregnancy&delivery.If U have signs of malaria like fever,feeling cold,headache or pains in bones,go to the clinic straight away for treatment.*From Mobile Midwife*##',161,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (523,0,'2010-04-30 00:00:00','TEXT','As your belly grows to fit baby its common to get pains in your belly or womb.U may feel them more as you try to get up from bed or chair,or have to walk far.Try to ease the pain by relaxing for a moment.When U get out of bed roll to your side first&get up slowly.Drink plenty water to help.If pain is  very bad or doesn''t ease after a few minutes of relaxing,see your midwife straight.*From Mobile Midwife*',162,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (524,0,'2010-04-30 00:00:00','TEXT','As your belly grows to fit baby its common to get pains in your belly or womb.U may feel them more as you try to get up from bed or chair,or have to walk far.Try to ease the pain by relaxing for a moment.When U get out of bed roll to your side first&get up slowly.Drink plenty water to help.If pain is  very bad or doesn''t ease after a few minutes of relaxing,see your midwife straight.*From Mobile Midwife*@@',162,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (525,0,'2010-04-30 00:00:00','TEXT','As your belly grows to fit baby its common to get pains in your belly or womb.U may feel them more as you try to get up from bed or chair,or have to walk far.Try to ease the pain by relaxing for a moment.When U get out of bed roll to your side first&get up slowly.Drink plenty water to help.If pain is  very bad or doesn''t ease after a few minutes of relaxing,see your midwife straight.*From Mobile Midwife*##',162,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (526,0,'2010-04-30 00:00:00','TEXT','When pregnanct,changes in the body make skin drier & scratchy.To help try rubbing skin with shea butter.Dry eyes are also normal.Don''t worry if U forget things now or are a bit confused,it is also normal&not a medical problem.U have a lot of things to think about with a baby on the way&U will be very busy when baby arrives.For now try to take time & rest when U can.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',163,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (527,0,'2010-04-30 00:00:00','TEXT','When pregnanct,changes in the body make skin drier & scratchy.To help try rubbing skin with shea butter.Dry eyes are also normal.Don''t worry if U forget things now or are a bit confused,it is also normal&not a medical problem.U have a lot of things to think about with a baby on the way&U will be very busy when baby arrives.For now try to take time & rest when U can.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',163,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (528,0,'2010-04-30 00:00:00','TEXT','When pregnanct,changes in the body make skin drier & scratchy.To help try rubbing skin with shea butter.Dry eyes are also normal.Don''t worry if U forget things now or are a bit confused,it is also normal&not a medical problem.U have a lot of things to think about with a baby on the way&U will be very busy when baby arrives.For now try to take time & rest when U can.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',163,3);


insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (529,0,'2010-04-30 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood doing the job of carrying food&oxygen around the body keeping it well.Low iron levels can make U tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*',164,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (530,0,'2010-04-30 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood doing the job of carrying food&oxygen around the body keeping it well.Low iron levels can make U tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*@@',164,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (531,0,'2010-04-30 00:00:00','TEXT','Most women start pregnancy with low iron levels in the blood.Iron keeps your blood doing the job of carrying food&oxygen around the body keeping it well.Low iron levels can make U tired or breathless.If the iron level is too low U have anaemia which is dangerous for U&baby.Your low iron level can cause the baby to be born too small which is bad.To bring your iron levels up,take the tablets from your midwife&eat liver,red meat,greens&eggs.*From Mobile Midwife*##',164,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (532,0,'2010-04-30 00:00:00','TEXT','If U feel burning in your chest after eating it may be heartburn.It may be painful&fearful but it is common&not dangerous.Heartburn comes from baby pressing on tummy pushing digestive juices up into the throat.It can happen until baby is born.To help,don''t eat spicy or oily foods.Avoid alcohol&coffee.Eat small meals through the day&chew food well.If U lie down right after a meal it can be worse.If U can,a glass of cold milk can help.*From Mobile Midwife*',165,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (533,0,'2010-04-30 00:00:00','TEXT','If U feel burning in your chest after eating it may be heartburn.It may be painful&fearful but it is common&not dangerous.Heartburn comes from baby pressing on tummy pushing digestive juices up into the throat.It can happen until baby is born.To help,don''t eat spicy or oily foods.Avoid alcohol&coffee.Eat small meals through the day&chew food well.If U lie down right after a meal it can be worse.If U can,a glass of cold milk can help.*From Mobile Midwife*@@',165,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (534,0,'2010-04-30 00:00:00','TEXT','If U feel burning in your chest after eating it may be heartburn.It may be painful&fearful but it is common&not dangerous.Heartburn comes from baby pressing on tummy pushing digestive juices up into the throat.It can happen until baby is born.To help,don''t eat spicy or oily foods.Avoid alcohol&coffee.Eat small meals through the day&chew food well.If U lie down right after a meal it can be worse.If U can,a glass of cold milk can help.*From Mobile Midwife*##',165,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (535,0,'2010-04-30 00:00:00','TEXT','Don''t take any tablets or medicine that is not given by a doctor or midwife who knows U are pregnant.Some medicines can cause baby to deform.Don''t drink alcohol or smoke.It can hurt your baby.If U have headache or pain,paracetamol is safe if only sometimes.Aspirin,Fpac&brufen are NOT SAFE&can harm your baby.Talk to your midwife to be sure of what is safe&before taking traditional treatments.Try to avoid stress,hot sun&drink plenty water.*From Mobile Midwife*',166,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (536,0,'2010-04-30 00:00:00','TEXT','Don''t take any tablets or medicine that is not given by a doctor or midwife who knows U are pregnant.Some medicines can cause baby to deform.Don''t drink alcohol or smoke.It can hurt your baby.If U have headache or pain,paracetamol is safe if only sometimes.Aspirin,Fpac&brufen are NOT SAFE&can harm your baby.Talk to your midwife to be sure of what is safe&before taking traditional treatments.Try to avoid stress,hot sun&drink plenty water.*From Mobile Midwife*@@',166,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (537,0,'2010-04-30 00:00:00','TEXT','Don''t take any tablets or medicine that is not given by a doctor or midwife who knows U are pregnant.Some medicines can cause baby to deform.Don''t drink alcohol or smoke.It can hurt your baby.If U have headache or pain,paracetamol is safe if only sometimes.Aspirin,Fpac&brufen are NOT SAFE&can harm your baby.Talk to your midwife to be sure of what is safe&before taking traditional treatments.Try to avoid stress,hot sun&drink plenty water.*From Mobile Midwife*##',166,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (538,0,'2010-04-30 00:00:00','TEXT','Yeah!U are now 7 months pregnant&entering the final stage of pregnancy.Soon U will be able to hold the little one growing inside U.Baby is getting ready for the outside world forming fat layers to be a healthy newborn.Worries are normal now&it may be hard to sleep.Wear light cool sleep clothes,avoid coffee&tea.Eat small before bed&avoid spicy,oily food.If U can''t sleep just get up,take a walk&think happy thoughts.*From Mobile Midwife*',167,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (539,0,'2010-04-30 00:00:00','TEXT','Yeah!U are now 7 months pregnant&entering the final stage of pregnancy.Soon U will be able to hold the little one growing inside U.Baby is getting ready for the outside world forming fat layers to be a healthy newborn.Worries are normal now&it may be hard to sleep.Wear light cool sleep clothes,avoid coffee&tea.Eat small before bed&avoid spicy,oily food.If U can''t sleep just get up,take a walk&think happy thoughts.*From Mobile Midwife*@@',167,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (540,0,'2010-04-30 00:00:00','TEXT','Yeah!U are now 7 months pregnant&entering the final stage of pregnancy.Soon U will be able to hold the little one growing inside U.Baby is getting ready for the outside world forming fat layers to be a healthy newborn.Worries are normal now&it may be hard to sleep.Wear light cool sleep clothes,avoid coffee&tea.Eat small before bed&avoid spicy,oily food.If U can''t sleep just get up,take a walk&think happy thoughts.*From Mobile Midwife*##',167,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (541,0,'2010-04-30 00:00:00','TEXT','When pregnant U need to put on weight,but not too fast. U don''t need to eat more than normal but must eat a mix of healthy food to help baby grow.U need 3 kinds of food.Body building like all beans,peas,groundnut,fish,meat&small dairy like milk or wagashe.Energy giving foods like grains,rice,cassava&yam.Protective food like all fruits,melons&shea fruit.There is no proof any of these foods will affect your baby''s character in future.*From Mobile Midwife*',168,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (542,0,'2010-04-30 00:00:00','TEXT','When pregnant U need to put on weight,but not too fast. U don''t need to eat more than normal but must eat a mix of healthy food to help baby grow.U need 3 kinds of food.Body building like all beans,peas,groundnut,fish,meat&small dairy like milk or wagashe.Energy giving foods like grains,rice,cassava&yam.Protective food like all fruits,melons&shea fruit.There is no proof any of these foods will affect your baby''s character in future.*From Mobile Midwife*@@',168,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (543,0,'2010-04-30 00:00:00','TEXT','When pregnant U need to put on weight,but not too fast. U don''t need to eat more than normal but must eat a mix of healthy food to help baby grow.U need 3 kinds of food.Body building like all beans,peas,groundnut,fish,meat&small dairy like milk or wagashe.Energy giving foods like grains,rice,cassava&yam.Protective food like all fruits,melons&shea fruit.There is no proof any of these foods will affect your baby''s character in future.*From Mobile Midwife*##',168,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (544,0,'2010-04-30 00:00:00','TEXT','Water is life&when U are pregnant it is very important.If U don''t drink enough water U can get dehydrated,have headaches&feel tired.U are dehydrated if your skin,nose&mouth feel dry or if your urine is dark yellow.Drinking plenty water helps carry nutrients to baby,prevents urinary infections,constipation&piles.It also helps U feel less bloated&swollen.6-8 pure water sachets is good as well as fresh fruit,juices,zoomkom or watermelon.*From Mobile Midwife*',169,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (545,0,'2010-04-30 00:00:00','TEXT','Water is life&when U are pregnant it is very important.If U don''t drink enough water U can get dehydrated,have headaches&feel tired.U are dehydrated if your skin,nose&mouth feel dry or if your urine is dark yellow.Drinking plenty water helps carry nutrients to baby,prevents urinary infections,constipation&piles.It also helps U feel less bloated&swollen.6-8 pure water sachets is good as well as fresh fruit,juices,zoomkom or watermelon.*From Mobile Midwife*@@',169,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (546,0,'2010-04-30 00:00:00','TEXT','Water is life&when U are pregnant it is very important.If U don''t drink enough water U can get dehydrated,have headaches&feel tired.U are dehydrated if your skin,nose&mouth feel dry or if your urine is dark yellow.Drinking plenty water helps carry nutrients to baby,prevents urinary infections,constipation&piles.It also helps U feel less bloated&swollen.6-8 pure water sachets is good as well as fresh fruit,juices,zoomkom or watermelon.*From Mobile Midwife*##',169,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (547,0,'2010-04-30 00:00:00','TEXT','U are closer to delivery&we still have info for U!Some beliefs about babies are not really true.If baby is deformed it is a medical problem-see a doctor.If too serious AFRIKIDS@Sirigu or Bolga can help.If baby cries alot,falls sick alot,or bites mum''s breast its normal child behavior,not a curse.Babies are gifts from God&have a better chance at life if born at a health facility.If U have problems with traditions,ask your midwife for help.*From Mobile Midwife*',170,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (548,0,'2010-04-30 00:00:00','TEXT','U are closer to delivery&we still have info for U!Some beliefs about babies are not really true.If baby is deformed it is a medical problem-see a doctor.If too serious AFRIKIDS@Sirigu or Bolga can help.If baby cries alot,falls sick alot,or bites mum''s breast its normal child behavior,not a curse.Babies are gifts from God&have a better chance at life if born at a health facility.If U have problems with traditions,ask your midwife for help.*From Mobile Midwife*@@',170,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (549,0,'2010-04-30 00:00:00','TEXT','U are closer to delivery&we still have info for U!Some beliefs about babies are not really true.If baby is deformed it is a medical problem-see a doctor.If too serious AFRIKIDS@Sirigu or Bolga can help.If baby cries alot,falls sick alot,or bites mum''s breast its normal child behavior,not a curse.Babies are gifts from God&have a better chance at life if born at a health facility.If U have problems with traditions,ask your midwife for help.*From Mobile Midwife*##',170,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (550,0,'2010-04-30 00:00:00','TEXT','U may urinate more often now.Its normal as baby is pressing on your bladder.If U have burning/pain when urinating,it can be a bladder infection.They are common in pregnancy&painful.U may also have fever,chills,blood in urine,feel sick&find sex painful.See midwife straight away.Don''t wait-it can harm baby.Prevent infection by wearing loose panties,always wipe front to back,urinate after sex,drink plenty water+don''t hold your urine for long.*From Mobile Midwife*',171,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (551,0,'2010-04-30 00:00:00','TEXT','U may urinate more often now.Its normal as baby is pressing on your bladder.If U have burning/pain when urinating,it can be a bladder infection.They are common in pregnancy&painful.U may also have fever,chills,blood in urine,feel sick&find sex painful.See midwife straight away.Don''t wait-it can harm baby.Prevent infection by wearing loose panties,always wipe front to back,urinate after sex,drink plenty water+don''t hold your urine for long.*From Mobile Midwife*@@',171,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (552,0,'2010-04-30 00:00:00','TEXT','U may urinate more often now.Its normal as baby is pressing on your bladder.If U have burning/pain when urinating,it can be a bladder infection.They are common in pregnancy&painful.U may also have fever,chills,blood in urine,feel sick&find sex painful.See midwife straight away.Don''t wait-it can harm baby.Prevent infection by wearing loose panties,always wipe front to back,urinate after sex,drink plenty water+don''t hold your urine for long.*From Mobile Midwife*##',171,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (553,0,'2010-04-30 00:00:00','TEXT','In pregnancy U have more vaginal discharge.If it gets thick,white&creamy&U itch down there it may be thrush or infection.Thrush is common for pregnant women&not always sexually transmitted.It can be from natural chemicals in the vagina that become too many.See midwife-dont treat yourself-some medicines are not good for pregnancy&can make infection worse.Don''t put anything in vagina-douching or cleaning with fingers can cause infection.*From Mobile Midwife*',172,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (554,0,'2010-04-30 00:00:00','TEXT','In pregnancy U have more vaginal discharge.If it gets thick,white&creamy&U itch down there it may be thrush or infection.Thrush is common for pregnant women&not always sexually transmitted.It can be from natural chemicals in the vagina that become too many.See midwife-dont treat yourself-some medicines are not good for pregnancy&can make infection worse.Don''t put anything in vagina-douching or cleaning with fingers can cause infection.*From Mobile Midwife*@@',172,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (555,0,'2010-04-30 00:00:00','TEXT','In pregnancy U have more vaginal discharge.If it gets thick,white&creamy&U itch down there it may be thrush or infection.Thrush is common for pregnant women&not always sexually transmitted.It can be from natural chemicals in the vagina that become too many.See midwife-dont treat yourself-some medicines are not good for pregnancy&can make infection worse.Don''t put anything in vagina-douching or cleaning with fingers can cause infection.*From Mobile Midwife*##',172,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (556,0,'2010-04-30 00:00:00','TEXT','Are your feet&hands swollen?It is called edema.This does not mean that baby is a boy.It happens as extra blood U have 4 baby gets trapped&pushes water into hands or ankles.It is common,not serious&goes away when baby is born.Help make it better by sitting with feet up,drink lots of water,avoid too much salt&maggi.If swelling comes sudden&your hands&face get big see midwife straight as this is dangerous.*From Mobile Midwife*',173,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (557,0,'2010-04-30 00:00:00','TEXT','Are your feet&hands swollen?It is called edema.This does not mean that baby is a boy.It happens as extra blood U have 4 baby gets trapped&pushes water into hands or ankles.It is common,not serious&goes away when baby is born.Help make it better by sitting with feet up,drink lots of water,avoid too much salt&maggi.If swelling comes sudden&your hands&face get big see midwife straight as this is dangerous.*From Mobile Midwife*@@',173,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (558,0,'2010-04-30 00:00:00','TEXT','Are your feet&hands swollen?It is called edema.This does not mean that baby is a boy.It happens as extra blood U have 4 baby gets trapped&pushes water into hands or ankles.It is common,not serious&goes away when baby is born.Help make it better by sitting with feet up,drink lots of water,avoid too much salt&maggi.If swelling comes sudden&your hands&face get big see midwife straight as this is dangerous.*From Mobile Midwife*##',173,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (559,0,'2010-04-30 00:00:00','TEXT','Pregnancy is hard&it is ok to be afraid,worried or sad.Its normal for moods to be strange as hormone levels change.If U feel sad try to do something to cheer yourself up like singing,listen to your best songs,take a nap,or talk to your partner or friends about how U feel.Don''t worry as mood swings are normal,try to relax&try not to be hard on yourself.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',174,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (560,0,'2010-04-30 00:00:00','TEXT','Pregnancy is hard&it is ok to be afraid,worried or sad.Its normal for moods to be strange as hormone levels change.If U feel sad try to do something to cheer yourself up like singing,listen to your best songs,take a nap,or talk to your partner or friends about how U feel.Don''t worry as mood swings are normal,try to relax&try not to be hard on yourself.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',174,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (561,0,'2010-04-30 00:00:00','TEXT','Pregnancy is hard&it is ok to be afraid,worried or sad.Its normal for moods to be strange as hormone levels change.If U feel sad try to do something to cheer yourself up like singing,listen to your best songs,take a nap,or talk to your partner or friends about how U feel.Don''t worry as mood swings are normal,try to relax&try not to be hard on yourself.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',174,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (562,0,'2010-04-30 00:00:00','TEXT','Soon baby will join us in the outside world&will need to be protected from infection&sickness.To help your baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the best milk.Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*',175,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (563,0,'2010-04-30 00:00:00','TEXT','Soon baby will join us in the outside world&will need to be protected from infection&sickness.To help your baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the best milk.Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*@@',175,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (564,0,'2010-04-30 00:00:00','TEXT','Soon baby will join us in the outside world&will need to be protected from infection&sickness.To help your baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the best milk.Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*##',175,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (565,0,'2010-04-30 00:00:00','TEXT','It is good to be informed about when U must go to clinic.Go if bleeding,it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy,blurry or flashing vision.Go if U have pain in the belly,especially if it is a sharp one-sided pain or baby is moving less.Go if suddenly too thirsty&urinating too much.Go if U have very swollen feet hands,face or eyes.Try not to worry just see the midwife.*From Mobile Midwife*',176,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (566,0,'2010-04-30 00:00:00','TEXT','It is good to be informed about when U must go to clinic.Go if bleeding,it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy,blurry or flashing vision.Go if U have pain in the belly,especially if it is a sharp one-sided pain or baby is moving less.Go if suddenly too thirsty&urinating too much.Go if U have very swollen feet hands,face or eyes.Try not to worry just see the midwife.*From Mobile Midwife*@@',176,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (567,0,'2010-04-30 00:00:00','TEXT','It is good to be informed about when U must go to clinic.Go if bleeding,it can be serious.Go for bad headaches,fever,vomitting,feeling dizzy,blurry or flashing vision.Go if U have pain in the belly,especially if it is a sharp one-sided pain or baby is moving less.Go if suddenly too thirsty&urinating too much.Go if U have very swollen feet hands,face or eyes.Try not to worry just see the midwife.*From Mobile Midwife*##',176,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (568,0,'2010-04-30 00:00:00','TEXT','Baby''s brain is growing&head is getting bigger.We can now see the sex of baby on scan.You might be more hungry&that is ok.If U feel breathless sometimes it is also ok,but if your blood is low U may be breathless too much.Make sure U take iron tablets midwife gave U.Take time when working.Sleep supported up with pillows or against a wall for help.In daytime relax a bit sitting up straight.See doctor if U get chest pain or racing heartbeat.*From Mobile Midwife*',177,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (569,0,'2010-04-30 00:00:00','TEXT','Baby''s brain is growing&head is getting bigger.We can now see the sex of baby on scan.You might be more hungry&that is ok.If U feel breathless sometimes it is also ok,but if your blood is low U may be breathless too much.Make sure U take iron tablets midwife gave U.Take time when working.Sleep supported up with pillows or against a wall for help.In daytime relax a bit sitting up straight.See doctor if U get chest pain or racing heartbeat.*From Mobile Midwife*@@',177,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (570,0,'2010-04-30 00:00:00','TEXT','Baby''s brain is growing&head is getting bigger.We can now see the sex of baby on scan.You might be more hungry&that is ok.If U feel breathless sometimes it is also ok,but if your blood is low U may be breathless too much.Make sure U take iron tablets midwife gave U.Take time when working.Sleep supported up with pillows or against a wall for help.In daytime relax a bit sitting up straight.See doctor if U get chest pain or racing heartbeat.*From Mobile Midwife*##',177,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (571,0,'2010-04-30 00:00:00','TEXT','Message for MEN! Now it is good to start preparing for baby''s arrival.Talk to midwife&see delivery room if possible.Help your pregnant lady prepare by thinking of transport&how to pay.Who&how to call in emergency?Where will mum deliver?Who can donate blood if needed?Have U registered for NHIS yet?Put down small money for baby napkins,soap,antiseptic,mackintosh,towels,aligudon for baby.*From Mobile Midwife*',178,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (572,0,'2010-04-30 00:00:00','TEXT','Message for MEN! Now it is good to start preparing for baby''s arrival.Talk to midwife&see delivery room if possible.Help your pregnant lady prepare by thinking of transport&how to pay.Who&how to call in emergency?Where will mum deliver?Who can donate blood if needed?Have U registered for NHIS yet?Put down small money for baby napkins,soap,antiseptic,mackintosh,towels,aligudon for baby.*From Mobile Midwife*@@',178,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (573,0,'2010-04-30 00:00:00','TEXT','Message for MEN! Now it is good to start preparing for baby''s arrival.Talk to midwife&see delivery room if possible.Help your pregnant lady prepare by thinking of transport&how to pay.Who&how to call in emergency?Where will mum deliver?Who can donate blood if needed?Have U registered for NHIS yet?Put down small money for baby napkins,soap,antiseptic,mackintosh,towels,aligudon for baby.*From Mobile Midwife*##',178,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (574,0,'2010-04-30 00:00:00','TEXT','Soon baby will join us in the outside world. Baby will need to be protected from infection&sickness.To help baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the BEST!Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*',179,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (575,0,'2010-04-30 00:00:00','TEXT','Soon baby will join us in the outside world. Baby will need to be protected from infection&sickness.To help baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the BEST!Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*@@',179,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (576,0,'2010-04-30 00:00:00','TEXT','Soon baby will join us in the outside world. Baby will need to be protected from infection&sickness.To help baby- BREASTFEED.Breastmilk is perfect food for babies&gives all they need to grow big&strong&protects baby from sickness.Feed baby from breast as soon as born.First milk is thick,yellow&the BEST!Feed breastmilk ONLY.No water or food for 6 months.Feed baby 8-12 times/day even if baby sleeps alot.Never fear asking midwife for help.*From Mobile Midwife*##',179,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (577,0,'2010-04-30 00:00:00','TEXT','If you haven''t registered for National Health Insurance yet,do it NOW.Its free for 1year for pregnant women&covers maternity bills including cost of surgery if needed.It covers baby for first 6weeks of life also.Baby is only covered for 6weeks,so remember to register baby once born.Go to NHIS office to register as soon as U know you are pregnant,or take your wife or relative that is pregnant.*From Mobile Midwife*',180,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (578,0,'2010-04-30 00:00:00','TEXT','If you haven''t registered for National Health Insurance yet,do it NOW.Its free for 1year for pregnant women&covers maternity bills including cost of surgery if needed.It covers baby for first 6weeks of life also.Baby is only covered for 6weeks,so remember to register baby once born.Go to NHIS office to register as soon as U know you are pregnant,or take your wife or relative that is pregnant.*From Mobile Midwife*@@',180,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (579,0,'2010-04-30 00:00:00','TEXT','If you haven''t registered for National Health Insurance yet,do it NOW.Its free for 1year for pregnant women&covers maternity bills including cost of surgery if needed.It covers baby for first 6weeks of life also.Baby is only covered for 6weeks,so remember to register baby once born.Go to NHIS office to register as soon as U know you are pregnant,or take your wife or relative that is pregnant.*From Mobile Midwife*##',180,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (580,0,'2010-04-30 00:00:00','TEXT','Baby has grown so much that now the space for him to move around is small.U may be feeling very tired now so try to get enough rest.Is your back paining from the weight of baby?Try sitting on a mat on the floor with your back against the wall&legs spread out.Try to keep active as it will keep U strong for labour,but avoid lifting heavy objects like water,firewood&other children.*From Mobile Midwife*',181,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (581,0,'2010-04-30 00:00:00','TEXT','Baby has grown so much that now the space for him to move around is small.U may be feeling very tired now so try to get enough rest.Is your back paining from the weight of baby?Try sitting on a mat on the floor with your back against the wall&legs spread out.Try to keep active as it will keep U strong for labour,but avoid lifting heavy objects like water,firewood&other children.*From Mobile Midwife*@@',181,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (582,0,'2010-04-30 00:00:00','TEXT','Baby has grown so much that now the space for him to move around is small.U may be feeling very tired now so try to get enough rest.Is your back paining from the weight of baby?Try sitting on a mat on the floor with your back against the wall&legs spread out.Try to keep active as it will keep U strong for labour,but avoid lifting heavy objects like water,firewood&other children.*From Mobile Midwife*##',181,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (583,0,'2010-04-30 00:00:00','TEXT','Labour is different for each woman&some signs show U are in labour.Contractions-when belly muscles tighten&harden-will come regular&hurt.They get stronger,longer&more painful as birth gets close.U may feel pain in the low back&cramps like a period.U may see a “show”-when the mucus plug that blocks neck of womb comes out&looks jelly-like.If waters break&U have contractions contact midwife&get to clinic as babies can sometimes come fast.*From Mobile Midwife*',182,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (584,0,'2010-04-30 00:00:00','TEXT','Labour is different for each woman&some signs show U are in labour.Contractions-when belly muscles tighten&harden-will come regular&hurt.They get stronger,longer&more painful as birth gets close.U may feel pain in the low back&cramps like a period.U may see a “show”-when the mucus plug that blocks neck of womb comes out&looks jelly-like.If waters break&U have contractions contact midwife&get to clinic as babies can sometimes come fast.*From Mobile Midwife*@@',182,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (585,0,'2010-04-30 00:00:00','TEXT','Labour is different for each woman&some signs show U are in labour.Contractions-when belly muscles tighten&harden-will come regular&hurt.They get stronger,longer&more painful as birth gets close.U may feel pain in the low back&cramps like a period.U may see a “show”-when the mucus plug that blocks neck of womb comes out&looks jelly-like.If waters break&U have contractions contact midwife&get to clinic as babies can sometimes come fast.*From Mobile Midwife*##',182,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (586,0,'2010-04-30 00:00:00','TEXT','For MEN! Your woman is like mother earth&the baby she is carrying is like a seed.Nurture&nourish mother earth,care for her to help the seed to grow strong.Remember pregnancy is a gift so take care of it-U may be having the next president of Ghana!Financial support can be hard,but U can support her by helping with the housework&make sure she has NHIS.Show love by going with her to ANC&learn what can help her have a healthy baby.*From Mobile Midwife*',183,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (587,0,'2010-04-30 00:00:00','TEXT','For MEN! Your woman is like mother earth&the baby she is carrying is like a seed.Nurture&nourish mother earth,care for her to help the seed to grow strong.Remember pregnancy is a gift so take care of it-U may be having the next president of Ghana!Financial support can be hard,but U can support her by helping with the housework&make sure she has NHIS.Show love by going with her to ANC&learn what can help her have a healthy baby.*From Mobile Midwife*@@',183,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (588,0,'2010-04-30 00:00:00','TEXT','For MEN! Your woman is like mother earth&the baby she is carrying is like a seed.Nurture&nourish mother earth,care for her to help the seed to grow strong.Remember pregnancy is a gift so take care of it-U may be having the next president of Ghana!Financial support can be hard,but U can support her by helping with the housework&make sure she has NHIS.Show love by going with her to ANC&learn what can help her have a healthy baby.*From Mobile Midwife*##',183,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (58,0,'2010-04-30 00:00:00','TEXT','In this stage of pregnancy it is common to suffer leg cramps.Cramps are a sharp sudden pain in the lower leg that comes most at night&lasts a few minutes.As baby grows in the womb it puts added pressure on the muscles,veins&nerves.To help prevent them take breaks from sitting or standing long&drink plenty water.Try gently rubbing or put pressure over painful area&stretch the leg straight with foot bent upwards.Also get up&walk a bit to help.*From Mobile Midwife*',184,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (589,0,'2010-04-30 00:00:00','TEXT','In this stage of pregnancy it is common to suffer leg cramps.Cramps are a sharp sudden pain in the lower leg that comes most at night&lasts a few minutes.As baby grows in the womb it puts added pressure on the muscles,veins&nerves.To help prevent them take breaks from sitting or standing long&drink plenty water.Try gently rubbing or put pressure over painful area&stretch the leg straight with foot bent upwards.Also get up&walk a bit to help.*From Mobile Midwife*@@',184,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (590,0,'2010-04-30 00:00:00','TEXT','In this stage of pregnancy it is common to suffer leg cramps.Cramps are a sharp sudden pain in the lower leg that comes most at night&lasts a few minutes.As baby grows in the womb it puts added pressure on the muscles,veins&nerves.To help prevent them take breaks from sitting or standing long&drink plenty water.Try gently rubbing or put pressure over painful area&stretch the leg straight with foot bent upwards.Also get up&walk a bit to help.*From Mobile Midwife*##',184,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (591,0,'2010-04-30 00:00:00','TEXT','Babies get food&oxygen in womb through placenta(or afterbirth).Placenta passes nutrients from mum to baby through umbilical cord attached to baby''s belly.After birth,cord is cut&a stump remains that soon falls off.Care of the stump before it falls off is very important.Keep it clean&dry.Dont apply anything to it.No spirit,ash,glass or anything.Make sure baby napkins dont rub or cover stump.Dont force stump to fall,it will go in 10-21 days.*From Mobile Midwife*',185,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (592,0,'2010-04-30 00:00:00','TEXT','Babies get food&oxygen in womb through placenta(or afterbirth).Placenta passes nutrients from mum to baby through umbilical cord attached to baby''s belly.After birth,cord is cut&a stump remains that soon falls off.Care of the stump before it falls off is very important.Keep it clean&dry.Dont apply anything to it.No spirit,ash,glass or anything.Make sure baby napkins dont rub or cover stump.Dont force stump to fall,it will go in 10-21 days.*From Mobile Midwife*@@',185,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (593,0,'2010-04-30 00:00:00','TEXT','Babies get food&oxygen in womb through placenta(or afterbirth).Placenta passes nutrients from mum to baby through umbilical cord attached to baby''s belly.After birth,cord is cut&a stump remains that soon falls off.Care of the stump before it falls off is very important.Keep it clean&dry.Dont apply anything to it.No spirit,ash,glass or anything.Make sure baby napkins dont rub or cover stump.Dont force stump to fall,it will go in 10-21 days.*From Mobile Midwife*##',185,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (594,0,'2010-04-30 00:00:00','TEXT','It may be hard to sleep now as it is hard to be comfortable-U urinate alot,worry alot or leg pain wakes U.This happens to most women as pregnancy goes on so try not to worry. Instead try to relax before bed with a bath or massage from husband.If U can''t sleep try listening to radio until sleep comes.This week,maybe plan where baby will sleep when they join us in the outside world.*From Mobile Midwife*',186,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (595,0,'2010-04-30 00:00:00','TEXT','It may be hard to sleep now as it is hard to be comfortable-U urinate alot,worry alot or leg pain wakes U.This happens to most women as pregnancy goes on so try not to worry. Instead try to relax before bed with a bath or massage from husband.If U can''t sleep try listening to radio until sleep comes.This week,maybe plan where baby will sleep when they join us in the outside world.*From Mobile Midwife*@@',186,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (596,0,'2010-04-30 00:00:00','TEXT','It may be hard to sleep now as it is hard to be comfortable-U urinate alot,worry alot or leg pain wakes U.This happens to most women as pregnancy goes on so try not to worry. Instead try to relax before bed with a bath or massage from husband.If U can''t sleep try listening to radio until sleep comes.This week,maybe plan where baby will sleep when they join us in the outside world.*From Mobile Midwife*##',186,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (597,0,'2010-04-30 00:00:00','TEXT','Contractions are when your belly muscles tighten,getting hard&firm for a few seconds&then get softer again as muscles relax.U may have had practice contractions already,but in real labour contractions get longer,stronger&come regularly.Pain may be more when your waters break.U can ease pain by changing positions&breathing through the contraction letting your body do the work.If pain is too much the midwife can help with pain relief.*From Mobile Midwife*',187,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (598,0,'2010-04-30 00:00:00','TEXT','Contractions are when your belly muscles tighten,getting hard&firm for a few seconds&then get softer again as muscles relax.U may have had practice contractions already,but in real labour contractions get longer,stronger&come regularly.Pain may be more when your waters break.U can ease pain by changing positions&breathing through the contraction letting your body do the work.If pain is too much the midwife can help with pain relief.*From Mobile Midwife*@@',187,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (599,0,'2010-04-30 00:00:00','TEXT','Contractions are when your belly muscles tighten,getting hard&firm for a few seconds&then get softer again as muscles relax.U may have had practice contractions already,but in real labour contractions get longer,stronger&come regularly.Pain may be more when your waters break.U can ease pain by changing positions&breathing through the contraction letting your body do the work.If pain is too much the midwife can help with pain relief.*From Mobile Midwife*##',187,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (600,0,'2010-04-30 00:00:00','TEXT','Well done!U are 33 weeks pregnant!From now U must do all U can to ensure baby is born healthy.Babies born before 36 weeks are early but can still be healthy.If baby comes early follow these tips.Don''t bath small babies,wipe with clean damp cloth.Tie baby between your breasts with a lappa all the day.Shea butter on their body helps baby stay warm.Breastfeed straight away&don''t give anything but breastmilk for first 6months of life.*From Mobile Midwife*',188,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (601,0,'2010-04-30 00:00:00','TEXT','Well done!U are 33 weeks pregnant!From now U must do all U can to ensure baby is born healthy.Babies born before 36 weeks are early but can still be healthy.If baby comes early follow these tips.Don''t bath small babies,wipe with clean damp cloth.Tie baby between your breasts with a lappa all the day.Shea butter on their body helps baby stay warm.Breastfeed straight away&don''t give anything but breastmilk for first 6months of life.*From Mobile Midwife*@@',188,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (602,0,'2010-04-30 00:00:00','TEXT','Well done!U are 33 weeks pregnant!From now U must do all U can to ensure baby is born healthy.Babies born before 36 weeks are early but can still be healthy.If baby comes early follow these tips.Don''t bath small babies,wipe with clean damp cloth.Tie baby between your breasts with a lappa all the day.Shea butter on their body helps baby stay warm.Breastfeed straight away&don''t give anything but breastmilk for first 6months of life.*From Mobile Midwife*##',188,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (603,0,'2010-04-30 00:00:00','TEXT','Your baby is protected inside the womb in a bag of fluid.When the bag tears,fluid comes out.Its called waters breaking.Waters can break before or during labour.If waters break stay calm&get to midwife as soon as U can.Once waters have broken U&baby have less protection from infection so go to clinic straight.When waters break note time,colour&smell of water.Most women give birth soon after water breaks so go to hospital when they do.*From Mobile Midwife*',189,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (604,0,'2010-04-30 00:00:00','TEXT','Your baby is protected inside the womb in a bag of fluid.When the bag tears,fluid comes out.Its called waters breaking.Waters can break before or during labour.If waters break stay calm&get to midwife as soon as U can.Once waters have broken U&baby have less protection from infection so go to clinic straight.When waters break note time,colour&smell of water.Most women give birth soon after water breaks so go to hospital when they do.*From Mobile Midwife*@@',189,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (605,0,'2010-04-30 00:00:00','TEXT','Your baby is protected inside the womb in a bag of fluid.When the bag tears,fluid comes out.Its called waters breaking.Waters can break before or during labour.If waters break stay calm&get to midwife as soon as U can.Once waters have broken U&baby have less protection from infection so go to clinic straight.When waters break note time,colour&smell of water.Most women give birth soon after water breaks so go to hospital when they do.*From Mobile Midwife*##',189,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (606,0,'2010-04-30 00:00:00','TEXT','Now baby''s internal body parts are growing&lungs are getting stronger.Mums&Dads talk to your baby in the womb.They can hear U&makes baby know they will be loved on arrival.Feel baby kicking too.Aches&pains are normal now as mum is bigger.Help our mums to be by carrying heavy things for them.Pregnant ladies should not carry heavy loads on their head,back or shoulders.Rest helps ease most aches&pains so help mum slow down&rest a bit.*From Mobile Midwife*',190,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (607,0,'2010-04-30 00:00:00','TEXT','Now baby''s internal body parts are growing&lungs are getting stronger.Mums&Dads talk to your baby in the womb.They can hear U&makes baby know they will be loved on arrival.Feel baby kicking too.Aches&pains are normal now as mum is bigger.Help our mums to be by carrying heavy things for them.Pregnant ladies should not carry heavy loads on their head,back or shoulders.Rest helps ease most aches&pains so help mum slow down&rest a bit.*From Mobile Midwife*@@',190,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (608,0,'2010-04-30 00:00:00','TEXT','Now baby''s internal body parts are growing&lungs are getting stronger.Mums&Dads talk to your baby in the womb.They can hear U&makes baby know they will be loved on arrival.Feel baby kicking too.Aches&pains are normal now as mum is bigger.Help our mums to be by carrying heavy things for them.Pregnant ladies should not carry heavy loads on their head,back or shoulders.Rest helps ease most aches&pains so help mum slow down&rest a bit.*From Mobile Midwife*##',190,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (609,0,'2010-04-30 00:00:00','TEXT','Baby is about the size of a medium grasscutter now&is practicing breathing&has hair now.Labour time is coming soon&when U go into labour it is very important to contact your midwife straight.Every labour is different.U need to be sure U call the midwife so any problem can be solved right away.Signs of true labour include,contractions,pain,show&breaking of waters.Midwife can confirm true labour so don''t be afraid to contact them to be sure.*From Mobile Midwife*',191,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (610,0,'2010-04-30 00:00:00','TEXT','Baby is about the size of a medium grasscutter now&is practicing breathing&has hair now.Labour time is coming soon&when U go into labour it is very important to contact your midwife straight.Every labour is different.U need to be sure U call the midwife so any problem can be solved right away.Signs of true labour include,contractions,pain,show&breaking of waters.Midwife can confirm true labour so don''t be afraid to contact them to be sure.*From Mobile Midwife*@@',191,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (611,0,'2010-04-30 00:00:00','TEXT','Baby is about the size of a medium grasscutter now&is practicing breathing&has hair now.Labour time is coming soon&when U go into labour it is very important to contact your midwife straight.Every labour is different.U need to be sure U call the midwife so any problem can be solved right away.Signs of true labour include,contractions,pain,show&breaking of waters.Midwife can confirm true labour so don''t be afraid to contact them to be sure.*From Mobile Midwife*##',191,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (612,0,'2010-04-30 00:00:00','TEXT','Long labour can mean many things-but not that U have been cheating on your husband.Midwives can help if there are problems.Long labour can be because the cord is around baby''s neck or baby is too big to pass through hip bones.Waiting at home can cause death to mother or baby,urine disease,leg problems or tearing of womb.Remember the sun must not set on any labour twice.Seek medical help as soon as labour starts for healthy mum&baby.*From Mobile Midwife*',192,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (613,0,'2010-04-30 00:00:00','TEXT','Long labour can mean many things-but not that U have been cheating on your husband.Midwives can help if there are problems.Long labour can be because the cord is around baby''s neck or baby is too big to pass through hip bones.Waiting at home can cause death to mother or baby,urine disease,leg problems or tearing of womb.Remember the sun must not set on any labour twice.Seek medical help as soon as labour starts for healthy mum&baby.*From Mobile Midwife*@@',192,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (614,0,'2010-04-30 00:00:00','TEXT','Long labour can mean many things-but not that U have been cheating on your husband.Midwives can help if there are problems.Long labour can be because the cord is around baby''s neck or baby is too big to pass through hip bones.Waiting at home can cause death to mother or baby,urine disease,leg problems or tearing of womb.Remember the sun must not set on any labour twice.Seek medical help as soon as labour starts for healthy mum&baby.*From Mobile Midwife*##',192,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (615,0,'2010-04-30 00:00:00','TEXT','Message for MEN!Your baby is nearly here!The BEST gift U can give your baby is to take your lady to a health facility to deliver.This means that healthworkers can deal with any emergencies&make sure your lady&baby get the best care.Delivering in a facility saves lives&brings better health.If U cannot get to the facility,make sure U can call a midwife to ask her to come to your place to help delivery in an emergency.*From Mobile Midwife*',193,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (616,0,'2010-04-30 00:00:00','TEXT','Message for MEN!Your baby is nearly here!The BEST gift U can give your baby is to take your lady to a health facility to deliver.This means that healthworkers can deal with any emergencies&make sure your lady&baby get the best care.Delivering in a facility saves lives&brings better health.If U cannot get to the facility,make sure U can call a midwife to ask her to come to your place to help delivery in an emergency.*From Mobile Midwife*@@',193,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (617,0,'2010-04-30 00:00:00','TEXT','Message for MEN!Your baby is nearly here!The BEST gift U can give your baby is to take your lady to a health facility to deliver.This means that healthworkers can deal with any emergencies&make sure your lady&baby get the best care.Delivering in a facility saves lives&brings better health.If U cannot get to the facility,make sure U can call a midwife to ask her to come to your place to help delivery in an emergency.*From Mobile Midwife*##',193,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (618,0,'2010-04-30 00:00:00','TEXT','First breastmilk is called colostrum-a thick yellowish fluid,rich in protien,antibodies&other infection fighting things.Its not dirty.Its the best milk for baby.Later breastmilk comes bluish-white&more watery.Newborns eat 8-12 times or more through 1day&night.Feeding often helps U increase milk production.Start feeding on 1 breast til baby stops or breast is empty then move to other breast.Baby needs nothing but breastmilk for first 6months.*From Mobile Midwife*',194,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (619,0,'2010-04-30 00:00:00','TEXT','First breastmilk is called colostrum-a thick yellowish fluid,rich in protien,antibodies&other infection fighting things.Its not dirty.Its the best milk for baby.Later breastmilk comes bluish-white&more watery.Newborns eat 8-12 times or more through 1day&night.Feeding often helps U increase milk production.Start feeding on 1 breast til baby stops or breast is empty then move to other breast.Baby needs nothing but breastmilk for first 6months.*From Mobile Midwife*@@',194,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (620,0,'2010-04-30 00:00:00','TEXT','First breastmilk is called colostrum-a thick yellowish fluid,rich in protien,antibodies&other infection fighting things.Its not dirty.Its the best milk for baby.Later breastmilk comes bluish-white&more watery.Newborns eat 8-12 times or more through 1day&night.Feeding often helps U increase milk production.Start feeding on 1 breast til baby stops or breast is empty then move to other breast.Baby needs nothing but breastmilk for first 6months.*From Mobile Midwife*##',194,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (621,0,'2010-04-30 00:00:00','TEXT','Blood pressure checks thru pregnancy are important.High pressure can be pre-eclampsia,a serious condition that reduces blood flow to baby.Blood carries oxygen&food to baby&proper flow is important for baby''s health.If your pressure stays high U need urine test to check for pre-eclampsia.Signs of pre-eclampsia are:high blood pressure,swelling of hands&face,headaches,dizziness.Go to clinic for regular checks to make sure U&baby are healthy.*From Mobile Midwife*',195,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (622,0,'2010-04-30 00:00:00','TEXT','Blood pressure checks thru pregnancy are important.High pressure can be pre-eclampsia,a serious condition that reduces blood flow to baby.Blood carries oxygen&food to baby&proper flow is important for baby''s health.If your pressure stays high U need urine test to check for pre-eclampsia.Signs of pre-eclampsia are:high blood pressure,swelling of hands&face,headaches,dizziness.Go to clinic for regular checks to make sure U&baby are healthy.*From Mobile Midwife*@@',195,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (623,0,'2010-04-30 00:00:00','TEXT','Blood pressure checks thru pregnancy are important.High pressure can be pre-eclampsia,a serious condition that reduces blood flow to baby.Blood carries oxygen&food to baby&proper flow is important for baby''s health.If your pressure stays high U need urine test to check for pre-eclampsia.Signs of pre-eclampsia are:high blood pressure,swelling of hands&face,headaches,dizziness.Go to clinic for regular checks to make sure U&baby are healthy.*From Mobile Midwife*##',195,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (624,0,'2010-04-30 00:00:00','TEXT','If baby is not in good position for normal delivery an operation may be planned.If U have had surgery on the womb before or have medical conditions doctor may recommend an operation.If during labour there are problems doctor may also tell U that U need operation.Reasons can be irregular heartbeat,problem with cord,risk of bleeding or baby not moving down birth canal.If U need operation try not to worry-it is done to save U&baby''s life.*From Mobile Midwife*',196,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (625,0,'2010-04-30 00:00:00','TEXT','If baby is not in good position for normal delivery an operation may be planned.If U have had surgery on the womb before or have medical conditions doctor may recommend an operation.If during labour there are problems doctor may also tell U that U need operation.Reasons can be irregular heartbeat,problem with cord,risk of bleeding or baby not moving down birth canal.If U need operation try not to worry-it is done to save U&baby''s life.*From Mobile Midwife*@@',196,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (626,0,'2010-04-30 00:00:00','TEXT','If baby is not in good position for normal delivery an operation may be planned.If U have had surgery on the womb before or have medical conditions doctor may recommend an operation.If during labour there are problems doctor may also tell U that U need operation.Reasons can be irregular heartbeat,problem with cord,risk of bleeding or baby not moving down birth canal.If U need operation try not to worry-it is done to save U&baby''s life.*From Mobile Midwife*##',196,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (627,0,'2010-04-30 00:00:00','TEXT','Your baby is almost ready for the world now.Well Done!The BEST thing you can do for U&your baby is DELIVER AT A HEALTH FACILITY.Health workers can help deal with any emergencies that come up&make sure that your baby gets the best care in his/her first few minutes in this world.Give your baby the best start in life!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',197,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (628,0,'2010-04-30 00:00:00','TEXT','Your baby is almost ready for the world now.Well Done!The BEST thing you can do for U&your baby is DELIVER AT A HEALTH FACILITY.Health workers can help deal with any emergencies that come up&make sure that your baby gets the best care in his/her first few minutes in this world.Give your baby the best start in life!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*@@',197,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (629,0,'2010-04-30 00:00:00','TEXT','Your baby is almost ready for the world now.Well Done!The BEST thing you can do for U&your baby is DELIVER AT A HEALTH FACILITY.Health workers can help deal with any emergencies that come up&make sure that your baby gets the best care in his/her first few minutes in this world.Give your baby the best start in life!*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*##',197,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (630,0,'2010-04-30 00:00:00','TEXT','After birthing U need to visit clinic 3 times in 2 days.It is important to be sure U&baby are healthy.Going to clinic makes sure any problems are managed before its too late.Midwife will talk about breastfeeding,bathing baby,cord care&when to bring your newborn to doctor for early treatment if sick.Baby will get 2 jabs to prevent sicknesses.Babies born to HIV+mums will start treatment.This all gives baby a healthy start at life.*From Mobile Midwife*',198,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (631,0,'2010-04-30 00:00:00','TEXT','After birthing U need to visit clinic 3 times in 2 days.It is important to be sure U&baby are healthy.Going to clinic makes sure any problems are managed before its too late.Midwife will talk about breastfeeding,bathing baby,cord care&when to bring your newborn to doctor for early treatment if sick.Baby will get 2 jabs to prevent sicknesses.Babies born to HIV+mums will start treatment.This all gives baby a healthy start at life.*From Mobile Midwife*@@',198,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (632,0,'2010-04-30 00:00:00','TEXT','After birthing U need to visit clinic 3 times in 2 days.It is important to be sure U&baby are healthy.Going to clinic makes sure any problems are managed before its too late.Midwife will talk about breastfeeding,bathing baby,cord care&when to bring your newborn to doctor for early treatment if sick.Baby will get 2 jabs to prevent sicknesses.Babies born to HIV+mums will start treatment.This all gives baby a healthy start at life.*From Mobile Midwife*##',198,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (633,0,'2010-04-30 00:00:00','TEXT','Immunization gives the body protection from certain diseases.An immunization tells body to make soliders that fight off disease.The diseases we can prevent are the 9childhood killer diseases:polio,tuberculosis,diptheria,whooping cough,measles,yellow fever,Hepatitis B,influenza&tetanus.Baby will need some of these immunizations at birth&more later.Ask doctor if U have questions.They help make sure your baby has the best chance at life.*From Mobile Midwife*',199,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (634,0,'2010-04-30 00:00:00','TEXT','Immunization gives the body protection from certain diseases.An immunization tells body to make soliders that fight off disease.The diseases we can prevent are the 9childhood killer diseases:polio,tuberculosis,diptheria,whooping cough,measles,yellow fever,Hepatitis B,influenza&tetanus.Baby will need some of these immunizations at birth&more later.Ask doctor if U have questions.They help make sure your baby has the best chance at life.*From Mobile Midwife*@@',199,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (635,0,'2010-04-30 00:00:00','TEXT','Immunization gives the body protection from certain diseases.An immunization tells body to make soliders that fight off disease.The diseases we can prevent are the 9childhood killer diseases:polio,tuberculosis,diptheria,whooping cough,measles,yellow fever,Hepatitis B,influenza&tetanus.Baby will need some of these immunizations at birth&more later.Ask doctor if U have questions.They help make sure your baby has the best chance at life.*From Mobile Midwife*##',199,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (636,0,'2010-04-30 00:00:00','TEXT','Babies who are breastfed are healthier&better nourished than those given other drinks&food.Baby needs no other food or drink for first 6 months of life.Breastmilk alone meets all their needs including water.Right position for breastfeeding is:baby''s body is turned to face mum belly to belly.Baby''s chin touchs mum''s breast,more of dark skin around mum''s nipple is seen above baby''s mouth than below,baby takes long deep sucks&mum has no pain.*From Mobile Midwife*',200,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (637,0,'2010-04-30 00:00:00','TEXT','Babies who are breastfed are healthier&better nourished than those given other drinks&food.Baby needs no other food or drink for first 6 months of life.Breastmilk alone meets all their needs including water.Right position for breastfeeding is:baby''s body is turned to face mum belly to belly.Baby''s chin touchs mum''s breast,more of dark skin around mum''s nipple is seen above baby''s mouth than below,baby takes long deep sucks&mum has no pain.*From Mobile Midwife*@@',200,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (638,0,'2010-04-30 00:00:00','TEXT','Babies who are breastfed are healthier&better nourished than those given other drinks&food.Baby needs no other food or drink for first 6 months of life.Breastmilk alone meets all their needs including water.Right position for breastfeeding is:baby''s body is turned to face mum belly to belly.Baby''s chin touchs mum''s breast,more of dark skin around mum''s nipple is seen above baby''s mouth than below,baby takes long deep sucks&mum has no pain.*From Mobile Midwife*##',200,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (639,0,'2010-04-30 00:00:00','TEXT','Newborns'' eyes are delicate&need good care.At birth eyes are checked for problems&some antibiotic may be put in eyes by nurse.If baby''s eyes are running water or have other discharge see doctor before trying traditional remedies like breastmilk.Clean eyes gently with small clean water on cotton wool wiping from inside corner near nose to outside corner.Look for yellowing of the white part of eye.If seen go to midwife to be sure all is well.*From Mobile Midwife*',201,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (640,0,'2010-04-30 00:00:00','TEXT','Newborns'' eyes are delicate&need good care.At birth eyes are checked for problems&some antibiotic may be put in eyes by nurse.If baby''s eyes are running water or have other discharge see doctor before trying traditional remedies like breastmilk.Clean eyes gently with small clean water on cotton wool wiping from inside corner near nose to outside corner.Look for yellowing of the white part of eye.If seen go to midwife to be sure all is well.*From Mobile Midwife*@@',201,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (641,0,'2010-04-30 00:00:00','TEXT','Newborns'' eyes are delicate&need good care.At birth eyes are checked for problems&some antibiotic may be put in eyes by nurse.If baby''s eyes are running water or have other discharge see doctor before trying traditional remedies like breastmilk.Clean eyes gently with small clean water on cotton wool wiping from inside corner near nose to outside corner.Look for yellowing of the white part of eye.If seen go to midwife to be sure all is well.*From Mobile Midwife*##',201,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (642,0,'2010-04-30 00:00:00','TEXT','Right now your body needs iron to make enough blood for U&baby.Baby will take what it needs from U to be healthy,but if your blood is too low U risk bleeding too much during delivery which is very dangerous.If U are eating plenty of protein like meat,fish,eggs,cowpea&soya beans,U are getting iron&calcium too.If U are not eating these try to add them to meals&add fresh fruit to help your body take in the iron.*From Mobile Midwife*',202,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (643,0,'2010-04-30 00:00:00','TEXT','Right now your body needs iron to make enough blood for U&baby.Baby will take what it needs from U to be healthy,but if your blood is too low U risk bleeding too much during delivery which is very dangerous.If U are eating plenty of protein like meat,fish,eggs,cowpea&soya beans,U are getting iron&calcium too.If U are not eating these try to add them to meals&add fresh fruit to help your body take in the iron.*From Mobile Midwife*@@',202,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (644,0,'2010-04-30 00:00:00','TEXT','Right now your body needs iron to make enough blood for U&baby.Baby will take what it needs from U to be healthy,but if your blood is too low U risk bleeding too much during delivery which is very dangerous.If U are eating plenty of protein like meat,fish,eggs,cowpea&soya beans,U are getting iron&calcium too.If U are not eating these try to add them to meals&add fresh fruit to help your body take in the iron.*From Mobile Midwife*##',202,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (645,0,'2010-04-30 00:00:00','TEXT','Baby can come anytime now!Great!Do U have all U need for delivery packed in a bag?U need baby napkins,cloths,soap,Camel,baby soap,shea butter,Aligudon for baby,towels&Makintosh.Do U have midwife''s phone number?Where are U delivering?How will U get there?If U dont deliver at hospital U must report to clinic as soon as possible after the birth.This is to be sure U&baby have a great start at taking care of yourself&the blessing God has given U.*From Mobile Midwife*',203,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (646,0,'2010-04-30 00:00:00','TEXT','Baby can come anytime now!Great!Do U have all U need for delivery packed in a bag?U need baby napkins,cloths,soap,Camel,baby soap,shea butter,Aligudon for baby,towels&Makintosh.Do U have midwife''s phone number?Where are U delivering?How will U get there?If U dont deliver at hospital U must report to clinic as soon as possible after the birth.This is to be sure U&baby have a great start at taking care of yourself&the blessing God has given U.*From Mobile Midwife*@@',203,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (647,0,'2010-04-30 00:00:00','TEXT','Baby can come anytime now!Great!Do U have all U need for delivery packed in a bag?U need baby napkins,cloths,soap,Camel,baby soap,shea butter,Aligudon for baby,towels&Makintosh.Do U have midwife''s phone number?Where are U delivering?How will U get there?If U dont deliver at hospital U must report to clinic as soon as possible after the birth.This is to be sure U&baby have a great start at taking care of yourself&the blessing God has given U.*From Mobile Midwife*##',203,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (648,0,'2010-04-30 00:00:00','TEXT','When baby arrives remember they can get sick easy.Immunizations are important to protect baby.Visit clinic within 1 day of birth for checkup.Baby will get 2 jabs to protect them.Feed baby only breastmilk.Breastmilk has water so no need to give baby water.Wash hands with soap or ash&water to remove germs,infections&protect from worms.Wash before touching baby,before&after changing baby,toileting,cooking&eating to keep whole family healthy.*From Mobile Midwife*',204,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (649,0,'2010-04-30 00:00:00','TEXT','When baby arrives remember they can get sick easy.Immunizations are important to protect baby.Visit clinic within 1 day of birth for checkup.Baby will get 2 jabs to protect them.Feed baby only breastmilk.Breastmilk has water so no need to give baby water.Wash hands with soap or ash&water to remove germs,infections&protect from worms.Wash before touching baby,before&after changing baby,toileting,cooking&eating to keep whole family healthy.*From Mobile Midwife*@@',204,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (650,0,'2010-04-30 00:00:00','TEXT','When baby arrives remember they can get sick easy.Immunizations are important to protect baby.Visit clinic within 1 day of birth for checkup.Baby will get 2 jabs to protect them.Feed baby only breastmilk.Breastmilk has water so no need to give baby water.Wash hands with soap or ash&water to remove germs,infections&protect from worms.Wash before touching baby,before&after changing baby,toileting,cooking&eating to keep whole family healthy.*From Mobile Midwife*##',204,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (651,0,'2010-04-30 00:00:00','TEXT','The soft spot on baby''s head is called Fontanel.Its where baby''s head bones are not yet sealed together,giving baby''s brain room to grow.It is normal&important.Its not an ulcer&doesn''t need compresses or herbal medications-these can harm baby''s brain development.Spot should be flat or raised small when you feel it.If sunk down baby is not well&must see doctor straight.By 6months spot will start to close&baby''s head will shape itself.*From Mobile Midwife*',205,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (652,0,'2010-04-30 00:00:00','TEXT','The soft spot on baby''s head is called Fontanel.Its where baby''s head bones are not yet sealed together,giving baby''s brain room to grow.It is normal&important.Its not an ulcer&doesn''t need compresses or herbal medications-these can harm baby''s brain development.Spot should be flat or raised small when you feel it.If sunk down baby is not well&must see doctor straight.By 6months spot will start to close&baby''s head will shape itself.*From Mobile Midwife*@@',205,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (653,0,'2010-04-30 00:00:00','TEXT','The soft spot on baby''s head is called Fontanel.Its where baby''s head bones are not yet sealed together,giving baby''s brain room to grow.It is normal&important.Its not an ulcer&doesn''t need compresses or herbal medications-these can harm baby''s brain development.Spot should be flat or raised small when you feel it.If sunk down baby is not well&must see doctor straight.By 6months spot will start to close&baby''s head will shape itself.*From Mobile Midwife*##',205,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (654,0,'2010-04-30 00:00:00','TEXT','If baby has arrived,congrats!!If not it will be here soon.Be ready to go to health facility as soon as labour starts-delivering there is safer for mum&baby.When baby is born take baby to clinic within 1 day of birth for check by nurse.Also take baby to facility STRAIGHT if they have fever,high temperature,trouble breathing,if baby is not sucking as before,wont feed,not crying or weak&limp.Ask a doctor for help before its too late*From Mobile Midwife*',206,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (655,0,'2010-04-30 00:00:00','TEXT','If baby has arrived,congrats!!If not it will be here soon.Be ready to go to health facility as soon as labour starts-delivering there is safer for mum&baby.When baby is born take baby to clinic within 1 day of birth for check by nurse.Also take baby to facility STRAIGHT if they have fever,high temperature,trouble breathing,if baby is not sucking as before,wont feed,not crying or weak&limp.Ask a doctor for help before its too late*From Mobile Midwife*@@',206,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (656,0,'2010-04-30 00:00:00','TEXT','If baby has arrived,congrats!!If not it will be here soon.Be ready to go to health facility as soon as labour starts-delivering there is safer for mum&baby.When baby is born take baby to clinic within 1 day of birth for check by nurse.Also take baby to facility STRAIGHT if they have fever,high temperature,trouble breathing,if baby is not sucking as before,wont feed,not crying or weak&limp.Ask a doctor for help before its too late*From Mobile Midwife*##',206,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (657,0,'2010-04-30 00:00:00','TEXT','Labour is hard work for the body&U will need strength.In early labour,try having something to eat&drink to keep U strong.Once labour is under way,U may have ice blocks,sips of water or drinks other than minerals.Moving about&gentle walking may help ease pain&help labour along.Remember to call midwife as soon as labour starts.Don''t wait at home.Its dangerous for U&baby.Remember,the sun should not rise or set twice on a woman in labour.*From Mobile Midwife*',207,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (658,0,'2010-04-30 00:00:00','TEXT','Labour is hard work for the body&U will need strength.In early labour,try having something to eat&drink to keep U strong.Once labour is under way,U may have ice blocks,sips of water or drinks other than minerals.Moving about&gentle walking may help ease pain&help labour along.Remember to call midwife as soon as labour starts.Don''t wait at home.Its dangerous for U&baby.Remember,the sun should not rise or set twice on a woman in labour.*From Mobile Midwife*@@',207,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (659,0,'2010-04-30 00:00:00','TEXT','Labour is hard work for the body&U will need strength.In early labour,try having something to eat&drink to keep U strong.Once labour is under way,U may have ice blocks,sips of water or drinks other than minerals.Moving about&gentle walking may help ease pain&help labour along.Remember to call midwife as soon as labour starts.Don''t wait at home.Its dangerous for U&baby.Remember,the sun should not rise or set twice on a woman in labour.*From Mobile Midwife*##',207,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (660,0,'2010-04-30 00:00:00','TEXT','At birth baby is weighed,measured&checked head to toe to be sure he/she is healthy.If baby is small they will need to be kept warm.Best way to do this is place baby wearing only a napkin between your breasts&tie with a cloth just as if baby was on your back.Carry baby close like this as much as U can.It is nice for U both.Don''t bath small babies-just clean quick with warm wet cloth.Plenty shea butter rubbed on baby also helps keep them warm.*From Mobile Midwife*',208,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (661,0,'2010-04-30 00:00:00','TEXT','At birth baby is weighed,measured&checked head to toe to be sure he/she is healthy.If baby is small they will need to be kept warm.Best way to do this is place baby wearing only a napkin between your breasts&tie with a cloth just as if baby was on your back.Carry baby close like this as much as U can.It is nice for U both.Don''t bath small babies-just clean quick with warm wet cloth.Plenty shea butter rubbed on baby also helps keep them warm.*From Mobile Midwife*@@',208,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (662,0,'2010-04-30 00:00:00','TEXT','At birth baby is weighed,measured&checked head to toe to be sure he/she is healthy.If baby is small they will need to be kept warm.Best way to do this is place baby wearing only a napkin between your breasts&tie with a cloth just as if baby was on your back.Carry baby close like this as much as U can.It is nice for U both.Don''t bath small babies-just clean quick with warm wet cloth.Plenty shea butter rubbed on baby also helps keep them warm.*From Mobile Midwife*##',208,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (663,0,'2010-04-30 00:00:00','TEXT','If baby hasn''t arrived yet,don''t worry but go to ANC to be sure all is fine.If U have delivered,congrats!!If baby was born outside hospital its very important U&baby visit clinic for checkup before 1day passes.It is to make sure U&baby are fine.Baby gets immunizations to protect from TB&Polio,so they can grow healthy&strong.U can also ask questions U have about baby''s care&health.*From Mobile Midwife*',209,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (664,0,'2010-04-30 00:00:00','TEXT','If baby hasn''t arrived yet,don''t worry but go to ANC to be sure all is fine.If U have delivered,congrats!!If baby was born outside hospital its very important U&baby visit clinic for checkup before 1day passes.It is to make sure U&baby are fine.Baby gets immunizations to protect from TB&Polio,so they can grow healthy&strong.U can also ask questions U have about baby''s care&health.*From Mobile Midwife*@@',209,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (665,0,'2010-04-30 00:00:00','TEXT','If baby hasn''t arrived yet,don''t worry but go to ANC to be sure all is fine.If U have delivered,congrats!!If baby was born outside hospital its very important U&baby visit clinic for checkup before 1day passes.It is to make sure U&baby are fine.Baby gets immunizations to protect from TB&Polio,so they can grow healthy&strong.U can also ask questions U have about baby''s care&health.*From Mobile Midwife*##',209,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (666,0,'2010-04-30 00:00:00','TEXT','All women bleed after delivery.For 2days flow can be heavy,but then balance like a normal period.If heavy after 2days see midwife straight.Color will change from bright red to pink then yellow-white.U can bleed 2-6weeks after birth,but red blood should not last more than 2weeks.Blood should not smell bad.If smells bad it can be infection which needs medical treatment.See midwife before trying traditonal rememdies-they can make things worse.*From Mobile Midwife*',210,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (667,0,'2010-04-30 00:00:00','TEXT','All women bleed after delivery.For 2days flow can be heavy,but then balance like a normal period.If heavy after 2days see midwife straight.Color will change from bright red to pink then yellow-white.U can bleed 2-6weeks after birth,but red blood should not last more than 2weeks.Blood should not smell bad.If smells bad it can be infection which needs medical treatment.See midwife before trying traditonal rememdies-they can make things worse.*From Mobile Midwife*@@',210,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (668,0,'2010-04-30 00:00:00','TEXT','All women bleed after delivery.For 2days flow can be heavy,but then balance like a normal period.If heavy after 2days see midwife straight.Color will change from bright red to pink then yellow-white.U can bleed 2-6weeks after birth,but red blood should not last more than 2weeks.Blood should not smell bad.If smells bad it can be infection which needs medical treatment.See midwife before trying traditonal rememdies-they can make things worse.*From Mobile Midwife*##',210,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (669,0,'2010-04-30 00:00:00','TEXT','Because of blood lost during delivery its common for mothers to become anemic or have very low blood levels.To help build blood back up,U will be given one tablet of vitamin A immediately after delivery.On first clinic visit,no more than a day after birthing,you will take another Vitamin A capsule.Its important to help U regain strength.Remember to ask for second capsule if U haven''t taken it at hospital.*From Mobile Midwife*',211,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (670,0,'2010-04-30 00:00:00','TEXT','Because of blood lost during delivery its common for mothers to become anemic or have very low blood levels.To help build blood back up,U will be given one tablet of vitamin A immediately after delivery.On first clinic visit,no more than a day after birthing,you will take another Vitamin A capsule.Its important to help U regain strength.Remember to ask for second capsule if U haven''t taken it at hospital.*From Mobile Midwife*@@',211,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (671,0,'2010-04-30 00:00:00','TEXT','Because of blood lost during delivery its common for mothers to become anemic or have very low blood levels.To help build blood back up,U will be given one tablet of vitamin A immediately after delivery.On first clinic visit,no more than a day after birthing,you will take another Vitamin A capsule.Its important to help U regain strength.Remember to ask for second capsule if U haven''t taken it at hospital.*From Mobile Midwife*##',211,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (672,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous for pregnant women&more for new babies.U&baby should sleep under insecticide treated nets.Cover baby''s arms,legs&feet in evening&at dawn.Try burning neem leaves or orange peels to keep mosquitos away or spray rooms.Clearing bushes around house&covering water containers helps too.If baby has fever go to clinic straight for early treatment that can save baby''s life.*From Mobile Midwife*',212,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (673,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous for pregnant women&more for new babies.U&baby should sleep under insecticide treated nets.Cover baby''s arms,legs&feet in evening&at dawn.Try burning neem leaves or orange peels to keep mosquitos away or spray rooms.Clearing bushes around house&covering water containers helps too.If baby has fever go to clinic straight for early treatment that can save baby''s life.*From Mobile Midwife*@@',212,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (674,0,'2010-04-30 00:00:00','TEXT','Malaria is very dangerous for pregnant women&more for new babies.U&baby should sleep under insecticide treated nets.Cover baby''s arms,legs&feet in evening&at dawn.Try burning neem leaves or orange peels to keep mosquitos away or spray rooms.Clearing bushes around house&covering water containers helps too.If baby has fever go to clinic straight for early treatment that can save baby''s life.*From Mobile Midwife*##',212,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (675,0,'2010-04-30 00:00:00','TEXT','After birth it takes time for body to come back to normal.As your body adjusts U may feel after-pains-cramping as womb works to return to normal size.Cramping can be worse when baby breastfeeds but it will soon go,so don''t stop breastfeeding.Pain in private area is normal&should go in a few days.If still painful,itchy or smells bad,see midwife.Back pain,leg pain&headaches are also common but if pain is too much,be safe&visit nearest clinic.*From Mobile Midwife*',213,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (676,0,'2010-04-30 00:00:00','TEXT','After birth it takes time for body to come back to normal.As your body adjusts U may feel after-pains-cramping as womb works to return to normal size.Cramping can be worse when baby breastfeeds but it will soon go,so don''t stop breastfeeding.Pain in private area is normal&should go in a few days.If still painful,itchy or smells bad,see midwife.Back pain,leg pain&headaches are also common but if pain is too much,be safe&visit nearest clinic.*From Mobile Midwife*@@',213,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (677,0,'2010-04-30 00:00:00','TEXT','After birth it takes time for body to come back to normal.As your body adjusts U may feel after-pains-cramping as womb works to return to normal size.Cramping can be worse when baby breastfeeds but it will soon go,so don''t stop breastfeeding.Pain in private area is normal&should go in a few days.If still painful,itchy or smells bad,see midwife.Back pain,leg pain&headaches are also common but if pain is too much,be safe&visit nearest clinic.*From Mobile Midwife*##',213,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (678,0,'2010-04-30 00:00:00','TEXT','Being a new mother is a blessing,but can be very tiring&U may find it hard to cope.It can be normal so try not to worry&try to ask for help from a relative or friend.If U feel very sad or cry a lot it can also be normal as U adjust to it all,but if it is all too much,don''t be afraid to tell your midwife.She will keep it secret&want help U through.Remember a happy,healthy mother makes a happy,healthy baby.Take some time for yourself too.*From Mobile Midwife*',214,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (679,0,'2010-04-30 00:00:00','TEXT','Being a new mother is a blessing,but can be very tiring&U may find it hard to cope.It can be normal so try not to worry&try to ask for help from a relative or friend.If U feel very sad or cry a lot it can also be normal as U adjust to it all,but if it is all too much,don''t be afraid to tell your midwife.She will keep it secret&want help U through.Remember a happy,healthy mother makes a happy,healthy baby.Take some time for yourself too.*From Mobile Midwife*@@',214,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (680,0,'2010-04-30 00:00:00','TEXT','Being a new mother is a blessing,but can be very tiring&U may find it hard to cope.It can be normal so try not to worry&try to ask for help from a relative or friend.If U feel very sad or cry a lot it can also be normal as U adjust to it all,but if it is all too much,don''t be afraid to tell your midwife.She will keep it secret&want help U through.Remember a happy,healthy mother makes a happy,healthy baby.Take some time for yourself too.*From Mobile Midwife*##',214,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (681,0,'2010-04-30 00:00:00','TEXT','If you haven''t delivered yet,make sure U go to clinic to be sure all is fine.Don''t just wait at home.If labour is not coming there may be a problem&your midwife can help.Waiting at home can be dangerous for U&baby.Try not to worry that something is wrong,but at times we need to help nature along&help start your labour.Remember,delivery at a health facility is safer for mother&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',215,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (682,0,'2010-04-30 00:00:00','TEXT','If you haven''t delivered yet,make sure U go to clinic to be sure all is fine.Don''t just wait at home.If labour is not coming there may be a problem&your midwife can help.Waiting at home can be dangerous for U&baby.Try not to worry that something is wrong,but at times we need to help nature along&help start your labour.Remember,delivery at a health facility is safer for mother&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',215,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (683,0,'2010-04-30 00:00:00','TEXT','If you haven''t delivered yet,make sure U go to clinic to be sure all is fine.Don''t just wait at home.If labour is not coming there may be a problem&your midwife can help.Waiting at home can be dangerous for U&baby.Try not to worry that something is wrong,but at times we need to help nature along&help start your labour.Remember,delivery at a health facility is safer for mother&baby.*From Mobile Midwife&Ghana Health Service~Your Health-Our Concern*',215,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (684,0,'2010-04-30 00:00:00','TEXT','If U had a baby boy,congratulations!There are a few special things about boys.Testicles are to come down at birth,if U can''t feel them in the sacks below the penis,report to midwife for help.If U plan to circumcise,please arrange to do it at certified places.This is important to be sure there are no mistakes.If not done properly baby can suffer very dangerous infections,bleeding,or urinary problems.Just be safe for your new little boy.*From Mobile Midwife*',216,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (685,0,'2010-04-30 00:00:00','TEXT','If U had a baby boy,congratulations!There are a few special things about boys.Testicles are to come down at birth,if U can''t feel them in the sacks below the penis,report to midwife for help.If U plan to circumcise,please arrange to do it at certified places.This is important to be sure there are no mistakes.If not done properly baby can suffer very dangerous infections,bleeding,or urinary problems.Just be safe for your new little boy.*From Mobile Midwife*@@',216,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (686,0,'2010-04-30 00:00:00','TEXT','If U had a baby boy,congratulations!There are a few special things about boys.Testicles are to come down at birth,if U can''t feel them in the sacks below the penis,report to midwife for help.If U plan to circumcise,please arrange to do it at certified places.This is important to be sure there are no mistakes.If not done properly baby can suffer very dangerous infections,bleeding,or urinary problems.Just be safe for your new little boy.*From Mobile Midwife*##',216,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (687,0,'2010-04-30 00:00:00','TEXT','Every child born needs to be registered with National Birth&Death Registry.A Birth certificate is a legal document that functions as an eye witness account of the birth of your baby.It is needed for processing several legal documents in life like passport.U can register with representative at hospital or for the community or ask your midwife where to register.Register as soon as child is born.Registration is free.*From Mobile Midwife*',217,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (688,0,'2010-04-30 00:00:00','TEXT','Every child born needs to be registered with National Birth&Death Registry.A Birth certificate is a legal document that functions as an eye witness account of the birth of your baby.It is needed for processing several legal documents in life like passport.U can register with representative at hospital or for the community or ask your midwife where to register.Register as soon as child is born.Registration is free.*From Mobile Midwife*@@',217,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (689,0,'2010-04-30 00:00:00','TEXT','Every child born needs to be registered with National Birth&Death Registry.A Birth certificate is a legal document that functions as an eye witness account of the birth of your baby.It is needed for processing several legal documents in life like passport.U can register with representative at hospital or for the community or ask your midwife where to register.Register as soon as child is born.Registration is free.*From Mobile Midwife*##',217,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (690,0,'2010-04-30 00:00:00','TEXT','We hope you are finding motherhood good&are trying to get some rest.Are U breastfeeding? Do U have painful breasts?Its common as breasts try to make the right amount of milk for baby.Don''t give up,it will soon be easier.Feed baby when they want to eat&they should be feeding at least 10times through a day&night.Don''t be afraid to wake baby for feeding in order to release pressure in your breasts.Breastmilk ALONE is best for a healthy baby.*From Mobile Midwife*',218,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (691,0,'2010-04-30 00:00:00','TEXT','We hope you are finding motherhood good&are trying to get some rest.Are U breastfeeding? Do U have painful breasts?Its common as breasts try to make the right amount of milk for baby.Don''t give up,it will soon be easier.Feed baby when they want to eat&they should be feeding at least 10times through a day&night.Don''t be afraid to wake baby for feeding in order to release pressure in your breasts.Breastmilk ALONE is best for a healthy baby.*From Mobile Midwife*@@',218,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (692,0,'2010-04-30 00:00:00','TEXT','We hope you are finding motherhood good&are trying to get some rest.Are U breastfeeding? Do U have painful breasts?Its common as breasts try to make the right amount of milk for baby.Don''t give up,it will soon be easier.Feed baby when they want to eat&they should be feeding at least 10times through a day&night.Don''t be afraid to wake baby for feeding in order to release pressure in your breasts.Breastmilk ALONE is best for a healthy baby.*From Mobile Midwife*##',218,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (693,0,'2010-04-30 00:00:00','TEXT','Sore nipples with breastfeeding is common.Nipples will get used to feedings&stop paining.To ease pain try to rub a bit of breastmilk on nipples after feeding&let air dry.Make sure your bra is not too tight.Wash nipples with clean water only,no soap or spirit,baby is protected from your germs&your milk is clean.Make sure baby is not sucking nipple only.Baby should have alot of the dark area around the nipple also in their mouth.*From Mobile Midwife*',219,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (694,0,'2010-04-30 00:00:00','TEXT','Sore nipples with breastfeeding is common.Nipples will get used to feedings&stop paining.To ease pain try to rub a bit of breastmilk on nipples after feeding&let air dry.Make sure your bra is not too tight.Wash nipples with clean water only,no soap or spirit,baby is protected from your germs&your milk is clean.Make sure baby is not sucking nipple only.Baby should have alot of the dark area around the nipple also in their mouth.*From Mobile Midwife*@@',219,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (695,0,'2010-04-30 00:00:00','TEXT','Sore nipples with breastfeeding is common.Nipples will get used to feedings&stop paining.To ease pain try to rub a bit of breastmilk on nipples after feeding&let air dry.Make sure your bra is not too tight.Wash nipples with clean water only,no soap or spirit,baby is protected from your germs&your milk is clean.Make sure baby is not sucking nipple only.Baby should have alot of the dark area around the nipple also in their mouth.*From Mobile Midwife*##',219,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (696,0,'2010-04-30 00:00:00','TEXT','Taking care of baby''s cord stump is very important to prevent serious infection.Keep stump clean&dry.Don''t apply anything-no ask,glass&not even spirit.It will dry on its own.Make sure baby napkins don''t rub or cover stump.Don''t force it to fall,it will go naturally in 10-21 days.If baby''s stump has discharge or redness take baby to clinic straight.Infections in newborns are very serious&can cause even death.*From Mobile Midwife*',220,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (697,0,'2010-04-30 00:00:00','TEXT','Taking care of baby''s cord stump is very important to prevent serious infection.Keep stump clean&dry.Don''t apply anything-no ask,glass&not even spirit.It will dry on its own.Make sure baby napkins don''t rub or cover stump.Don''t force it to fall,it will go naturally in 10-21 days.If baby''s stump has discharge or redness take baby to clinic straight.Infections in newborns are very serious&can cause even death.*From Mobile Midwife*@@',220,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (698,0,'2010-04-30 00:00:00','TEXT','Taking care of baby''s cord stump is very important to prevent serious infection.Keep stump clean&dry.Don''t apply anything-no ask,glass&not even spirit.It will dry on its own.Make sure baby napkins don''t rub or cover stump.Don''t force it to fall,it will go naturally in 10-21 days.If baby''s stump has discharge or redness take baby to clinic straight.Infections in newborns are very serious&can cause even death.*From Mobile Midwife*##',220,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (699,0,'2010-04-30 00:00:00','TEXT','Newborns only need a few things to be happy.Food,love,sleep&a clean nappy.Changing baby''s nappy often is important-bacteria in urine&faeces can make skin sore&give rashes.This happens very quick in warm weather.Expect to change nappy before or after every feed.This should every 1-3hrs.Baby is well fed if you change 6-10 nappies/day.Clean baby''s buttocks with soft,damp,clean cloth&be sure to wash hands with soap after every change*From Mobile Midwife*',221,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (700,0,'2010-04-30 00:00:00','TEXT','Newborns only need a few things to be happy.Food,love,sleep&a clean nappy.Changing baby''s nappy often is important-bacteria in urine&faeces can make skin sore&give rashes.This happens very quick in warm weather.Expect to change nappy before or after every feed.This should every 1-3hrs.Baby is well fed if you change 6-10 nappies/day.Clean baby''s buttocks with soft,damp,clean cloth&be sure to wash hands with soap after every change*From Mobile Midwife*@@',221,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (701,0,'2010-04-30 00:00:00','TEXT','Newborns only need a few things to be happy.Food,love,sleep&a clean nappy.Changing baby''s nappy often is important-bacteria in urine&faeces can make skin sore&give rashes.This happens very quick in warm weather.Expect to change nappy before or after every feed.This should every 1-3hrs.Baby is well fed if you change 6-10 nappies/day.Clean baby''s buttocks with soft,damp,clean cloth&be sure to wash hands with soap after every change*From Mobile Midwife*##',221,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (702,0,'2010-04-30 00:00:00','TEXT','Babies grow very fast.By the end of first month baby should be able to lift his head small when lying flat on their belly.Baby can focus on your face when U watch them but they cant see very far so keep your face close to theirs so they can see you.Remember if baby is weak or limp,or not making at least 6-8 wet nappies in a day,report to clinic.Try not to let anyone tell U to give baby anything except breastmilk.It can cause serious problems*From Mobile Midwife*',222,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (703,0,'2010-04-30 00:00:00','TEXT','Babies grow very fast.By the end of first month baby should be able to lift his head small when lying flat on their belly.Baby can focus on your face when U watch them but they cant see very far so keep your face close to theirs so they can see you.Remember if baby is weak or limp,or not making at least 6-8 wet nappies in a day,report to clinic.Try not to let anyone tell U to give baby anything except breastmilk.It can cause serious problems*From Mobile Midwife*@@',222,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (704,0,'2010-04-30 00:00:00','TEXT','Babies grow very fast.By the end of first month baby should be able to lift his head small when lying flat on their belly.Baby can focus on your face when U watch them but they cant see very far so keep your face close to theirs so they can see you.Remember if baby is weak or limp,or not making at least 6-8 wet nappies in a day,report to clinic.Try not to let anyone tell U to give baby anything except breastmilk.It can cause serious problems*From Mobile Midwife*##',222,3);

insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (705,0,'2010-04-30 00:00:00','TEXT','Babies cry alot.Crying is how they tell U they need something.Its not a curse,but normal.Most common reason baby cries is hunger so breastfeeding may quiet them.Babies should not have ANY food or water-just breastmilk.Babies cry when nappy is wet.They cry when bathing or changing so be quick.Some babies like to be held&cuddled more than others-holding newborns makes them feel safe as they get used to the outside world.*From Mobile Midwife*',223,1);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (706,0,'2010-04-30 00:00:00','TEXT','Babies cry alot.Crying is how they tell U they need something.Its not a curse,but normal.Most common reason baby cries is hunger so breastfeeding may quiet them.Babies should not have ANY food or water-just breastmilk.Babies cry when nappy is wet.They cry when bathing or changing so be quick.Some babies like to be held&cuddled more than others-holding newborns makes them feel safe as they get used to the outside world.*From Mobile Midwife*@@',223,2);
insert into `message_template` (`id`,`obj_vesion`,`date_created`,`message_type`,`template`,`notification_type`,`language`) values (707,0,'2010-04-30 00:00:00','TEXT','Babies cry alot.Crying is how they tell U they need something.Its not a curse,but normal.Most common reason baby cries is hunger so breastfeeding may quiet them.Babies should not have ANY food or water-just breastmilk.Babies cry when nappy is wet.They cry when bathing or changing so be quick.Some babies like to be held&cuddled more than others-holding newborns makes them feel safe as they get used to the outside world.*From Mobile Midwife*##',223,3);





/*Table structure for table `notification_type` */

DROP TABLE IF EXISTS `notification_type`;

CREATE TABLE `notification_type` (
  `id` bigint(20) NOT NULL,
  `name` varchar(45) DEFAULT NULL,
  `description` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `notification_type` */

insert into `notification_type` (`id`,`name`,`description`) values (2,'Min-by-min test ','First informational message sent at min 1');
insert into `notification_type` (`id`,`name`,`description`) values (3,'Min-by-min test ','Second informational message sent at min 2');
insert into `notification_type` (`id`,`name`,`description`) values (4,'Min-by-min test ','Prompt for tetanus dose 1  sent at min 3');
insert into `notification_type` (`id`,`name`,`description`) values (5,'Min-by-min test ','Third informational message sent at min 5');
insert into `notification_type` (`id`,`name`,`description`) values (6,'Min-by-min test ','Fourth informational message sent at min 6');
insert into `notification_type` (`id`,`name`,`description`) values (7,'Min-by-min test ','Reminder for missed tetanus 1 sent at min 6 (if missed)');
insert into `notification_type` (`id`,`name`,`description`) values (8,'Min-by-min test ','Second reminder for missed tetanus 1 sent at min 8 (if missed)');
insert into `notification_type` (`id`,`name`,`description`) values (9,'Min-by-min test ','Prompt for tetanus 2');
insert into `notification_type` (`id`,`name`,`description`) values (10,'Min-by-min test ','Reminder for missed tetanus dose 2');
insert into `notification_type` (`id`,`name`,`description`) values (11,'Min-by-min test ','Second reminder for missed tetanus dose 2');

insert into `notification_type` (`id`,`name`,`description`) values (14,'Week-by-week','week1 message');
insert into `notification_type` (`id`,`name`,`description`) values (15,'Week-by-week','week 2 message');
insert into `notification_type` (`id`,`name`,`description`) values (16,'Week-by-week','week 3 message');
insert into `notification_type` (`id`,`name`,`description`) values (17,'Week-by-week','week 4 message');
insert into `notification_type` (`id`,`name`,`description`) values (18,'Week-by-week','week 5 ');
insert into `notification_type` (`id`,`name`,`description`) values (19,'Week-by-week','week 6');
insert into `notification_type` (`id`,`name`,`description`) values (20,'Week-by-week','week 7 ');
insert into `notification_type` (`id`,`name`,`description`) values (21,'Week-by-week','week 8 ');
insert into `notification_type` (`id`,`name`,`description`) values (22,'Week-by-week','week 9 ');
insert into `notification_type` (`id`,`name`,`description`) values (23,'Week-by-week','week 10 ');
insert into `notification_type` (`id`,`name`,`description`) values (24,'Week-by-week','week 11 ');
insert into `notification_type` (`id`,`name`,`description`) values (25,'Week-by-week','week 12 ');
insert into `notification_type` (`id`,`name`,`description`) values (26,'Week-by-week','week 13 ');
insert into `notification_type` (`id`,`name`,`description`) values (27,'Week-by-week','week 14 ');
insert into `notification_type` (`id`,`name`,`description`) values (28,'Week-by-week','week 15 ');
insert into `notification_type` (`id`,`name`,`description`) values (29,'Week-by-week','week 16 ');
insert into `notification_type` (`id`,`name`,`description`) values (30,'Week-by-week','week 17 ');
insert into `notification_type` (`id`,`name`,`description`) values (31,'Week-by-week','week 18 ');
insert into `notification_type` (`id`,`name`,`description`) values (32,'Week-by-week','week 19 ');
insert into `notification_type` (`id`,`name`,`description`) values (33,'Week-by-week','week 20 ');
insert into `notification_type` (`id`,`name`,`description`) values (34,'Week-by-week','week 21 ');
insert into `notification_type` (`id`,`name`,`description`) values (35,'Week-by-week','week 22 ');
insert into `notification_type` (`id`,`name`,`description`) values (36,'Week-by-week','week 23 ');
insert into `notification_type` (`id`,`name`,`description`) values (37,'Week-by-week','week 24 ');
insert into `notification_type` (`id`,`name`,`description`) values (38,'Week-by-week','week 25 ');
insert into `notification_type` (`id`,`name`,`description`) values (39,'Week-by-week','week 26 ');
insert into `notification_type` (`id`,`name`,`description`) values (40,'Week-by-week','week 27 ');
insert into `notification_type` (`id`,`name`,`description`) values (41,'Week-by-week','week 28 ');
insert into `notification_type` (`id`,`name`,`description`) values (42,'Week-by-week','week 29 ');
insert into `notification_type` (`id`,`name`,`description`) values (43,'Week-by-week','week 30 ');
insert into `notification_type` (`id`,`name`,`description`) values (44,'Week-by-week','week 31 ');
insert into `notification_type` (`id`,`name`,`description`) values (45,'Week-by-week','week 32 ');
insert into `notification_type` (`id`,`name`,`description`) values (46,'Week-by-week','week 33 ');
insert into `notification_type` (`id`,`name`,`description`) values (47,'Week-by-week','week 34 ');
insert into `notification_type` (`id`,`name`,`description`) values (48,'Week-by-week','week 35 ');
insert into `notification_type` (`id`,`name`,`description`) values (49,'Week-by-week','week 36 ');
insert into `notification_type` (`id`,`name`,`description`) values (50,'Week-by-week','week 37 ');
insert into `notification_type` (`id`,`name`,`description`) values (51,'Week-by-week','week 38 ');
insert into `notification_type` (`id`,`name`,`description`) values (52,'Week-by-week','week 39 ');
insert into `notification_type` (`id`,`name`,`description`) values (53,'Week-by-week','week 40 ');
insert into `notification_type` (`id`,`name`,`description`) values (54,'Week-by-week','child week 1 ');
insert into `notification_type` (`id`,`name`,`description`) values (55,'Week-by-week','child week 2 ');
insert into `notification_type` (`id`,`name`,`description`) values (56,'Week-by-week','child week 3 ');
insert into `notification_type` (`id`,`name`,`description`) values (57,'Week-by-week','child week 4 ');

insert into `notification_type` (`id`,`name`,`description`) values (58,'Min-by-min demo ','Demo Message 1');
insert into `notification_type` (`id`,`name`,`description`) values (59,'Min-by-min demo ','Demo Message 2');
insert into `notification_type` (`id`,`name`,`description`) values (60,'Min-by-min demo ','Demo Message 3');
insert into `notification_type` (`id`,`name`,`description`) values (61,'Min-by-min demo ','Demo Message 4');
insert into `notification_type` (`id`,`name`,`description`) values (62,'Min-by-min demo ','Demo Message 5');
insert into `notification_type` (`id`,`name`,`description`) values (63,'Min-by-min demo ','Demo Message 6');
insert into `notification_type` (`id`,`name`,`description`) values (64,'Min-by-min demo ','Demo Message 7');
insert into `notification_type` (`id`,`name`,`description`) values (65,'Min-by-min demo ','Demo Message 8');
insert into `notification_type` (`id`,`name`,`description`) values (66,'Min-by-min demo ','Demo Message 9');
insert into `notification_type` (`id`,`name`,`description`) values (67,'Min-by-min demo ','Demo Message 10');
insert into `notification_type` (`id`,`name`,`description`) values (68,'Min-by-min demo ','Demo Message 11');
insert into `notification_type` (`id`,`name`,`description`) values (69,'Min-by-min demo ','Demo Message 12');
insert into `notification_type` (`id`,`name`,`description`) values (70,'Min-by-min demo ','Demo Message 13');
insert into `notification_type` (`id`,`name`,`description`) values (71,'Min-by-min demo ','Demo Message 14');
insert into `notification_type` (`id`,`name`,`description`) values (72,'Min-by-min demo ','Demo Message 15');
insert into `notification_type` (`id`,`name`,`description`) values (73,'Min-by-min demo ','Demo Message 16');
insert into `notification_type` (`id`,`name`,`description`) values (74,'Min-by-min demo ','Demo Message 17');
insert into `notification_type` (`id`,`name`,`description`) values (75,'Min-by-min demo ','Demo Message 18');
insert into `notification_type` (`id`,`name`,`description`) values (76,'Min-by-min demo ','Demo Message 19');
insert into `notification_type` (`id`,`name`,`description`) values (77,'Min-by-min demo ','Demo Message 20');

/* Notification entries for care messages*/

insert into `notification_type` (`id`,`name`,`description`) values (78,'Care ','Tetanus Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (79,'Care ','Tetanus Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (80,'Care ','IPT Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (81,'Care ','IPT Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (82,'Care ','ANC Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (83,'Care ','ANC Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (84,'Care ','PPC Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (85,'Care ','PPC Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (86,'Care ','PNC Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (87,'Care ','PNC Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (88,'Care ','BCG Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (89,'Care ','BCG Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (90,'Care ','OPV Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (91,'Care ','OPV Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (92,'Care ','Penta Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (93,'Care ','Penta Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (94,'Care ','IPTi Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (95,'Care ','IPTi Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (96,'Care ','Yellow Fever Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (97,'Care ','ellow Fever Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (98,'Care ','Measles Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (99,'Care ','Measles Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (100,'Care ','Vitamin A Upcoming');
insert into `notification_type` (`id`,`name`,`description`) values (101,'Care ','Vitamin A Overdue (Reminder)');
insert into `notification_type` (`id`,`name`,`description`) values (102,'Care ','Delivery notification');
/**/
insert into `notification_type` (`id`,`name`,`description`) values (104,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (105,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (106,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (107,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (108,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (109,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (110,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (111,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (112,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (113,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (114,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (115,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (116,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (117,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (118,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (119,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (120,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (121,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (122,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (123,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (124,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (125,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (126,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (127,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (128,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (129,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (130,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (131,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (132,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (133,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (134,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (135,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (136,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (137,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (138,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (139,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (140,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (141,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (142,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (143,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (144,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (145,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (146,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (147,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (148,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (149,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (150,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (151,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (152,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (153,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (154,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (155,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (156,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (157,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (158,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (159,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (160,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (161,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (162,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (163,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (164,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (165,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (166,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (167,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (168,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (169,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (170,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (171,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (172,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (173,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (174,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (175,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (176,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (177,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (178,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (179,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (180,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (181,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (182,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (183,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (184,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (185,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (186,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (187,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (188,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (189,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (190,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (191,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (192,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (193,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (194,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (195,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (196,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (197,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (198,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (199,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (200,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (201,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (202,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (203,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (204,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (205,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (206,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (207,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (208,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (209,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (210,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (211,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (212,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (213,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (214,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (215,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (216,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (217,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (218,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (219,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (220,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (221,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (222,'Pregnant Parents SMS - 3x per Week ','');
insert into `notification_type` (`id`,`name`,`description`) values (223,'Pregnant Parents SMS - 3x per Week ','');



/*Table structure for table `personalization_info` */

DROP TABLE IF EXISTS `personalization_info`;

CREATE TABLE `personalization_info` (
  `requestId` bigint(20) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  PRIMARY KEY (`requestId`,`name`,`value`),
  KEY `FK7233DE9E60D8876` (`requestId`),
  CONSTRAINT `FK7233DE9E60D8876` FOREIGN KEY (`requestId`) REFERENCES `message_request` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Table structure for table `transition` */

DROP TABLE IF EXISTS `transition`;

CREATE TABLE `transition` (
  `id` bigint(20) NOT NULL,
  `obj_vesion` int(11) NOT NULL DEFAULT '0',
  `transactionType` varchar(255) DEFAULT NULL,
  `transactionDate` datetime DEFAULT NULL,
  `transactionDescription` varchar(255) DEFAULT NULL,
  `gateway_response_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK993B6D552E655D7F` (`gateway_response_id`),
  KEY `FK993B6D553E72B537` (`gateway_response_id`),
  CONSTRAINT `FK993B6D553E72B537` FOREIGN KEY (`gateway_response_id`) REFERENCES `transition` (`id`),
  CONSTRAINT `FK993B6D552E655D7F` FOREIGN KEY (`gateway_response_id`) REFERENCES `gateway_response` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-11-26 21:11:32
